local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("AileronVisceralus", {
  instance = "Datascape",
  groupName = "Elemental Pairs",
  displayName = "Aileron & Visceralus",
  tTrigger = {
    sType = "ALL",
    tNames = {"unit.boss_air", "unit.boss_life"},
    tZones = {
      [1] = {
        continentId = 52,
        parentZoneId = 98,
        mapId = 119,
      },
    },
  },
},{
  ["enUS"] = {
    -- Unit names
    ["unit.boss_air"] = "Aileron",
    ["unit.boss_life"] = "Visceralus",
    ["unit.life_orb"] = "Life Force",
    ["unit.thorns"] = "Wild Brambles",
    ["unit.tornado"] = "[DS] e395 - Air - Tornado",
    ["unit.tree"] = "Lifekeeper",
    -- Casts
    ["cast.blinding"] = "Blinding Light",
    -- Timers
    ["timer.midphase"] = "Next Midphase",
    ["timer.midphase_end"] = "Midphase Ending",
    ["timer.thorns"] = "Next Thorns",
    ["timer.trees"] = "Next Trees",
    ["timer.twirl"] = "Next Twirls",
    -- Alerts
    ["alert.twirl"] = "Twirls!",
    ["alert.twirl_you"] = "Twirl on you!",
    ["alert.lightning_on"] = "Lightning on %s",
    ["alert.lightning_you"] = "Lightning on you!",
    ["alert.no_heals"] = "No-Healing Debuff!",
    -- Labels
    ["label.no_heals"] = "No-Healing Debuff",
    ["label.midphase"] = "Midphase",
    ["label.thorns"] = "Thorns",
    ["label.tree"] = "Tree",
    ["label.orb"] = "Life Orb",
    ["label.lightning"] = "Lightning",
  },
  ["deDE"] = {
    -- Unit names
    ["unit.boss_air"] = "Aileron",
    ["unit.boss_life"] = "Viszeralus",
    ["unit.life_orb"] = "Lebenskraft",
    ["unit.thorns"] = "Wilde Brombeeren",
    ["unit.tornado"] = "[DS] e395 - Air - Tornado", --assumed
    ["unit.tree"] = "Lebensbewahrer",
    -- Casts
    ["cast.blinding"] = "Blendendes Licht",
    -- Timers
    ["timer.midphase"] = "Nächste Mittelphase",
    ["timer.midphase_end"] = "Mittelphase Ended",
    ["timer.thorns"] = "Nächste Dornen",
    ["timer.trees"] = "Nächste Bäume",
    ["timer.twirl"] = "Nächste Wirbel",
    -- Alerts
    ["alert.twirl"] = "Wirbel!",
    ["alert.twirl_you"] = "Wirbel auf dir!",
    ["alert.lightning_on"] = "Blitz auf %s",
    ["alert.lightning_you"] = "Blitz auf dir!",
    ["alert.no_heals"] = "Debuff: Keine Heilung!",
    -- Labels
    ["label.no_heals"] = "Debuff: Keine Heilung",
    ["label.midphase"] = "Mittelphase",
    ["label.thorns"] = "Dornen",
    ["label.tree"] = "Baum",
    ["label.orb"] = "Lebens Orb",
    ["label.lightning"] = "Blitz",
  },
  ["frFR"] = {
    -- Unit names
    ["unit.boss_air"] = "Ventemort",
    ["unit.boss_life"] = "Visceralus",
    ["unit.life_orb"] = "Force vitale",
    ["unit.thorns"] = "Ronces sauvages",
    ["unit.tornado"] = "[DS] e395 - Air - Tornado",
    ["unit.tree"] = "Garde-vie",
    -- Casts
    ["cast.blinding"] = "Lumière aveuglante",
    -- Timers
    ["timer.midphase"] = "Prochaine phase milieu",
    ["timer.midphase_end"] = "Phase Milieu Fin",
    ["timer.thorns"] = "Prochaine épines",
    ["timer.trees"] = "Prochain Arbres à Soigner",
    ["timer.twirl"] = "Next Twirls",
    -- Alerts
    ["alert.twirl"] = "Tournoiement!",
    ["alert.twirl_you"] = "TOURNOIEMENT SUR VOUS!",
    ["alert.lightning_on"] = "Foudre sur %s",
    ["alert.lightning_you"] = "Foudre sur vous!",
    ["alert.no_heals"] = "Aucun-Soin Debuff!",
    -- Labels
    ["label.no_heals"] = "Aucun-Soin Debuff",
    ["label.midphase"] = "Midphase",
    ["label.thorns"] = "Thorns",
    ["label.tree"] = "Tree",
    ["label.orb"] = "Life Orb",
    ["label.lightning"] = "Lightning",
  },
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  BossAir{
    label = "unit.boss_air",
    unit{color = "ff44ffff"},
    line{color = "ff00ff00", thickness = 8},
  }
  BossLife{
    label = "unit.boss_life",
    unit{color = "ff22aa00"},
  }

  Midphase{
    label = "label.midphase",
    timer{color = "xkcdBluePurple"},
  }
  Thorns{
    label = "label.thorns",
    color = "xkcdBluegreen",
    timer{},
    text{},
  }
  Tree{
    label = "label.tree",
    color = "xkcdAvocadoGreen",
    timer{},
    unit{},
    text{},
  }
  Orb{
    label = "label.orb",
    line{color = "ff0000ff"},
  }

  Twirl{
    label = "alert.twirl",
    alert{},
    sound{file = "inferno"},
    icon{sprite = "LUIBM_crosshair", size = 60, color = "ffff0000"},
    aura{label = "alert.twirl_you", sprite = "LUIBM_run", color = "ffff0000"},
    line{color = "ffff0000"},
    timer{color = "xkcdBluegreen"},
  }

  NoHeal{
    label = "label.no_heals",
    color = "ffff00ff",
    icon{sprite = "LUIBM_biohazard", size = 60},
    aura{sprite = "LUIBM_biohazard"},
    alert{},
    sound{sound = "alarm"},
  }

  Lightning{
    label = "label.lightning",
    color = "ff00ffff",
    icon{sprite = "LUIBM_lightning2", size = 60},
    aura{sprite = "LUIBM_lightning2"},
    alert{},
    sound{file = "run-away"},
    line{thickness = 5},
  }

  Blinding{
    label = "cast.blinding",
    alert{},
    sound{file = "beware"},
  }

end, function(_arg, _env, _var) --luacheck: no unused args
  -- luacheck: no global


  Enable{
    Timer("Midphase", 90, "timer.midphase"),
    Timer("Thorns", 15, "timer.thorns"), --this is done by the first thorns aswell (directly at pull)
    Timer("Twirl", 15, "timer.twirl"),
  }

  UnitCreated{ strUnitName = "unit.boss_air",
    Unit("BossAir", _arg.tUnit),
    Line("BossAir", _arg.tUnit, 15),
  }
  UnitCreated{ strUnitName = "unit.boss_life",
    Unit("BossLife", _arg.tUnit),
  }

  _var.nLastThorns = 0
  local nGameTime = _env.GameLib.GetGameTime()
  UnitCreated{ strUnitName = "unit.thorns", [_var.nLastThorns] = {"<", nGameTime-5},
    _var.nLastThorns(nGameTime),
    Timer("Thorns", 15, "timer.thorns"),
    TimerText("Thorns", _arg.self:GetUnit("BossAir"), 15),
  }

  UnitCreated{ strUnitName = "unit.tornado",
    Timer("Midphase", 35, "timer.midphase_end"),
    Timer("Thorns", 35, "timer.thorns"),
    TimerText("Thorns", _arg.self:GetUnit("BossAir"), 35),
    Timer("Tree", 35, "timer.trees"),
  }
  UnitDestroyed{ strUnitName = "unit.tornado",
    Timer("Midphase", 90, "timer.midphase"),
    Timer("Tree", 30, "timer.trees"),
  }

  UnitCreated{ strUnitName = "unit.life_orb",
    LineBetween("Orb", _arg.tUnit, _arg.self:GetUnit("BossLife")) % (_arg.nUnitId),
  }


  local tTreeCache = {} --this will only be populated for about a frame.
  local fSetVal = _arg(function(t,k,v) t[k]=v end)
  _var.tActiveTrees = _arg(function() return {} end)()
  UnitCreated{ strUnitName = "unit.tree",
    _env.table.insert(tTreeCache, _arg.tUnit), --insert in order of appearance.
    fSetVal(_var.tActiveTrees, _arg.nUnitId, _arg.tUnit), --insert by UnitId
    --this is a 0-Second-Delay. Which should trigger after all Unit-Related Events triggered
    Delay("TreeDelay", 0, function(self)
      while #tTreeCache > 1 do
        local tTree1 = table.remove(tTreeCache, 1)
        local tTree2 = table.remove(tTreeCache, 1)

        if not tTree1:IsValid() then
          table.insert(tTreeCache, 1, tTree2)
        elseif not tTree2:IsValid() then
          table.insert(tTreeCache, 1, tTree1)
        else
          local tPos1 = tTree1:GetPosition()
          local tPos2 = tTree2:GetPosition()

          local tNorthTree, tSouthTree = tTree1, tTree2
          if tPos1.z > tPos2.z then --we were wrong with assignment above.
            tNorthTree, tSouthTree = tTree2, tTree1
          end

          local nMarkNorth = self:Count("Trees")
          local nMarkSouth = self:Count("Trees")
          self:Unit("Tree", tNorthTree, nMarkNorth, {strMark = nMarkNorth})
          self:Unit("Tree", tSouthTree, nMarkSouth, {strMark = nMarkSouth})
          self:Text("Tree", tNorthTree, nMarkNorth, nMarkNorth) --unit, text, keyExtension
          self:Text("Tree", tSouthTree, nMarkSouth, nMarkSouth)
        end
      end
    end)
  }

  UnitDestroyed{ strUnitName = "unit.tree",
    fSetVal(_var.tActiveTrees, _arg.nUnitId),
    -Unit("Tree") % (_arg.nUnitId),
    -Text("Tree") % (_arg.nUnitId),
  }


  local DEBUFF_TWIRL = 70440
  BuffAdded{ nSpellId = DEBUFF_TWIRL,
    Timer("Twirl", 30, "timer.twirl"),
    Polygon("Twirl", _arg.tUnit, 7, 20) % (_arg.nUnitId) + {nDuration = _arg.nDuration},
    If{ [_arg.tUnit:IsThePlayer()] = true,
      Aura("Twirl", _arg.nDuration) % (_arg.nUnitId),
      Sound("Twirl"),
      Alert("Twirl", "alert.twirl_you")
    }/{
      Icon("Twirl", _arg.tUnit) % (_arg.nUnitId) + {nDuration = _arg.nDuration},
      Alert("Twirl", "alert.twirl") % (_arg.nUnitId)
    }
  }

  local DEBUFF_NOHEAL = 74366
  BuffAdded{ nSpellId = DEBUFF_NOHEAL,
    If{ [_arg.tUnit:IsThePlayer()] = true,
      Aura("NoHeal", nil) % (_arg.nUnitId),
      Sound("NoHeal"),
      Alert("NoHeal", "alert.no_heals")
    }/{
      Icon("NoHeal", _arg.tUnit) % (_arg.nUnitId)
    }
  }
  BuffRemoved{ nSpellId = DEBUFF_NOHEAL,
    -Aura("NoHeal") % (_arg.nUnitId),
    -Icon("NoHeal") % (_arg.nUnitId)
  }

  local DEBUFF_LIGHTNING = 74485
  BuffAdded{ nSpellId = DEBUFF_LIGHTNING,
    If{ [_arg.tUnit:IsThePlayer()] = true,
      Aura("Lightning", _arg.nDuration) % (_arg.nUnitId),
      Sound("Lightning"),
      Alert("Lightning", "alert.lightning_you")
    }/{
      Icon("Lightning", _arg.tUnit) % (_arg.nUnitId) + {nDuration = _arg.nDuration},
      Alert("Lightning", {"alert.lightning_on", _arg.strUnitName}) % (_arg.nUnitId)
    }
  }

  BuffAdded{ nSpellId = DEBUFF_LIGHTNING, [_arg.tUnit:IsThePlayer()] = true,
    {function(self, nDuration)
      local tTrees = self.tVars.tActiveTrees
      local tValidTargets, bOnlyHealed = {}, false
      for nUnitId, tUnit in pairs(tTrees) do
        if tUnit:IsValid() then
          local bHealed = not tUnit:GetHealth() --fully healed trees have nil Health.
          -- not nil == true
          -- not <number> == false
          if bHealed and not bOnlyHealed then
            tValidTargets = {} --all previously inserted have been damaged. -> reset.
            bOnlyHealed = true
          end
          if bHealed or not bOnlyHealed then
            tValidTargets[nUnitId] = tUnit
          end
        end
      end
      for nUnitId, tUnit in pairs(tValidTargets) do
        self:LineBetween("Lightning", tUnit, nil, nUnitId, {
          nDuration = nDuration,
        })
      end
    end, _arg.self, _arg.nDuration}
  }

  CastStart{ strSpellName = "cast.blinding", [InRange(_arg.tUnit, 33)] = true,
    Alert("Blinding", "cast.blinding"),
    Sound("Blinding"),
  }
end)