local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("MnemesisHydroflux", {
  instance = "Datascape",
  groupName = "Elemental Pairs",
  displayName = "Mnemesis & Hydroflux",
  tTrigger = {
    sType = "ALL",
    tNames = {"unit.boss_logic", "unit.boss_water"},
    tZones = {
      [1] = {
        continentId = 52,
        parentZoneId = 98,
        mapId = 118,
      },
    },
  },
},{
  ["enUS"] = {
    -- Units
    ["unit.boss_logic"] = "Mnemesis",
    ["unit.boss_water"] = "Hydroflux",
    ["unit.tetris"] = "Alphanumeric Hash",
    ["unit.orb"] = "Hydro Disrupter - DNT",
    -- Casts
    ["cast.circuit_breaker"] = "Circuit Breaker",
    ["cast.imprison"] = "Imprison",
    ["cast.defrag"] = "Defragment",
    ["cast.grave"] = "Watery Grave",
    ["cast.tsunami"] = "Tsunami",
    -- Alerts
    ["alert.midphase"] = "Midphase! - Remaining IA: %s",
    ["alert.defrag"] = "DEFRAGMENT - SPREAD!",
    ["alert.imprison"] = "%s GOT IMPRISONED!",
    ["alert.imprison_player"] = "YOU GOT IMPRISONED! - MOVE!",
    -- Timers
    ["timer.midphase"] = "Next Midphase",
    ["timer.defrag"] = "Next Defragment",
    ["timer.imprison"] = "Next Imprison",
    ["timer.grave"] = "Next Watery Grave",
    -- Datachron
    ["datachron.enrage"] = "Time to die, sapients!",
    -- Labels
    ["label.orb"] = "Orb",
    ["label.midphase"] = "Midphase",
    ["label.avatus"] = "Avatus incoming",
    ["label.enrage"] = "Enrage",
    ["label.imprison"] = "Imprison",
    ["label.imprison_player"] = "Imprison on player",
    ["label.grave"] = "Watery Grave",
  },
  ["deDE"] = {
    -- Units
    ["unit.boss_logic"] = "Mnemesis",
    ["unit.boss_water"] = "Hydroflux",
    ["unit.tetris"] = "Alphanumerische Raute",
    ["unit.orb"] = "Hydro-disrupteur - DNT",
    -- Casts
    ["cast.circuit_breaker"] = "Schaltkreiszerstörer",
    ["cast.imprison"] = "Einsperren",
    ["cast.defrag"] = "Defragmentieren",
    ["cast.grave"] = "Seemannsgrab",
    ["cast.tsunami"] = "Tsunami", --assumed
    -- Alerts
    ["alert.midphase"] = "Mittelphase! - übrige IA: %s",
    ["alert.defrag"] = "DEFRAGMENTIEREN - VERTEILEN!",
    ["alert.imprison"] = "%s WURDE EINGESPERRT!",
    ["alert.imprison_player"] = "DU WURDEST EINGESPERRT - LAUF!",
    -- Timers
    ["timer.midphase"] = "Nächste Mitte-Phase",
    ["timer.defrag"] = "Nächste Defragmentierung",
    ["timer.imprison"] = "Nächstes Einsperren",
    ["timer.grave"] = "Nächstes Seemannsgrab",
    -- Datachron
    ["datachron.enrage"] = "Zeit, zu sterben, Vernunftbegabte!",
    -- Labels
    ["label.orb"] = "Orb",
    ["label.midphase"] = "Mittelphase",
    ["label.avatus"] = "Avatus incoming",
    ["label.enrage"] = "Enrage",
    ["label.imprison"] = "Einsperren",
    ["label.imprison_player"] = "Einsperren auf Spieler",
    ["label.grave"] = "Seemannsgrab",
  },
  ["frFR"] = {
    -- Units
    ["unit.boss_logic"] = "Mnémésis", --V (Verified)
    ["unit.boss_water"] = "Hydroflux", --V
    ["unit.tetris"] = "Alphanumeric Hash", --V
    ["unit.orb"] = "Hydro-disrupteur - DNT", --V
    -- Casts
    ["cast.circuit_breaker"] = "Coupe-circuit", --V
    ["cast.imprison"] = "Emprisonner", --V
    ["cast.defrag"] = "Défragmentation", --V
    ["cast.grave"] = "Tombe aqueuse",
    ["cast.tsunami"] = "Tsunami",
    -- Alerts
    ["alert.midphase"] = "Phase milieu! - IA RESTANTE: %s",
    ["alert.defrag"] = "DÉFRAGMENTATION - SÉPARER-VOUS !",
    ["alert.imprison"] = "%s A OBTENU EMPRISONNER !",
    ["alert.imprison_player"] = "TU AS EMPRISONNER !",
    -- Timers
    ["timer.midphase"] = "Prochaine phase milieu",
    ["timer.defrag"] = "Défragmentation suivante",
    ["timer.imprison"] = "Prochain emprisonner",
    ["timer.grave"] = "Next Watery Grave",
    -- Datachron
    ["datachron.enrage"] = "Maintenant c'est l'heure de mourir, misérables !", --V
    -- Labels
    ["label.orb"] = "Orbe",
    ["label.midphase"] = "Phase milieu",
    ["label.avatus"] = "Avatus est arrivé",
    ["label.enrage"] = "Enrager",
    ["label.imprison"] = "Emprisonner",
    ["label.imprison_player"] = "Emprisonner sur le joueur",
    ["label.grave"] = "Watery Grave",
  },
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  BossLogic{
    label = "unit.boss_logic",
    unit{color = "ffadff2f"},
  }
  BossWater{
    label = "unit.boss_water",
    unit{color = "ff44bbff"},
  }

  Midphase{
    label = "label.midphase",
    color = "xkcdAlgaeGreen",
    timer{},
    alert{},
    text{},
  }
  Imprison{
    label = "label.imprison",
    timer{color = "xkcdBluegreen"},
    alert{},
  }
  Defrag{
    label = "cast.defrag",
    timer{color = "xkcdBarneyPurple"},
    alert{},
    sound{file = "alarm"},
    line{thickness = 4, color = "xkcdBloodOrange"}
  }
  Grave{
    label = "label.grave",
    color = "xkcdDeepOrange",
    timer{enable = false},
    text{},
  }
  Orb{
    label = "label.orb",
    icon{sprite = "LUIBM_twirl", size = 60, color = "ffff00ff"},
    sound{file = "beware"},
    line{enable = false, color = "ff0000ff"}
  }
  Tetris{
    label = "unit.tetris",
    line{thickness = 8, color = "ffadff2f"},
  }
end, function(_arg, _env, _var) --luacheck: no unused args
  -- luacheck: no global

  UnitCreated{ strUnitName = "unit.boss_logic", [_arg.tUnit:GetHealth()] = {"~=", _arg(nil)},
    Unit("BossLogic", _arg.tUnit),
  }
  UnitCreated{ strUnitName = "unit.boss_water",
    Unit("BossWater", _arg.tUnit),
  }

  _var.bMidphase = false
  Enable{
    Timer("Midphase", 75, "timer.midphase"),
    Timer("Imprison", 33, "timer.imprison"),
    Timer("Defrag", 16, "timer.defrag"),
    Timer("Grave", 10, "timer.grave"),
  }

  CastStart{ strSpellName = "cast.circuit_breaker",
    _var.bMidphase(true),
    -Timer("Imprison"),
    -Timer("Defrag"),
    Timer("Midphase", 25, "label.midphase"),
    TimerText("Midphase", _arg.tUnit, 25),
    Alert("Midphase", {"alert.midphase", _arg.tUnit:GetInterruptArmorValue()})
  }
  CastEnd{ strSpellName = "cast.circuit_breaker",
    _var.bMidphase(false),
    Timer("Imprison", 25),
    Timer("Midphase", 85, "timer.midphase"),
  }

  CastStart{ strSpellName = "cast.imprison",
    -Timer("Imprison"),
    Alert("Imprison", _arg.strSpellName),
  }

  CastStart{ strSpellName = "cast.defrag",
    Timer("Defrag", 36, "timer.defrag"),
    Alert("Defrag", "alert.defrag"),
    Sound("Defrag"),
    Polygon("Defrag", _env.GameLib.GetPlayerUnit(), 13, 4) + {nDuration = 10},
  }

  CastStart{ strSpellName = "cast.grave",
    Timer("Grave", 10, "timer.grave"),
    TimerText("Grave", _arg.tUnit, 10),
  }

  CastStart{ strSpellName = "cast.tsunami",
    -Timer("Grave"),
    -TimerText("Grave"),
  }

  local DEBUFF_ORB = 78407
  BuffAdded{ nSpellId = DEBUFF_ORB,
    Icon("Orb", _arg.tUnit) % (_arg.nUnitId) + {nDuration = _arg.nDuration},
    If{ [_arg.tUnit:IsThePlayer()] = true,
      Sound("Orb")
    }
  }
  BuffRemoved{ nSpellId = DEBUFF_ORB,
    -Icon("Orb") % (_arg.nUnitId),
  }

  UnitCreated{ strUnitName = "unit.orb", [_var.bMidphase] = false,
    LineBetween("Orb", _arg.tUnit, nil) % (_arg.nUnitId),
  }

  UnitCreated{ strUnitName = "unit.tetris",
    Line("Tetris", _arg.tUnit, 15) % (_arg.nUnitId),
  }
end)