local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("MnemesisMegalith", {
  instance = "Datascape",
  groupName = "Elemental Pairs",
  displayName = "Mnemesis & Megalith",
  tTrigger = {
    sType = "ALL",
    tNames = {"unit.boss_logic", "unit.boss_earth"},
    tZones = {
      [1] = {
        continentId = 52,
        parentZoneId = 98,
        mapId = 117,
      },
    },
  },
},{
  ["enUS"] = {
    -- Units
    ["unit.boss_logic"] = "Mnemesis",
    ["unit.boss_earth"] = "Megalith",
    ["unit.pillar"] = "Crystalline Matrix",
    ["unit.stone"] = "Obsidian Outcropping",
    ["unit.snake_piece"] = "e395- [Datascape] Logic Elemental - Snake Piece (invis unit)",
    -- Casts
    ["cast.defrag"] = "Defragment",
    -- Alerts
    ["alert.mario"] = "JUMP INTO CUBES!",
    ["alert.superquake"] = "JUMP, JUMP, JUMP!!!",
    ["alert.defrag"] = "DEFRAGMENT - SPREAD!",
    ["alert.snake"] = "SNAKE ON %s!",
    ["alert.snake_player"] = "SNAKE ON YOU!",
    -- Timers
    ["timer.mario"] = "Next Mario Phase",
    ["timer.defrag"] = "Next Defragment",
    -- Datachron
    ["datachron.superquake"] = "The ground shudders beneath Megalith!",
    ["datachron.mario"] = "Logic creates powerful data caches",
    ["datachron.enrage"] = "Time to die, sapients!",
    -- Labels
    ["label.superquake"] = "Superquake",
    ["label.avatus"] = "Avatus incoming",
    ["label.enrage"] = "Enrage",
    ["label.snake"] = "Snake",
    ["label.snake_player"] = "Snake on player",
  },
  ["deDE"] = {
    -- Units
    ["unit.boss_logic"] = "Mnemesis",
    ["unit.boss_earth"] = "Megalith",
    ["unit.pillar"] = "Kristallmatrix",
    ["unit.stone"] = "Obsidianvorsprung",
    ["unit.snake_piece"] = "e395- [Datascape] Logic Elemental - Snake Piece (invis unit)",
    -- Casts
    ["cast.defrag"] = "Defragmentieren",
    -- Alerts
    ["alert.mario"] = "SPRING IN WÜRFEL!",
    ["alert.superquake"] = "SPRING, SPRING, SPRING!!!",
    ["alert.defrag"] = "DEFRAGMENTIEREN - VERTEILEN!",
    ["alert.snake"] = "SCHLANGE AUF %s!",
    ["alert.snake_player"] = "SCHLANGE AUF DIR!",
    -- Timers
    ["timer.mario"] = "Nächste Mario Phase",
    ["timer.defrag"] = "Nächste Defragmentierung",
    -- Datachron
    ["datachron.superquake"] = "Der Boden unter Megalith bebt!",
    ["datachron.mario"] = "Logik erschafft mächtige Datenspeicher!",
    ["datachron.enrage"] = "Zeit, zu sterben, Vernunftbegabte!",
    -- Labels
    ["label.superquake"] = "Superbeben",
    ["label.avatus"] = "Avatus incoming",
    ["label.enrage"] = "Enrage",
    ["label.snake"] = "Schlange",
    ["label.snake_player"] = "Schlange auf Spieler",
  },
  ["frFR"] = {
    -- Units
    ["unit.boss_logic"] = "Mnémésis", --V (Verified)
    ["unit.boss_earth"] = "Mégalithe", --V
    ["unit.pillar"] = "Matrice cristalline", --V
    ["unit.stone"] = "Affleurement d'obsidienne",
    ["unit.snake_piece"] = "e395- [Datascape] Logic Elemental - Snake Piece (invis unit)",
    -- Casts
    ["cast.defrag"] = "Défragmentation", --V
    -- Alerts
    ["alert.mario"] = "ATTRAPE LES CUBES !",
    ["alert.superquake"] = "SAUTE, SAUTE, SAUTE !!!",
    ["alert.defrag"] = "DÉFRAGMENTATION - SÉPARER-VOUS !",
    ["alert.snake"] = "SERPENT SUR %s !",
    ["alert.snake_player"] = "SERPENT SUR VOUS !",
    -- Timers
    ["timer.mario"] = "Prochaine phase de Mario",
    ["timer.defrag"] = "Défragmentation suivante",
    -- Datachron
    ["datachron.superquake"] = "Le sol tremble sous les pieds de Mégalithe !", --V
    ["datachron.mario"] = "La logique crée de puissantes caches de données !", --V
    ["datachron.enrage"] = "Maintenant c'est l'heure de mourir, misérables !", --V
    -- Labels
    ["label.superquake"] = "Super séisme",
    ["label.avatus"] = "Avatus est arrivé",
    ["label.enrage"] = "Enrager",
    ["label.snake"] = "Serpent",
    ["label.snake_player"] = "Serpent sur le joueur",
  },
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  BossLogic{
    label = "unit.boss_logic",
    unit{color = "ffadff2f"},
  }
  BossEarth{
    label = "unit.boss_earth",
    unit{color = "ffcc8844"},
    text{color = "ffcc8844"},
  }

  Snake{
    label = "label.snake",
    line{thickness = 8, color = "ffff0000"},
    alert{},
    sound{file = "run-away"},
    timer{color = "xkcdBrickOrange"},
    icon{sprite = "LUIBM_crosshair", size = 60, color = "ffff0000"},
    aura{label = "label.snake_player", sprite = "LUIBM_run", color = "ffff0000"},
  }
  Defrag{
    label = "cast.defrag",
    timer{color = "xkcdBarneyPurple"},
    alert{},
    sound{file = "alarm"},
    line{thickness = 4, color = "xkcdBloodOrange"}
  }
  Mario{
    label = "alert.mario",
    timer{color = "xkcdBlue"},
    alert{},
    sound{file = "alert"},
    icon{sprite = "LUIBM_minotaur", size = 60, color = "ffff0000"},
  }
  Defrag{
    label = "cast.defrag",
    timer{color = "xkcdBarneyPurple"},
    alert{},
    sound{file = "alarm"},
    line{thickness = 4, color = "xkcdBloodOrange"}
  }
  Jump{
    label = "label.superquake",
    sound{file = "beware"},
    alert{},
    cast{},
  }
end, function(_arg, _env, _var) --luacheck: no unused args
  -- luacheck: no global

  _var.tStones = _arg(function() return {} end)()
  _var.v3SnakePos = nil
  _var.tTargetUnit = nil

  local nCurrLines = 0
  local nSnakeStep = 6 --the Snake does a Step of 6m each time.
  local function fDrawSnakeLines(self)
    local tStones = self.tVars.tStones
    local v3SnakePos = self.tVars.v3SnakePos
    local tTarget = self.tVars.tTargetUnit

    if v3SnakePos and tTarget or next(tStones) then
      local v3TargetPos = nil
      if next(tStones) then
        local nDistance = nil
        for _, tStone in pairs(tStones) do
          local v3Pos = Vector3.New(tStone:GetPosition())
          local nDist = (v3Pos - v3SnakePos):Length()
          if not nDistance or nDist < nDistance then
            nDistance = nDist
            v3TargetPos = v3Pos
          end
        end
      end
      if not v3TargetPos then v3TargetPos = Vector3.New(tTarget:GetPosition()) end

      --from v3SnakePos to v3TargetPos
      local v3Diff = v3TargetPos-v3SnakePos
      local v3StepX = Vector3.New(v3Diff.x<0 and -nSnakeStep or nSnakeStep, 0, 0)
      local v3StepZ = Vector3.New(0, 0, v3Diff.z<0 and -nSnakeStep or nSnakeStep)
      local nStepsX = math.ceil(math.floor(math.abs(v3Diff.x)/nSnakeStep*2)/2)
      local nStepsZ = math.ceil(math.floor(math.abs(v3Diff.z)/nSnakeStep*2)/2)
      local bPrioX = math.abs(v3Diff.x)+((nStepsZ-nStepsX)*nSnakeStep) > math.abs(v3Diff.z)

      if bPrioX then
        nStepsX = nStepsX+0.5
      else
        nStepsZ = nStepsZ+0.5
      end

      local nStepsDone = 0
      local v3LineStart = v3SnakePos
      local v3LineEnd; -- =nil
      --draw each step
      while nStepsX >= 1 or nStepsZ >= 1 do
        if nStepsX > nStepsZ then
          nStepsX = nStepsX-1
          v3LineEnd = v3LineStart+v3StepX
        else
          nStepsZ = nStepsZ-1
          v3LineEnd = v3LineStart+v3StepZ
        end
        nStepsDone = nStepsDone+1
        self:LineBetween("Snake", v3LineStart, v3LineEnd, nStepsDone)
        v3LineStart = v3LineEnd
      end
      for nKey = nStepsDone+1, nCurrLines, 1 do
        self:RemoveLineBetween("Snake", nKey)
      end
      nCurrLines = nStepsDone
    else
      for nKey = 1, nCurrLines, 1 do
        self:RemoveLineBetween("Snake", nKey)
      end
      nCurrLines = 0
    end
  end

  Enable{
    Timer("Defrag", 10, "timer.defrag"),
    Timer("Mario", 60, "timer.mario"),
  }

  UnitCreated{ strUnitName = "unit.boss_logic", [_arg.tUnit:GetHealth()] = {"~=", _arg(nil)},
    Unit("BossLogic", _arg.tUnit),
  }
  UnitCreated{ strUnitName = "unit.boss_earth",
    Unit("BossEarth", _arg.tUnit),
  }
  local DEBUFF_STACKS_EARTH = 51350
  BuffAdded{ nSpellId = DEBUFF_STACKS_EARTH,
    Text("BossEarth", _arg.tUnit, _arg.nStack),
  }
  BuffUpdated{ nSpellId = DEBUFF_STACKS_EARTH,
    Text("BossEarth", _arg.tUnit, _arg.nStack),
  }
  BuffRemoved{ nSpellId = DEBUFF_STACKS_EARTH,
    Text("BossEarth", _arg.tUnit, 0),
  }

  local fSetVal = _arg(function(t,k,v) t[k]=v end)
  UnitCreated{ strUnitName = "unit.stone",
    fSetVal(_var.tStones, _arg.nUnitId, _arg.tUnit),
    fDrawSnakeLines,
  }
  UnitDestroyed{ strUnitName = "unit.stone",
    fSetVal(_var.tStones, _arg.nUnitId, nil),
    fDrawSnakeLines,
  }
  UnitCreated{ strUnitName = "unit.snake_piece",
    _var.v3SnakePos(_env.Vector3.New(_arg.tUnit:GetPosition())),
    fDrawSnakeLines,
  }

  CastStart{ strSpellName = "cast.defrag",
    Timer("Defrag", 40, "timer.defrag"),
    Alert("Defrag", "alert.defrag"),
    Sound("Defrag"),
    Polygon("Defrag", _env.GameLib.GetPlayerUnit(), 13, 4) + {nDuration = 10},
  }

  Datachron{ strMessage = "datachron.superquake",
    Sound("Jump"),
    Alert("Jump", "alert.superquake"),
    Cast("Jump", 2),
  }

  Datachron{ strMessage = "datachron.mario",
    Timer("Mario", 60, "timer.mario"),
    Sound("Mario"),
    Alert("Mario", "alert.mario"),
  }

  local DEBUFF_SNAKE = 74570
  BuffAdded{ nSpellId = DEBUFF_SNAKE,
    If{ [_arg.tUnit:IsThePlayer()] = true,
      Sound("Snake"),
      Alert("Snake", "alert.snake_player"),
      Timer("Snake", _arg.nDuration, "alert.snake_player"),
      Aura("Snake", _arg.nDuration)
    }/{
      Alert("Snake", {"alert.snake", _arg.strUnitName}),
      Timer("Snake", _arg.nDuration, {"alert.snake", _arg.strUnitName}),
      Icon("Snake", _arg.tUnit) + {nDuration = _arg.nDuration}
    },
    _var.tTargetUnit(_arg.tUnit),
    fDrawSnakeLines,
  }
  BuffRemoved{ nSpellId = DEBUFF_SNAKE, tUnit = _var.tTargetUnit,
    _var.tTargetUnit(nil),
    fDrawSnakeLines,
  }

  local DEBUFF_MARIO = 52868
  BuffAdded{ nSpellId = DEBUFF_MARIO,
    Icon("Mario", _arg.tUnit) % (_arg.nUnitId),
    If{ [_arg.tUnit:IsThePlayer()] = true,
      Sound("Mario")
    }
  }
  BuffRemoved{ nSpellId = DEBUFF_MARIO,
    -Icon("Mario") % (_arg.nUnitId),
  }
end)