local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("MnemesisVisceralus", {
  instance = "Datascape",
  groupName = "Elemental Pairs",
  displayName = "Mnemesis & Visceralus",
  tTrigger = {
    sType = "ALL",
    tNames = {"unit.boss_logic", "unit.boss_life"},
    tZones = {
      [1] = {
        continentId = 52,
        parentZoneId = 98,
        mapId = 119,
      },
    },
  },
},{
  ["enUS"] = {
    -- Units
    ["unit.boss_logic"] = "Mnemesis",
    ["unit.boss_life"] = "Visceralus",
    ["unit.life_orb"] = "Life Force",
    ["unit.essence_life"] = "Essence of Life",
    ["unit.essence_logic"] = "Essence of Logic",
    ["unit.tetris"] = "Alphanumeric Hash",
    ["unit.thorns"] = "Wild Brambles",
    -- Casts
    ["cast.defrag"] = "Defragment",
    ["cast.blinding"] = "Blinding Light",
    -- Alerts
    ["alert.defrag"] = "DEFRAGMENT - SPREAD!",
    ["alert.snake"] = "SNAKE ON %s!",
    ["alert.snake_player"] = "SNAKE ON YOU!",
    ["alert.no_heals"] = "No-Healing Debuff!",
    -- Timers
    ["timer.thorns"] = "Next Thorns",
    ["timer.defrag"]= "Next Defragment",
    -- Datachron
    ["datachron.enrage"] = "Time to die, sapients!",
    -- Labels
    ["label.orb"] = "Orb",
    ["label.no_heals"] = "No-Healing Debuff",
    ["label.thorns"] = "Thorns Debuff",
    ["label.avatus"] = "Avatus incoming",
    ["label.enrage"] = "Enrage",
    ["label.snake"] = "Snake",
    ["label.snake_player"] = "Snake on player",
    ["label.midphase"] = "Midphase",
    -- Cardinals
    ["cardinal.N"] = "N",
    ["cardinal.E"] = "E",
    ["cardinal.S"] = "S",
    ["cardinal.W"] = "W",
  },
  ["deDE"] = {
    -- Units
    ["unit.boss_logic"] = "Mnemesis",
    ["unit.boss_life"] = "Viszeralus",
    ["unit.life_orb"] = "Lebenskraft",
    ["unit.essence_life"] = "Lebensessenz",
    ["unit.essence_logic"] = "Logikessenz",
    ["unit.tetris"] = "Alphanumerische Raute",
    ["unit.thorns"] = "Wild Brambles", -- Missing
    -- Casts
    ["cast.defrag"] = "Defragmentieren",
    ["cast.blinding"] = "Blendendes Licht",
    -- Alerts
    ["alert.defrag"] = "DEFRAGMENTIEREN - VERTEILEN!",
    ["alert.snake"] = "SCHLANGE AUF %s!",
    ["alert.snake_player"] = "SCHLANGE AUF DIR!",
    ["alert.no_heals"] = "Debuff: Keine Heilung!",
    -- Timers
    ["timer.thorns"] = "Nächste Dornen",
    ["timer.defrag"] = "Nächste Defragmentierung",
    -- Datachron
    ["datachron.enrage"] = "Zeit, zu sterben, Vernunftbegabte!",
    -- Labels
    ["label.orb"] = "Orb",
    ["label.no_heals"] = "Keine-Heilung Debuff",
    ["label.thorns"] = "Dornen Debuff",
    ["label.avatus"] = "Avatus incoming",
    ["label.enrage"] = "Enrage",
    ["label.snake"] = "Schlange",
    ["label.snake_player"] = "Schlange auf Spieler",
    ["label.midphase"] = "Mittelphase",
    -- Cardinals
    ["cardinal.N"] = "N",
    ["cardinal.E"] = "O",
    ["cardinal.S"] = "S",
    ["cardinal.W"] = "W",
  },
  ["frFR"] = {
    -- Units
    ["unit.boss_logic"] = "Mnémésis", --V (Verified)
    ["unit.boss_life"] = "Visceralus", --V
    ["unit.life_orb"] = "Force vitale", --V
    ["unit.essence_life"] = "Essence de vie", --V
    ["unit.essence_logic"] = "Essence de logique", --V
    ["unit.tetris"] = "Alphanumeric Hash", --V
    ["unit.thorns"] = "Ronces sauvages", --V
    -- Casts
    ["cast.defrag"] = "Défragmentation", --V
    ["cast.blinding"] = "Lumière aveuglante",
    -- Alerts
    ["alert.defrag"] = "DÉFRAGMENTATION - SÉPARER-VOUS !",
    ["alert.snake"] = "SERPENT SUR %s !",
    ["alert.snake_player"] = "SERPENT SUR VOUS !",
    ["alert.no_heals"] = "Aucun-Soin Debuff!",
    -- Timers
    ["timer.thorns"] = "Epines suivantes",
    ["timer.defrag"] = "Défragmentation suivante",
    -- Datachron
    ["datachron.enrage"] = "Maintenant c'est l'heure de mourir, misérables !", --V
    -- Labels
    ["label.orb"] = "Orbe",
    ["label.no_heals"] = "Debuff: Aucun-Soin",
    ["label.thorns"] = "Debuff: Epines",
    ["label.avatus"] = "Avatus est arrivé",
    ["label.enrage"] = "Enrager",
    ["label.snake"] = "Serpent",
    ["label.snake_player"] = "Serpent sur le joueur",
    ["label.midphase"] = "Midphase",
    -- Cardinals
    ["cardinal.N"] = "N",
    ["cardinal.E"] = "E",
    ["cardinal.S"] = "S",
    ["cardinal.W"] = "W",
  },
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  BossLogic{
    label = "unit.boss_logic",
    unit{color = "ffadff2f"},
  }
  BossLife{
    label = "unit.boss_life",
    unit{color = "ff22aa00"},
  }
  Defrag{
    label = "cast.defrag",
    timer{color = "xkcdBarneyPurple"},
    alert{},
    sound{file = "alarm"},
    line{thickness = 4, color = "xkcdBloodOrange"}
  }
  Snake{
    label = "label.snake",
    line{thickness = 8, color = "ffff0000"},
    alert{},
    sound{file = "run-away"},
    icon{sprite = "LUIBM_crosshair", size = 60, color = "ffff0000"},
    aura{label = "label.snake_player", sprite = "LUIBM_run", color = "ffff0000"},
  }
  NoHeal{
    label = "label.no_heals",
    color = "ffff00ff",
    icon{sprite = "LUIBM_biohazard", size = 60},
    aura{sprite = "LUIBM_biohazard"},
    alert{},
    sound{sound = "alarm"},
  }
  Thorns{
    timer{label = "timer.thorns", color = "xkcdBluegreen"},
    icon{label = "label.thorns", sprite = "LUIBM_waterdrop2", size = 60, color = "ffcc0000"},
  }
  Midphase{
    label = "label.midphase",
    text{},
  }
  EssenceLogic{
    label = "unit.essence_logic",
    unit{color = "ff00ff00"},
  }
  EssenceLife{
    label = "unit.essence_life",
    unit{color = "ff22aa00"},
  }
  Tetris{
    label = "unit.tetris",
    line{thickness = 8, color = "ffadff2f"},
  }
  Orb{
    label = "label.orb",
    line{color = "ff0000ff"},
  }

  Blinding{
    label = "cast.blinding",
    alert{},
    sound{file = "beware"},
  }
end, function(_arg, _env, _var) --luacheck: no unused args
  -- luacheck: no global

  _var.v3SnakePos = nil
  _var.tTargetUnit = nil

  local nCurrLines = 0
  local nSnakeStep = 6 --the Snake does a Step of 6m each time.
  local function fDrawSnakeLines(self)
    local v3SnakePos = self.tVars.v3SnakePos
    local tTarget = self.tVars.tTargetUnit

    if v3SnakePos and tTarget then
      local v3TargetPos = Vector3.New(tTarget:GetPosition())

      --from v3SnakePos to v3TargetPos
      local v3Diff = v3TargetPos-v3SnakePos
      local v3StepX = Vector3.New(v3Diff.x<0 and -nSnakeStep or nSnakeStep, 0, 0)
      local v3StepZ = Vector3.New(0, 0, v3Diff.z<0 and -nSnakeStep or nSnakeStep)
      local nStepsX = math.ceil(math.floor(math.abs(v3Diff.x)/nSnakeStep*2)/2)
      local nStepsZ = math.ceil(math.floor(math.abs(v3Diff.z)/nSnakeStep*2)/2)
      local bPrioX = math.abs(v3Diff.x)+((nStepsZ-nStepsX)*nSnakeStep) > math.abs(v3Diff.z)

      if bPrioX then
        nStepsX = nStepsX+0.5
      else
        nStepsZ = nStepsZ+0.5
      end

      local nStepsDone = 0
      local v3LineStart = v3SnakePos
      local v3LineEnd; -- =nil
      --draw each step
      while nStepsX >= 1 or nStepsZ >= 1 do
        if nStepsX > nStepsZ then
          nStepsX = nStepsX-1
          v3LineEnd = v3LineStart+v3StepX
        else
          nStepsZ = nStepsZ-1
          v3LineEnd = v3LineStart+v3StepZ
        end
        nStepsDone = nStepsDone+1
        self:LineBetween("Snake", v3LineStart, v3LineEnd, nStepsDone)
        v3LineStart = v3LineEnd
      end
      for nKey = nStepsDone+1, nCurrLines, 1 do
        self:RemoveLineBetween("Snake", nKey)
      end
      nCurrLines = nStepsDone
    else
      for nKey = 1, nCurrLines, 1 do
        self:RemoveLineBetween("Snake", nKey)
      end
      nCurrLines = 0
    end
  end

  Enable{
    Timer("Defrag", 10, "timer.defrag"),
    Timer("Thorns", 24, "timer.thorns"),
  }

  UnitCreated{ strUnitName = "unit.boss_logic", [_arg.tUnit:GetHealth()] = {"~=", _arg(nil)},
    Unit("BossLogic", _arg.tUnit),
  }
  UnitCreated{ strUnitName = "unit.boss_life",
    Unit("BossLife", _arg.tUnit),
  }

  CastStart{ strSpellName = "cast.defrag",
    Timer("Defrag", 50, "timer.defrag"),
    Alert("Defrag", "alert.defrag"),
    Sound("Defrag"),
    Polygon("Defrag", _env.GameLib.GetPlayerUnit(), 13, 4) + {nDuration = 10},
  }

  local DEBUFF_SNAKE = 74570
  BuffAdded{ nSpellId = DEBUFF_SNAKE,
    If{ [_arg.tUnit:IsThePlayer()] = true,
      Sound("Snake"),
      Alert("Snake", "alert.snake_player"),
      Aura("Snake") % (_arg.nUnitId)
    }/{
      Alert("Snake", {"alert.snake", _arg.strUnitName}),
      Icon("Snake", _arg.tUnit) % (_arg.nUnitId)
    },
    _var.tTargetUnit(_arg.tUnit),
    fDrawSnakeLines,
  }
  BuffRemoved{ nSpellId = DEBUFF_SNAKE, tUnit = _var.tTargetUnit,
    _var.tTargetUnit(nil),
    fDrawSnakeLines,
    -Aura("Snake") % (_arg.nUnitId),
    -Icon("Snake") % (_arg.nUnitId),
  }

  local DEBUFF_NOHEAL = 74366
  BuffAdded{ nSpellId = DEBUFF_NOHEAL,
    If{ [_arg.tUnit:IsThePlayer()] = true,
      Aura("NoHeal", nil) % (_arg.nUnitId),
      Sound("NoHeal"),
      Alert("NoHeal", "alert.no_heals")
    }/{
      Icon("NoHeal", _arg.tUnit) % (_arg.nUnitId)
    },
  }
  BuffRemoved{ nSpellId = DEBUFF_NOHEAL,
    -Aura("NoHeal") % (_arg.nUnitId),
    -Icon("NoHeal") % (_arg.nUnitId),
  }

  _var.nLastThorns = 0
  local nGameTime = _env.GameLib.GetGameTime()
  UnitCreated{ strUnitName = "unit.thorns", [_var.nLastThorns] = {"<", nGameTime-5},
    _var.nLastThorns(nGameTime),
    Timer("Thorns", 30, "timer.thorns"),
  }

  local DEBUFF_THORNS = 75031
  BuffAdded{ nSpellId = DEBUFF_THORNS,
    Icon("Throns", _arg.tUnit) % (_arg.nUnitId),
  }
  BuffRemoved{ nSpellId = DEBUFF_THORNS,
    -Icon("Throns") % (_arg.nUnitId),
  }

  UnitCreated{ strUnitName = "unit.essence_life",
    Unit("EssenceLife", _arg.tUnit) % (_arg.nUnitId),
    -Timer("Thorns"),
    -Timer("Defrag"),
    Text("Midphase", { x = 9741.53, y = -518, z = 17823.81 }, "cardinal.N") % ("N"),
    Text("Midphase", { x = 9791.53, y = -518, z = 17873.81 }, "cardinal.E") % ("E"),
    Text("Midphase", { x = 9741.53, y = -518, z = 17923.81 }, "cardinal.S") % ("S"),
    Text("Midphase", { x = 9691.53, y = -518, z = 17873.81 }, "cardinal.W") % ("W"),
  }
  UnitDestroyed{ strUnitName = "unit.essence_life",
    -Unit("EssenceLife") % (_arg.nUnitId),
  }
  UnitCreated{ strUnitName = "unit.essence_logic",
    Unit("EssenceLogic", _arg.tUnit) % (_arg.nUnitId),
  }
  UnitDestroyed{ strUnitName = "unit.essence_logic",
    -Unit("EssenceLogic") % (_arg.nUnitId),
    -Text("Midphase") % ("N"),
    -Text("Midphase") % ("E"),
    -Text("Midphase") % ("S"),
    -Text("Midphase") % ("W"),
  }

  UnitCreated{ strUnitName = "unit.tetris",
    Line("Tetris", _arg.tUnit, 15) % (_arg.nUnitId),
  }

  UnitCreated{ strUnitName = "unit.life_orb",
    LineBetween("Orb", _arg.tUnit, _arg.self:GetUnit("BossLife")) % (_arg.nUnitId),
  }

  CastStart{ strSpellName = "cast.blinding", [InRange(_arg.tUnit, 33)] = true,
    Alert("Blinding", "cast.blinding"),
    Sound("Blinding"),
  }
end)