local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("SystemDaemons", {
  instance = "Datascape",
  displayName = "System Daemons",
  tTrigger = {
    sType = "ALL",
    tNames = {"unit.boss_north", "unit.boss_south"},
    tZones = {
      [1] = {
        continentId = 52,
        parentZoneId = 98,
        mapId = 105,
      },
      [2] = {
        continentId = 52,
        parentZoneId = 98,
        mapId = 107,
      },
    },
  },
},{
  ["enUS"] = {
      -- Bosses
      ["unit.boss_north"] = "Binary System Daemon",
      ["unit.boss_south"] = "Null System Daemon",
      -- Probes
      ["unit.probe_1"] = "Conduction Unit Mk. I",
      ["unit.probe_2"] = "Conduction Unit Mk. II",
      ["unit.probe_3"] = "Conduction Unit Mk. III",
      -- Adds
      ["unit.brute_force_algorithm"] = "Brute Force Algorithm",
      ["unit.encryption_program"] = "Encryption Program",
      ["unit.radiation_dispersion_unit"] = "Radiation Dispersion Unit",
      ["unit.defragmentation_unit"] = "Defragmentation Unit",
      ["unit.extermination_sequence"] = "Extermination Sequence",
      ["unit.data_compiler"] = "Data Compiler",
      ["unit.viral_diffusion_inhibitor"] = "Viral Diffusion Inhibitor",

      ["unit.pillar"] = "Enhancement Module",
      -- Casts
      ["cast.disconnect"] = "Disconnect",
      ["cast.power_surge"] = "Power Surge",
      ["cast.purge"] = "Purge",
      ["cast.back_ic"] = "Black IC",
      -- Alerts
      ["alert.disconnect_north"] = "Disconnect North!",
      ["alert.disconnect_south"] = "Disconnect South!",
      ["alert.purge_player"] = "Purge on you!",
      ["alert.purge_close"] = "Purge close!",
      ["alert.interrupt"] = "Interrupt!",
      -- Datachron
      ["datachron.disconnect"] = "INVALID SIGNAL. DISCONNECTING",
      ["datachron.enhancement"] = "COMMENCING ENHANCEMENT SEQUENCE",
      -- Messages
      ["message.next_wave_mobs"] = "Next wave: Mobs",
      ["message.next_wave_boss"] = "Next wave: Miniboss",
      ["message.next_disconnect"] = "Next disconnect",
      ["message.next_probe"] = "Next probe #%u",
      ["message.next_purge_south"] = "Next purge on south daemon",
      ["message.next_purge_north"] = "Next purge on north daemon",
      -- Labels
      ["label.disconnect_north"] = "Disconnect North",
      ["label.disconnect_south"] = "Disconnect South",
      ["label.purge"] = "Purge",
      ["label.disconnect"] = "Disconnect",
      ["label.waves"] = "Add Waves",
      ["label.probes"] = "Probes",
      ["label.distance_warn"] = "Bosses Distance Warning",
      ["label.minibosses"] = "Minibosses",
      ["label.miniboss_interrupt"] = "Miniboss Interrupt",
      ["label.interrupt_debuff"] = "Interrupt Debuff",
      ["label.midphase"] = "Midphase",

      ["cardinal.north"] = "N",
      ["cardinal.south"] = "S",
  },
  ["deDE"] = {
      -- Bosses
      ["unit.boss_north"] = "Binärsystem-Dämon",
      ["unit.boss_south"] = "Nullsystem-Dämon",
      -- Probes
      ["unit.probe_1"] = "Leistungseinheit V1",
      ["unit.probe_2"] = "Leistungseinheit V2",
      ["unit.probe_3"] = "Leistungseinheit V3",
      -- Adds
      ["unit.brute_force_algorithm"] = "Brachialgewalt-Algorithmus",
      ["unit.encryption_program"] = "Verschlüsselungsprogramm",
      ["unit.radiation_dispersion_unit"] = "Strahlungsverteilungseinheit", --copied from Raidcore
      ["unit.defragmentation_unit"] = "Defragmentierungseinheit", --copied from Raidcore
      ["unit.extermination_sequence"] = "Vernichtungssequenz",
      ["unit.data_compiler"] = "Datenkompilierer",
      ["unit.viral_diffusion_inhibitor"] = "Virushemmstoff", --copied from Raidcore

      ["unit.pillar"] = "Verbesserungsmodul",
      -- Casts
      ["cast.disconnect"] = "Trennung",
      ["cast.power_surge"] = "Energieschweller",
      ["cast.purge"] = "Säubern",
      ["cast.back_ic"] = "Glatteis",
      -- Alerts
      ["alert.disconnect_north"] = "Disconnect Norden!",
      ["alert.disconnect_south"] = "Disconnect Süden!",
      ["alert.purge_player"] = "Purge auf dir!",
      ["alert.purge_close"] = "Purge nah!",
      ["alert.interrupt"] = "Interrupt!",
      -- Datachron
      ["datachron.disconnect"] = "UNGÜLTIGES SIGNAL. VERBINDUNG ZU", --%s WIRD ABGEBROCHEN.
      ["datachron.enhancement"] = "BEGINNE VERBESSERUNGSSEQUENZ",
      -- Messages
      ["message.next_wave_mobs"] = "Nächste Welle: Mobs",
      ["message.next_wave_boss"] = "Nächste Welle: Miniboss",
      ["message.next_disconnect"] = "Nächstes Disconnect",
      ["message.next_probe"] = "Nächste Sonde #%u",
      ["message.next_purge_south"] = "Nächstes Purge im Süden",
      ["message.next_purge_north"] = "Nächstes Purge im Norden",
      -- Labels
      ["label.disconnect_north"] = "Disconnect Norden",
      ["label.disconnect_south"] = "Disconnect Süden",
      ["label.purge"] = "Purge",
      ["label.disconnect"] = "Disconnect",
      ["label.waves"] = "Add Wellen",
      ["label.probes"] = "Sonden",
      ["label.distance_warn"] = "Boss Entfernungs Warnung",
      ["label.minibosses"] = "Minibosse",
      ["label.miniboss_interrupt"] = "Miniboss Interrupt",
      ["label.interrupt_debuff"] = "Interrupt Debuff",
      ["label.midphase"] = "Midphase",

      ["cardinal.north"] = "N",
      ["cardinal.south"] = "S",
  },
  ["frFR"] = {
      -- Bosses
      ["unit.boss_north"] = "Daemon 2.0", --V
      ["unit.boss_south"] = "Daemon 1.0", --V
      -- Probes
      ["unit.probe_1"] = "Unité de conductivité v1", --V
      ["unit.probe_2"] = "Unité de conductivité v2", --V
      ["unit.probe_3"] = "Unité de conductivité v3", --V
      -- Adds
      ["unit.brute_force_algorithm"] = "Algorithme de force brute", --V
      ["unit.encryption_program"] = "Programme de cryptage", --not found
      ["unit.radiation_dispersion_unit"] = "Unité de dispersion de radiations", --V
      ["unit.defragmentation_unit"] = "Unité de défragmentation", --V
      ["unit.extermination_sequence"] = "Séquence d'extermination", --V
      ["unit.data_compiler"] = "Compilateur de données", --not found
      ["unit.viral_diffusion_inhibitor"] = "Inhibiteur de diffusion virale", --V

      ["unit.pillar"] = "Module d'amélioration",
      -- Casts
      ["cast.disconnect"] = "Déconnexion", --V
      ["cast.power_surge"] = "Surcharge d'énergie", --V
      ["cast.purge"] = "Purge", --GameLib.GetSpell(79399):GetName(),
      ["cast.back_ic"] = "CI noir",
      -- Alerts
      ["alert.disconnect_north"] = "Déconnexion Nord !",
      ["alert.disconnect_south"] = "Déconnexion Sud !",
      ["alert.purge_player"] = "Purge sur toi !",
      ["alert.purge_close"] = "Purge proche de vous !",
      ["alert.interrupt"] = "Interrompre !",
      -- Datachron
      ["datachron.disconnect"] = "SIGNAL INCORRECT. DÉCONNEXION", --V
      ["datachron.enhancement"] = "ACTIVATION DE LA SÉQUENCE D'AMÉLIORATION", --V
      -- Messages
      ["message.next_wave_mobs"] = "Vague suivante : Mobs",
      ["message.next_wave_boss"] = "Vague suivante : Miniboss",
      ["message.next_disconnect"] = "Prochaine déconnexion",
      ["message.next_probe"] = "Prochaine sonde #%u",
      ["message.next_purge_south"] = "Prochaine purge sur le daemon sud",
      ["message.next_purge_north"] = "Prochaine purge sur le daemon nord",
      -- Labels
      ["label.disconnect_north"] = "Déconnexion Nord",
      ["label.disconnect_south"] = "Déconnexion Sud",
      ["label.purge"] = "Purge",
      ["label.disconnect"] = "Déconnexion",
      ["label.waves"] = "Vague pop",
      ["label.probes"] = "Sondes",
      ["label.distance_warn"] = "Bosses Distance Warning",
      ["label.minibosses"] = "Minibosses",
      ["label.miniboss_interrupt"] = "Miniboss Interrupt",
      ["label.interrupt_debuff"] = "Interrupt Debuff",
      ["label.midphase"] = "Midphase",

      ["cardinal.north"] = "N",
      ["cardinal.south"] = "S",
  },
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global

  North{
    label = "unit.boss_north",
    color = "ffDC5E30",
    unit{},
    text{color = false},
  }
  South{
    label = "unit.boss_south",
    color = "ff30aedc",
    unit{},
    text{},
  }
  Miniboss{
    label = "label.minibosses",
    unit{},
    alert{label = "label.miniboss_interrupt"},
    cast{label = "label.miniboss_interrupt"},
    sound{label = "label.miniboss_interrupt", file = "alert"},
    timer{label = "label.miniboss_interrupt"},
  }

  DistanceWarn{
    label = "label.distance_warn",
    line{color = false, thickness = 8},
  }

  Disconnect{
    label = "label.disconnect",
    timer{color = "xkcdBlueyPurple"},
    cast{enable = false},
    alert{},
    sound{enable = false},
  }
  Wave{
    label = "label.waves",
    timer{color = "xkcdOrangeYellow"},
    alert{},
    sound{file = "info"},
  }
  Probe{
    label = "label.probes",
    timer{color = "xkcdSunYellow"},
    text{},
  }
  PowerSurge{
    label = "cast.power_surge",
    cast{},
    alert{},
    sound{file = "alert"},
  }
  Purge{
    label = "label.purge",
    color = "xkcdBrickOrange",
    timer{},
    line{},
    sound{file = "beware"},
    alert{},
  }

  Overload{
    label = "label.interrupt_debuff",
    text{color = "ffF0BB32"},
  }

  Midphase{
    label = "label.midphase",
    text{},
    alert{},
  }

end, function(_arg, _env, _var) --luacheck: no unused args
  -- luacheck: no global
  local function fCreateDistanceLines(self)
    local tNorth, tSouth = self:GetUnit("North"), self:GetUnit("South")
    if not tNorth or not tSouth then return end

    self:LineBetween("DistanceWarn", tNorth, tSouth, "Notice", {max = 67, min = 62, color = "xkcdOrange"})
    self:LineBetween("DistanceWarn", tNorth, tSouth, "Warning", {max = 62, min = nil, color = "xkcdRed"})
  end

  local function fUpdateHealthDiff(self, tDraw, oOther)
    local nHealthSelf = self:GetHealth(tDraw.tOrigin)
    local nHealthOther = self:GetHealth(oOther)

    local nDiff = nHealthSelf - nHealthOther --this is negative, if the other mob has more health

    local strColor = math.abs(nDiff) <= 3 and "ffdbdbdb" or nDiff < 0 and "ffeb1414" or "ff14eb14"
    local strText = Apollo.FormatNumber(nDiff, 1, true).."%" --ex: 3.2% for 3.194

    tDraw.wnd:SetTextColor(strColor)
    tDraw.wnd:SetText(strText)
  end

  UnitCreated{ strUnitName = "unit.boss_north", bInCombat = true, [_arg.self:HasUnit("North")] = false,
    Unit("North", _arg.tUnit) + {strMark = "cardinal.north"},
    Text("North", _arg.tUnit, "0.0%") + {fUpdate = fUpdateHealthDiff, tData = "South"},
    fCreateDistanceLines,
  }
  UnitCreated{ strUnitName = "unit.boss_south", bInCombat = true, [_arg.self:HasUnit("South")] = false,
    Unit("South", _arg.tUnit) + {strMark = "cardinal.south"},
    Text("North", _arg.tUnit, "0.0%") + {fUpdate = fUpdateHealthDiff, tData = "North"},
    fCreateDistanceLines,
  }


  --### Disconnect ###--
  Enable{
    Timer("Disconnect", 41),
  }
  Datachron{ strMessage = "datachron.disconnect",
    Timer("Disconnect", 60),
  }
  CastStart{ strSpellName = "cast.disconnect",
    Sound("Disconnect"),
    If{ strUnitName = "unit.boss_north",
      Cast("Disconnect", _arg.tCast) + {strText = "label.disconnect_north"},
      Alert("Disconnect", "alert.disconnect_north")
    }/{
      Cast("Disconnect", _arg.tCast) + {strText = "label.disconnect_south"},
      Alert("Disconnect", "alert.disconnect_south")
    },
  }


  --### Adds / Minibosses ###
  Enable{
    Timer("Wave", 15) + {strText = "message.next_wave_mobs"},
  }

  _var.bMidphase = false
  _var.nLastAdds = 0
  _var.nProbeCount = 0
  _var.nWaveCount = 0
  local fGameTime = _env.GameLib.GetGameTime
  UnitCreated{
    [_var.bMidphase] = false, --not sure why this is neccessary. But original file added it.
    [_var.nLastAdds] = {"<", fGameTime()-48}, --last adds spawned 48 secs ago.
    strUnitName = {
      "unit.brute_force_algorithm",
      "unit.encryption_program",
      "unit.extermination_sequence",
      "unit.data_compiler",
      "unit.viral_diffusion_inhibitor",
      "unit.defragmentation_unit",
      "unit.radiation_dispersion_unit",
    },

    _var.nLastAdds(fGameTime()),
    _var.nProbeCount(0),
    _var.nWaveCount+1,
    {function(self, nWaveCount)
      local strNow = nWaveCount%2==1 and nWaveCount~=1 and "message.next_wave_boss" or "message.next_wave_mobs"
      local strNext = nWaveCount%2==0 and "message.next_wave_boss" or "message.next_wave_mobs"
      self:Sound("Wave")
      self:Alert("Wave", strNow)
      self:Timer("Wave", 50, strNext)
      self:Timer("Probe", 10, self.L["message.next_probe"]:format(1))
    end, _arg.self, _var.nWaveCount}
  }
  Callback("MidphaseWaveTimer", { --Triggered 5s after Midphase Start
    {function(self, nProbeCount, nWaveCount)
      local strNext = nWaveCount%2==0 and "message.next_wave_boss" or "message.next_wave_mobs"
      if nProbeCount == 3 then
        self:Timer("Wave", 90, strNext)
      else
        local nTime = 110 + (2 - nProbeCount) * 10
        self:Timer("Wave", nTime, strNext)
      end
    end, _arg.self, _var.nProbeCount, _var.nWaveCount}
  })

  UnitCreated{ strUnitName = {"unit.defragmentation_unit", "unit.radiation_dispersion_unit"},
    Unit("Miniboss", _arg.tUnit),
  }
  CastStart{ strSpellName = "cast.black_ic",
    If{ [_arg.self:InRange(_arg.tUnit, 40)] = true,
      Cast("Miniboss", _arg.tCast),
      Alert("Miniboss", "alert.interrupt"),
      Sound("Miniboss")
    },
    Timer("Miniboss", 30, "label.miniboss_interrupt"),
  }

  UnitCreated{ strUnitName = "unit.probe_1", [_var.nProbeCount] = 0,
    _var.nProbeCount(1),
    Text("Probe", _arg.tUnit, 1),
    Timer("Probe", 10, _arg.self.L["message.next_probe"]:format(2)),
  }
  UnitCreated{ strUnitName = "unit.probe_2", [_var.nProbeCount] = 1,
    _var.nProbeCount(2),
    Text("Probe", _arg.tUnit, 2),
    Timer("Probe", 10, _arg.self.L["message.next_probe"]:format(3)),
  }
  UnitCreated{ strUnitName = "unit.probe_3", [_var.nProbeCount] = 2,
    _var.nProbeCount(3),
    Text("Probe", _arg.tUnit, 3),
  }

  --### Purge ###
  CastStart{ strSpellName = "cast.purge", strUnitName = "unit.boss_north",
    Timer("Purge", 27, "message.next_purge_north") % ("North"),
  }
  CastStart{ strSpellName = "cast.purge", strUnitName = "unit.boss_south",
    Timer("Purge", 27, "message.next_purge_south") % ("South"),
  }
  _var.nLastPurgeSound = 0
  local DEBUFF_PURGE = 79399
  BuffAdded{ nSpellId = DEBUFF_PURGE,
    Polygon("Purge", _arg.tUnit, 6, 20) % (_arg.nUnitId) + {nDuration = _arg.nDuration},
    If{ [_arg.self:InRange(_arg.tUnit, 8)] = true, --this is also true for the player himself.
      If{ [_var.nLastPurgeSound] = {"<", fGameTime()-2},
        _var.nLastPurgeSound(fGameTime()),
        Sound("Purge")
      },
    },
    If{ [_arg.tUnit:IsThePlayer()] = true,
      Alert("Purge", "alert.purge_player")
    }/{ [_arg.self:InRange(_arg.tUnit, 8)] = true,
      Alert("Purge", "alert.purge_close")
    },
  }

  BuffRemoved{ nSpellId = DEBUFF_PURGE,
    -Polygon("Purge") % (_arg.nUnitId),
  }

  --### Power Surge (Interrupt Boss) ###
  CastStart{ strSpellName = "cast.power_surge", [_arg.self:InRange(_arg.tUnit, 25)] = true,
    Sound("PowerSurge"),
    Cast("PowerSurge", _arg.tCast),
    Alert("PowerSurge", "alert.interrupt"),
  }
  local DEBUFF_INTERRUPT = 43012 --ID_OVERLOAD
  BuffAdded{ nSpellId = DEBUFF_INTERRUPT,
    Text("Overload", _arg.tUnit, _arg.nStack) % (_arg.nUnitId)
  }
  BuffUpdated{ nSpellId = DEBUFF_INTERRUPT,
    Text("Overload", _arg.tUnit, _arg.nStack) % (_arg.nUnitId)
  }
  BuffRemoved{ nSpellId = DEBUFF_INTERRUPT,
    -Text("Overload") % (_arg.nUnitId)
  }


  --### Midphase ###

  Datachron{ strMessage = "datachron.enhancement", --Midphase
    Alert("Midphase"),
    Timer("Disconnect", 85),
    Delay(5,
      FireCallbacks("MidphaseWaveTimer")
    )
  }

  _var.nPillars = 0
  UnitCreated{ strUnitName = "unit.pillar", --while one of these is alive: display Midphase Markers
    _var.nPillars+1,
    If{ [_var.nPillars] = 1,
      function(self)
        --should be 30, but trying with 35.
        local b1stPhase = (self:GetHealth("North") > 35) and (self:GetHealth("South") > 35)

        local tPhaseMarkers = b1stPhase and {
          ["N1"] = { x = 133.217, y = -225.94, z = -207.71 },
          ["N2"] = { x = 156.79, y = -225.94, z = -198.126 },
          ["N3"] = { x = 109.23, y = -225.94, z = -198.13 },
          ["N4"] = false,
          ["S1"] = { x = 133.17, y = -225.94, z = -140.96 },
          ["S2"] = { x = 109.22, y = -225.94, z = -150.85 },
          ["S3"] = { x = 156.80, y = -225.94, z = -150.82 },
          ["S4"] = false,
        } or {
          ["N1"] = { x = 109.23, y = -225.94, z = -198.12 },
          ["N2"] = { x = 156.79, y = -225.94, z = -198.12 },
          ["N3"] = { x = 99.91, y = -225.99, z = -174.35 },
          ["N4"] = { x = 133.21, y = -225.94, z = -207.71 },
          ["S1"] = { x = 109.22, y = -225.94, z = -150.85 },
          ["S2"] = { x = 156.80, y = -225.94, z = -150.82 },
          ["S3"] = { x = 133.17, y = -225.94, z = -140.93 },
          ["S4"] = { x = 166.56, y = -225.94, z = -174.30 },
        }

        for strText, tPos in pairs(tPhaseMarkers) do
          if tPos then
            self:Text("Midphase", tPos, strText, strText)
          else
            self:RemoveText("Midphase", strText)
          end
        end
      end
    }
  }
  UnitDestroyed{ strUnitName = "unit.pillar",
    _var.nPillars-1,
    If{ [_var.nPillars] = 0,
      -Text("Midphase") % ("N1"),
      -Text("Midphase") % ("N2"),
      -Text("Midphase") % ("N3"),
      -Text("Midphase") % ("N4"),
      -Text("Midphase") % ("S1"),
      -Text("Midphase") % ("S2"),
      -Text("Midphase") % ("S3"),
      -Text("Midphase") % ("S4")
    }
  }
end)