local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter

local tZones = {
  [1] = {
    continentId = 105,    -- CBC
    parentZoneId = 0,
    mapId = 560,
  },
}

-- ##########################################################################################################
-- # Hail (1)
-- ##########################################################################################################


Encounter.new("CBCHail", {
  instance = "Dungeons",
  groupName = "CBC",
  displayName = "(1) Hail",
  tTrigger = {
    sType = "ANY",
    tNames = {"unit.boss"},
    tZones = tZones,
  },
},{
  ["enUS"] = {
    ["unit.boss"] = "???",


    ["cast.throw"] = "Schneebrocken schleudern",
    ["cast."] = nil,
  },
  ["deDE"] = {
    ["unit.boss"] = "Hagelstein-Torzerberster",
  },
  ["frFR"] = {},
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  Boss{
    label = "unit.boss",
    unit{},
  }

  Test{text{font="Pixel"}}
end, function(_arg, _env) --luacheck: no unused args
  -- luacheck: no global

  UnitCreated{ strUnitName = "unit.boss", bInCombat = true, [_arg.self:GetUnit("Boss")] = _arg.Nil,
    Unit("Boss", _arg.tUnit),
  }




  UnitCreated{Text("Test", _arg.tUnit, _arg.strUnit, _arg.nUnitId)}
  CastStart{_env.print}
end)