local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("Kuralak", {
  instance = "Genetic Archives",
  displayName = "Kuralak",
  tTrigger = {
    sType = "ANY",
    tNames = {"unit.boss"},
    tZones = {
      [1] = {
        continentId = 67,
        parentZoneId = 147,
        mapId = 148,
      },
    },
  },
},{
  ["enUS"] = {
    ["unit.boss"] = "Kuralak the Defiler",
    -- Datachron messages.
    ["datachron.vanish"] = "Kuralak the Defiler vanishes into the shadows",
    ["datachron.return"] = "Kuralak the Defiler returns to the Archive Core",
    ["datachron.outbreak"] = "Kuralak the Defiler causes a violent outbreak of corruption",
    ["datachron.corruption"] = "The corruption begins to fester",
    ["datachron.anesthetized"] = "has been anesthetized",
    -- Cast.
    ["cast.vanish"] = "Vanish into Darkness",
    ["cast.corruption"] = "Chromosome Corruption",
    -- Bar and messages.
    ["message.next_outbreak"] = "Next outbreak",
    ["message.next_eggs"] = "Next eggs",
    ["message.next_tankswitch"] = "Next switch tank",
    ["message.next_vanish"] = "Next vanish",
    ["message.phase2"] = "PHASE 2 !",
    ["message.vanish"] = "VANISH",
    ["message.outbreak"] = "OUTBREAK",
    ["message.eggs"] = "EGGS",
    ["message.switchtank"] = "SWITCH TANK",

    ["alert.vanish_soon"] = "VANISH SOON!",
    -- Labels
    ["label.vanish"] = "Vanish",
    ["label.outbreak"] = "Outbreak",
    ["label.eggs"] = "Eggs",
    ["label.tankswitch"] = "Tank switch",
    ["label.phase2"] = "Phase 2",
    ["label.player_pillar"] = "Players Pillar",
    ["label.cardinals"] = "Cardinal Directions",
    ["label.inner.N"] = "N",
    ["label.inner.E"] = "E",
    ["label.inner.S"] = "S",
    ["label.inner.W"] = "W",
  },
  ["deDE"] = {
    -- Unit names.
    ["unit.boss"] = "Kuralak die Schänderin",
    -- Datachron messages.
    ["datachron.vanish"] = "Kuralak die Schänderin verschwindet in den Schatten",
    ["datachron.return"] = "Kuralak die Schänderin kehrt zum Archivkern zurück",
    ["datachron.outbreak"] = "Kuralak die Schänderin verursacht einen heftigen Ausbruch der Korrumpierung",
    ["datachron.corruption"] = "Die Korrumpierung beginnt zu eitern",
    ["datachron.anesthetized"] = "wurde narkotisiert",
    -- Cast.
    ["cast.vanish"] = "In der Dunkelheit verschwinden",
    ["cast.corruption"] = "Chromosomen-Korrumpierung",
    -- Bar and messages.
    ["message.next_outbreak"] = "Nächster Ausbruch",
    ["message.next_eggs"] = "Nächste Eier",
    ["message.next_tankswitch"] = "Nächster Tankwechsel",
    ["message.next_vanish"] = "Nächstes Verschwinden",
    ["message.phase2"] = "PHASE 2 !",
    ["message.vanish"] = "VERSCHWINDEN",
    ["message.outbreak"] = "AUSBRUCH",
    ["message.eggs"] = "EIER",
    ["message.switchtank"] = "AGGRO ZIEHEN !!!",

    ["alert.vanish_soon"] = "VERSCHWINDEN BALD!",
    -- Labels
    ["label.vanish"] = "Verschwinden",
    ["label.outbreak"] = "Ausbruch",
    ["label.eggs"] = "Eier",
    ["label.tankswitch"] = "Tankwechsel",
    ["label.phase2"] = "Phase 2",
    ["label.player_pillar"] = "Spielers Säule",
    ["label.cardinals"] = "Himmelsrichtungen",
    ["label.inner.N"] = "N",
    ["label.inner.E"] = "O",
    ["label.inner.S"] = "S",
    ["label.inner.W"] = "W",
  },
  ["frFR"] = {
    -- Unit names.
    ["unit.boss"] = "Kuralak la Profanatrice",
    -- Datachron messages.
    ["datachron.vanish"] = "Kuralak the Defiler vanishes into the shadows",
    ["datachron.return"] = "Kuralak la Profanatrice retourne au Noyau d'accès aux archives pour reprendre des forces",
    ["datachron.outbreak"] = "Kuralak la Profanatrice provoque une violente éruption de Corruption",
    ["datachron.corruption"] = "La Corruption commence à se répandre",
    ["datachron.anesthetized"] = "est sous anesthésie",
    -- Cast.
    ["cast.vanish"] = "Disparaître dans les ténèbres",
    ["cast.corruption"] = "Corruption chromosomique",
    -- Bar and messages.
    ["message.next_outbreak"] = "Prochaine invasion",
    ["message.next_eggs"] = "Prochain oeufs",
    ["message.next_tankswitch"] = "Prochain changement de tank",
    ["message.next_vanish"] = "Prochaine disparition",
    ["message.phase2"] = "PHASE 2 !",
    ["message.vanish"] = "DISPARITION",
    ["message.outbreak"] = "INVASION",
    ["message.eggs"] = "OEUFS",
    ["message.switchtank"] = "CHANGEMENT TANK",

    ["alert.vanish_soon"] = "VANISH SOON!",
    -- Labels
    ["label.vanish"] = "Disparition",
    ["label.outbreak"] = "Invasion",
    ["label.eggs"] = "Oeufs",
    ["label.tankswitch"] = "Changement tank",
    ["label.phase2"] = "Phase 2",
    ["label.player_pillar"] = "Players Pillar",
    ["label.cardinals"] = "Cardinal Directions",
    ["label.inner.N"] = "N",
    ["label.inner.E"] = "E",
    ["label.inner.S"] = "S",
    ["label.inner.W"] = "W",
  },
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  Boss{
    label = "unit.boss",
    unit{},
    text{},
  }
  Cardinals{
    label = "label.cardinals",
    text{color = "ffffffff"},
  }
  Vanish{
    label = "label.vanish",
    alert{},
    sound{file = "alert"},
    timer{color = "ad1dfbfb"},
    text{color = "ff00ffff"},
  }
  Outbreak{
    label = "label.outbreak",
    alert{},
    sound{file = "run-away"},
    timer{color = "afff4500"},
    text{color = "ffff0000"},
  }
  Eggs{
    label = "label.eggs",
    alert{},
    sound{file = "alert"},
    timer{color = "afb0ff2f"},
    icon{sprite = "LUIBM_crosshair", size = 60, color = "ffb0ff2f"},
  }
  Tankswitch{
    label = "label.tankswitch",
    alert{},
    sound{file = "alarm"},
    timer{color = "afff00ff"},
  }
  PlayerPillar{
    label = "label.player_pillar",
    line{thickness = 8, color = "ff9932cc"},
  }
  Phase2{
    label = "label.phase2",
    alert{},
    sound{file = "long"},
  }
end, function(_arg, _env, _var) --luacheck: no unused args
  -- luacheck: no global

  local v3BossPos = Vector3.New(170.13, -110.89, -489.32)

  UnitCreated{ strUnitName = "unit.boss", bInCombat = true, [_arg.self:GetUnit("Boss")] = _arg.Nil,
    Unit("Boss", _arg.tUnit),
    HealthText("Boss", _arg.tUnit, 73) + {nOffset = -50},
  }

  Enable{
    Text("Cardinals", {x = 174.0, y = -112, z = -512.4}, "label.inner.N") % ("N"),
    Text("Cardinals", {x = 192.7, y = -112, z = -482.2}, "label.inner.E") % ("E"),
    Text("Cardinals", {x = 164.0, y = -112, z = -466.4}, "label.inner.S") % ("S"),
    Text("Cardinals", {x = 146.0, y = -112, z = -495.3}, "label.inner.W") % ("W"),
  }

  Datachron{ strMessage = "datachron.return",
    Timer("Vanish", 47),
    TimerText("Vanish", v3BossPos, 47), --we put this here, because at this time the boss is not a valid unit
    Delay("Vanish", 37,
      FireCallbacks("VanishWarning")
    )
  }

  _var.tPlayersPillarPos = nil
  local nZ = math.sqrt(0.75)
  local tOuterPillars = {
    ["NE"] = {x =  0.5,   y = 0, z = -nZ}, --   ["NE"] = {x = 207.25, y = -111.5, z = -554.6},
    ["E"] =  {x =  1,     y = 0, z =  0},  --   ["E"] = {x = 244.4,   y = -111.5, z = -489.4},
    ["SE"] = {x =  0.5,   y = 0, z =  nZ}, --   ["SE"] = {x = 207.25, y = -111.5, z = -423.9},
    ["SW"] = {x = -0.5,   y = 0, z =  nZ}, --   ["SW"] = {x = 130.75, y = -111.5, z = -421.8},
    ["W"] =  {x = -1,     y = 0, z =  0},  --   ["W"] = {x = 93.5,    y = -111.5, z = -489.9},
    ["NW"] = {x = -0.5,   y = 0, z = -nZ}, --   ["NW"] = {x = 131.5,  y = -111.5, z = -555.4},
  }
  local function CalculatePlayersPillar(self)
    if self.tVars.tPlayersPillarPos then return end
    local tPlayer = GameLib.GetPlayerUnit()
    if not tPlayer then return nil end

    local tBossPos = Vector3.New(170.13, -110.89, -489.32)
    local tPlayerPos = tPlayer:GetPosition()

    if not tBossPos or not tPlayerPos then return end
    if tBossPos.y == 0 or tPlayerPos.y == 0 then return end

    local vDiff = Vector2.New(tPlayerPos.x - tBossPos.x, tPlayerPos.z - tBossPos.z)

    if vDiff:Length() < 60 then return nil end

    -- -z = North, +x = East
    local strPos = math.abs(vDiff.y) < 30 and "" or vDiff.y < 0 and "N" or vDiff.y > 0 and "S"
    strPos = strPos..(vDiff.x > 0 and "E" or "W")

    self.tVars.tPlayersPillarPos = tOuterPillars[strPos]
  end
  Callback("VanishWarning", {
    If{ [_var.tPlayersPillarPos] = {"~=", _arg(nil)},
      Alert("Vanish", "alert.vanish_soon"),
      Sound("Vanish"),
      Line("PlayerPillar", _env.GameLib.GetPlayerUnit(), 10) + {
        nOffset = 2,
        tVectorFacing = _var.tPlayersPillarPos,
        nDuration = 15},
    },
  })
  Datachron{ strMessage = "datachron.vanish",
    Alert("Vanish", "message.vanish"),
    Sound("Vanish"),
    CalculatePlayersPillar,
  }

  _var.nPhase = 1
  CastStart{ strSpellName = "cast.corruption", [_var.nPhase] = 1,
    _var.nPhase+1,
    -Timer("Vanish"),
    -TimerText("Vanish"),
    -Delay("Vanish"),
    -LineBetween("PlayerPillar"),

    Alert("Phase2", "message.phase2"),
    Sound("Phase2"),
    Timer("Outbreak", 15),
    TimerText("Outbreak", _arg.self:GetUnit("Boss"), 15),
    Timer("Eggs", 73),
    Timer("Tankswitch", 37),
  }

  Datachron{ strMessage = "datachron.corruption",
    Alert("Eggs", "message.eggs"),
    Sound("Eggs"),
    Timer("Eggs", 66),
  }

  local DEBUFFID_CHROMOSOME_CORRUPTION = 56652
  BuffAdded{ nSpellId = DEBUFFID_CHROMOSOME_CORRUPTION,
    Icon("Eggs", _arg.tUnit) % (_arg.nUnitId),
  }
  BuffRemoved{ nSpellId = DEBUFFID_CHROMOSOME_CORRUPTION,
    -Icon("Eggs") % (_arg.nUnitId),
  }

  Datachron{ strMessage = "datachron.outbreak",
    Alert("Outbreak", "message.outbreak"),
    Sound("Outbreak"),
    Timer("Outbreak", 45),
    TimerText("Outbreak", _arg.self:GetUnit("Boss"), 45),
  }

  Datachron{ strMessage = "datachron.anesthetized", [_env.GroupLib.GetGroupMember(1).bTank] = true,
    Alert("Tankswitch", "message.tankswitch"),
    Sound("Tankswitch"),
  }
  Datachron{ strMessage = "datachron.anesthetized",
    Timer("Tankswitch", 88),
  }
end)