local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("GeneticMonstrosity", {
  instance = "Genetic Archives",
  groupName = "Minibosses",
  displayName = "Genetic Monstrosity",
  tTrigger = {
    sType = "ANY",
    tNames = {"unit.boss"},
    tZones = {
      [1] = {
        continentId = 67,
        parentZoneId = 147,
        mapId = 148,
      },
    },
  },
},{
  ["enUS"] = {
    -- Units
    ["unit.boss"] = "Genetic Monstrosity",
    ["unit.pustule"] = "Pustule",
    -- Casts
    -- Alerts
    -- Labels
    ["label.belch"] = "Noxious Belch",
  },
  ["deDE"] = {
    -- Units
    ["unit.boss"] = "Genetische Monstrosität",
    ["unit.pustule"] = "Pustel",
    -- Casts
    -- Alerts
    -- Labels
    ["label.belch"] = "Noxious Belch",
  },
  ["frFR"] = {
    -- Units
    ["unit.boss"] = "Genetic Monstrosity",
    ["unit.pustule"] = "Pustule",
    -- Casts
    -- Alerts
    -- Labels
    ["label.belch"] = "Noxious Belch",
  },
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  Boss{
    label = "unit.boss",
    unit{},
  }
  Belch{
    label = "label.belch",
    timer{color = "ffff0000"},
    text{color = "ffff0000"}
  }
  Pustule{
    label = "unit.pustule",
    icon{sprite = "LUIBM_stop", size = 60, color = "ffffd700"}
  }
end, function(_arg, _env) --luacheck: no unused args
  -- luacheck: no global

  UnitCreated{ strUnitName = "unit.boss", bInCombat = true, [_arg.self:GetUnit("Boss")] = _arg.Nil,
    Unit("Boss", _arg.tUnit),
    Timer("Belch", 12),
    TimerText("Belch", _arg.tUnit, 12),
  }

  UnitCreated{ strUnitName = "unit.pustule",
    Icon("Pustule", _arg.tUnit) % (_arg.nUnitId),
  }
  UnitDestroyed{ strUnitName = "unit.pustule",
    -Icon("Pustule") % (_arg.nUnitId),
  }
  Event("CombatLogDamage", "tArg",
  { [_arg.tArg.unitTarget:GetName()] = "unit.pustule",
    -Icon("Pustule") % (_arg.tArg.unitTarget:GetId()),
  })

  local SPELL_NOXIOUS_BELCH = 69962
  Event("CombatLogDamage", "tArg", { [_arg.tArg.splCallingSpell] = {"~=", _arg(nil)},
    If{ [_arg.tArg.splCallingSpell:GetId()] = SPELL_NOXIOUS_BELCH, [_arg.tArg.unitCaster] = _arg.self:GetUnit("Boss"),
      Timer("Belch", 12),
      TimerText("Belch", _arg.self:GetUnit("Boss"), 12),
    }
  })
end)