local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("Ohmna", {
  instance = "Genetic Archives",
  displayName = "Ohmna",
  tTrigger = {
    sType = "ANY",
    tNames = {"unit.boss"},
    tZones = {
      [1] = {
        continentId = 67,
        parentZoneId = 147,
        mapId = 149,
      },
    },
  },
},{
  ["enUS"] = {
    -- Unit names.
    ["unit.boss"] = "Dreadphage Ohmna",
    ["unit.tentacle"] = "Tentacle of Ohmna",
    ["unit.mini_boss"] = "Ravenous Maw of the Dreadphage",
    -- Datachron messages.
    ["datachron.pillar_leech"] = "A plasma leech begins draining",
    ["datachron.submerge"] = "Dreadphage Ohmna submerges",
    ["datachron.bored_of_tank"] = "Dreadphage Ohmna is bored with",
    ["datachron.phase2_start"] = "The Archives tremble as Dreadphage Ohmna",
    ["datachron.phase3_start"] = "The Archives quake with the furious might",
    -- Objectifs.
    ["objective.north_core"] = "North Power Core Energy",
    ["objective.south_core"] = "South Power Core Energy",
    ["objective.east_core"] = "East Power Core Energy",
    ["objective.west_core"] = "West Power Core Energy",
    -- Cast.
    ["cast.knockback"] = "Erupt",
    ["cast.spew"] = "Genetic Torrent",
    ["cast.devour"] = "Devour",
    -- Bar and messages.
    ["alert.tentacles"] = "Tentacles",
    ["alert.phase2_soon"] = "P2 SOON !",
    ["alert.phase2"] = "P2: TENTACLES",
    ["alert.phase3_soon"] = "P3 SOON !",
    ["alert.phase3"] = "P3: RAVENOUS",
    ["alert.phase3_really_soon"] = "P3 REALLY SOON !",
    ["alert.switch_tank"] = "SWITCH TANK",
    ["alert.spew"] = "BIG SPEW",
    ["alert.interrupt"] = "Interrupt!!",

    ["timer.next_tentacles"] = "Next Tentacles",
    ["timer.next_switch_tank"] = "Next Switch Tank",
    ["timer.next_spew"] = "NEXT BIG SPEW",
    ["timer.pillar"] = "PILLAR %u : %s",

    ["cardinal.north"] = "N",
    ["cardinal.south"] = "S",
    ["cardinal.east"] = "E",
    ["cardinal.west"] = "W",

    ["label.pillar"] = "Pillar",
    ["label.knockback"] = "Knockback",
    ["label.phase_alert"] = "Phase Alerts",
    ["label.last_tentacles"] = "Last Phase Tentacles",
  },
  ["deDE"] = {
    -- Unit names.
    ["unit.boss"] = "Schreckensphage Ohmna",
    ["unit.tentacle"] = "Tentakel von Ohmna",
    ["unit.mini_boss"] = "Unersättliches Maul der Schreckensphage",
    -- Datachron messages.
    ["datachron.pillar_leech"] = "Ein Plasmaegel beginnt, den",
    ["datachron.submerge"] = "Die Schreckensphage Ohmna taucht in den",
    ["datachron.bored_of_tank"] = "Die Schreckensphage Ohmna langweilt sich",
    ["datachron.phase2_start"] = "Die Archive beben, als die Tentakeln der Schreckensphage Ohmna",
    ["datachron.phase3_start"] = "Die Archive beben unter der wütenden Macht der Schreckensphage",
    -- Objectifs.
    ["objective.north_core"] = "Nördliche Kraftkernenergie",
    ["objective.south_core"] = "Südliche Kraftkernenergie",
    ["objective.east_core"] = "Östliche Kraftkernenergie",
    ["objective.west_core"] = "Westliche Kraftkernenergie",
    -- Cast.
    ["cast.knockback"] = "Ausbrechen",
    ["cast.spew"] = "Genetische Strömung",
    ["cast.devour"] = "Verschlingen",
    -- Bar and messages.
    ["alert.tentacles"] = "TENTAKEL",
    ["alert.phase2_soon"] = "GLEICH PHASE 2 !",
    ["alert.phase2"] = "P2: TENTAKEL",
    ["alert.phase3_soon"] = "GLEICH PHASE 3 !",
    ["alert.phase3"] = "P3: GROßE WÜRMER",
    ["alert.phase3_really_soon"] = "17 % | VORSICHT MIT DAMAGE",
    ["alert.switch_tank"] = "TANKWECHSEL",
    ["alert.spew"] = "GROßES BRECHEN",
    ["alert.interrupt"] = "Unterbrechen!!",

    ["timer.next_tentacles"] = "NÄCHSTE TENTAKEL",
    ["timer.next_switch_tank"] = "Nächster Tankwechsel",
    ["timer.next_spew"] = "NÄCHSTES GROßES BRECHEN",
    ["timer.pillar"] = "SÄULE %u : %s",

    ["cardinal.north"] = "N",
    ["cardinal.south"] = "S",
    ["cardinal.east"] = "O",
    ["cardinal.west"] = "W",

    ["label.pillar"] = "Säule",
    ["label.knockback"] = "Knockback",
    ["label.phase_alert"] = "Phasen Warnungen",
    ["label.last_tentacles"] = "Tentakeln der Letzten Phase",
  },
  ["frFR"] = {
    -- Unit names.
    ["unit.boss"] = "Ohmna la Terriphage",
    ["unit.tentacle"] = "Tentacule d'Ohmna",
    ["unit.mini_boss"] = "Gueule vorace de la Terriphage",
    -- Datachron messages.
    ["datachron.pillar_leech"] = "Une Sangsue à plasma commence à vider la cellule énergétique",
    ["datachron.submerge"] = "Ohmna la Terriphage s'immerge dans les bassins de Biophage.",
    ["datachron.bored_of_tank"] = "(.*) n'amuse plus Ohmna la Terriphage !",
    ["datachron.phase2_start"] = "Les Archives tremblent alors que les tentacules d'Ohmna la Terriphage",
    ["datachron.phase3_start"] = "Les Archives tremblent sous la puissance terrible de la Terriphage.",
    -- Objectifs.
    ["objective.north_core"] = "Puissance de la cellule énergétique nord",
    ["objective.south_core"] = "Puissance de la cellule énergétique sud",
    ["objective.east_core"] = "Puissance de la cellule énergétique est",
    ["objective.west_core"] = "Puissance de la cellule énergétique ouest",
    -- Cast.
    ["cast.knockback"] = "Erupt",
    ["cast.spew"] = "Torrent génétique",
    ["cast.devour"] = "Devour", --need translation --spellid 90625
    -- Bar and messages.
    ["alert.tentacles"] = "Tentacules",
    ["alert.phase2_soon"] = "P2 SOON !",
    ["alert.phase2"] = "P2: TENTACULES",
    ["alert.phase3_soon"] = "P3 BIENTÔT !",
    ["alert.phase3"] = "P3: AFFAMÉ",
    ["alert.phase3_really_soon"] = "P3 RÉELLEMENT BIENTÔT !",
    ["alert.switch_tank"] = "CHANGEMENT TANK",
    ["alert.spew"] = "TORRENT",
    ["alert.interrupt"] = "Interrupt!!",

    ["timer.next_tentacles"] = "Prochaine Tentacules",
    ["timer.next_switch_tank"] = "Next Switch Tank",
    ["timer.next_spew"] = "PROCHAIN TORRENT",
    ["timer.pillar"] = "PILLIER %u : %s",

    ["cardinal.north"] = "N",
    ["cardinal.south"] = "S",
    ["cardinal.east"] = "E",
    ["cardinal.west"] = "W",

    ["label.pillar"] = "Pillier",
    ["label.knockback"] = "Knockback",
    ["label.phase_alert"] = "Phase Alerts",
    ["label.last_tentacles"] = "Last Phase Tentacles",
  },
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  Boss{
    label = "unit.boss",
    unit{},
  }
  Knockback{
    label = "label.knockback",
    line{color = "xkcdBlue"},
  }
  Bored{
    label = "timer.next_switch_tank",
    timer{},
  }
  Devour{
    label = "cast.devour",
    cast{},
    sound{file = "long", enable = false},
    alert{},
  }
  Pillar{
    label = "label.pillar",
    timer{},
  }
  Tentacles{
    label = "alert.tentacles",
    alert{},
    timer{},
    sound{file="info"},
  }
  LastTentacles{
    label = "label.last_tentacles",
    line{color = "ff0000ff"},
  }
  MiniBoss{
    label = "unit.mini_boss",
    unit{},
    text{font = "CRB_FloaterGigantic"},
  }
  PhaseAlert{
    label = "label.phase_alert",
    alert{},
    sound{file = "alert"},
  }
  Spew{
    label = "alert.spew",
    alert{},
    timer{},
    sound{file="run-away"},
  }
end, function(_arg, _env, _var) --luacheck: no unused args
  -- luacheck: no global


  local function fMax(tCores)
    local nMax, strConcat = -1, ""
    for strTxt, nLevel in pairs(tCores) do
      if nLevel > nMax and nLevel > 0 then
        nMax, strConcat = nLevel, strTxt
      elseif nLevel == nMax then
        strConcat = strConcat .. "/" .. strTxt
      end
    end
    return strConcat
  end

  local function fMin(tCores)
    local nMin, strConcat = 101, ""
    for strTxt, nLevel in pairs(tCores) do
      if nLevel < nMin and nLevel > 0 then
        nMin, strConcat = nLevel, strTxt
      elseif nLevel == nMin then
        strConcat = strConcat .. "/" .. strTxt
      end
    end
    return strConcat
  end

  local function fCalcCoreString(self, nCoreIdx)
    local bHighest = nCoreIdx%2 == 1

    local tCores = {}
    local tEvents = PublicEvent.GetActiveEvents()
    for _, peEvent in pairs(tEvents) do
      for _, peObjective in pairs(peEvent:GetObjectives()) do
        if peObjective:GetShortDescription() == self.L["objective.north_core"] then
          tCores[self.L["cardinal.north"]] = peObjective:GetCount()
        elseif peObjective:GetShortDescription() == self.L["objective.south_core"] then
          tCores[self.L["cardinal.south"]] = peObjective:GetCount()
        elseif peObjective:GetShortDescription() == self.L["objective.east_core"] then
          tCores[self.L["cardinal.east"]] = peObjective:GetCount()
        elseif peObjective:GetShortDescription() == self.L["objective.west_core"] then
          tCores[self.L["cardinal.west"]] = peObjective:GetCount()
        end
      end
    end
    if bHighest then
      return fMax(tCores)
    else
      return fMin(tCores)
    end
  end
  local strUpcomingCoreTargets = _arg(fCalcCoreString)(_arg.self, GetCount("Pillar"))
  local strUpcomingCoreText = _arg.self.L["timer.pillar"]:format(GetCount("Pillar")+1, strUpcomingCoreTargets)

  local nGameTime = _env.GameLib.GetGameTime()

  _var.bPhase3 = false -- 3HeadPhase
  _var.bPhase4 = false -- No Platforms
  _var.bWasSubmerged = false --the first Erupt after submerge defines some timers.
  Enable{
    Timer("Pillar", 17, strUpcomingCoreText),
    Timer("Pillar", 26, "timer.next_spew"),
    Timer("Bored", 45, "timer.next_switch_tank"),
  }

  UnitCreated{ strUnitName = "unit.boss", bInCombat = true, [_arg.self:HasUnit("Boss")] = false,
    Unit("Boss", _arg.tUnit),
    Line("Knockback", _arg.tUnit, 20) % ("Front") + {color = "ffff0000", nOffset = 13},
    Line("Knockback", _arg.tUnit, 20) % ("Left")  + {nRotation = -120, nOffset = 13},
    Line("Knockback", _arg.tUnit, 20) % ("Right") + {nRotation =  120, nOffset = 13},
  }

  _var.nLastTentacles = 0 --to not spam sounds/messages
  UnitCreated{ strUnitName = "unit.tentacle", [_var.bPhase4] = false, [_var.nLastTentacles] = {"<", nGameTime-2},
    _var.nLastTentacles(nGameTime),
    Alert("Tentacles", "alert.tentacles"),
    Timer("Tentacles", 20, "timer.next_tentacles"),
    Sound("Tentacles"),
  }
  UnitCreated{ strUnitName = "unit.tentacle", [_var.bPhase4] = true,
    Line("LastTentacles", _arg.tUnit, 10) % (_arg.nUnitId),
    Polygon("LastTentacles", _arg.tUnit, 10, 20) % (_arg.nUnitId),
  }

  UnitCreated{ strUnitName = "unit.mini_boss", --these are Phase3 3x Mini Ohmnas
    Line("Knockback", _arg.tUnit, 15) % (_arg.nUnitId) + {nOffset = 10},
    Unit("MiniBoss", _arg.tUnit) % (Count("MiniBoss")) + {strMark = GetCount("MiniBoss")},
    Text("MiniBoss", _arg.tUnit, GetCount("MiniBoss")) % (_arg.nUnitId),
    --Count returns 1 the first time its called with these args, 2 the second time, ...
  }

  UnitDestroyed{ strUnitName = "unit.mini_boss",
    _var.bPhase4(true),
    Line("Knockback", _arg.self:GetUnit("Boss"), 20) % ("Front") + {color = "ffff0000", nOffset = 10},
    Timer("Spew", 23, "timer.next_spew"),
  }

  HealthReached{ strUnitname = "unit.boss", nHealthReached = 52,
    Alert("PhaseAlert", "alert.phase2_soon"),
    Sound("PhaseAlert"),
  }
  HealthReached{ strUnitname = "unit.boss", nHealthReached = 20,
    Alert("PhaseAlert", "alert.phase3_soon"),
    Sound("PhaseAlert"),
  }
  HealthReached{ strUnitname = "unit.boss", nHealthReached = 17,
    Alert("PhaseAlert", "alert.phase3_really_soon"),
    Sound("PhaseAlert"),
  }

  CastStart{ strSpellName = "cast.knockback", [_var.bPhase3] = false,
    Timer("Bored", 45, "timer.next_switch_tank"),
    If{ [_var.bWasSubmerged] = true,
      Line("Knockback", _arg.tUnit, 20) % ("Front") + {color = "ffff0000", nOffset = 13},
      Line("Knockback", _arg.tUnit, 20) % ("Left")  + {nRotation = -120, nOffset = 13},
      Line("Knockback", _arg.tUnit, 20) % ("Right") + {nRotation =  120, nOffset = 13},
      Timer("Pillar", 32, strUpcomingCoreText)
    },
  }
  CastStart{ strSpellName = "cast.spew",
    Alert("Spew", "alert.spew"),
    Sound("Spew"),

    If{ [_var.bPhase4] = true,
      Timer("Spew", 40, "timer.next_spew")
    }/{
      Timer("Spew", 95, "timer.next_spew")
    },
  }

  Datachron{ strMessage = "datachron.pillar_leech", [_var.bPhase3] = false,
    Count("Pillar"),
    Timer("Pillar", 25, strUpcomingCoreText),
  }

  Datachron{ strMessage = "datachron.submerge",
    _var.bWasSubmerged(true),
    SetCount(0, "Pillar"),
    SetCount(0, "Bored"),
    Count("Submerge"),

    -Line("Knockback") % ("Front"),
    -Line("Knockback") % ("Left"),
    -Line("Knockback") % ("Right"),
    -Timer("Tentacles"),
    -Timer("Spew"),
    -Timer("Bored"),
  }

  Datachron{ strMessage = "datachron.bored_of_tank", [GetCount("Bored")] = 0,
    Count("Bored"),
    Timer("Bored", 42, "timer.next_switch_tank"),
  }

  Datachron{ strMessage = "datachron.phase2_start",
    Alert("PhaseAlert", "alert.phase2"),
    Sound("PhaseAlert"),
  }

  Datachron{ strMessage = "datachron.phase3_start",
    Alert("PhaseAlert", "alert.phase3"),
    Sound("PhaseAlert"),

    _var.bPhase3(true),
    -Line("Knockback") % ("Front"),
    -Line("Knockback") % ("Left"),
    -Line("Knockback") % ("Right"),

    -Timer("Pillar"),
    -Timer("Bored"),
    Timer("Spew", 45, "timer.next_spew")
  }

  CastStart{ strSpellName = "cast.devour", strUnitName = "unit.boss",
    Cast("Devour", _arg.tCast),
    Alert("Devour", "alert.interrupt"),
    Sound("Devour"),
  }


  local function fGetCloseMini(self)
    local v3OwnPos = Vector3.New(GameLib.GetPlayerUnit():GetPosition())

    local tClosest = nil
    local nRange = 1000
    for i = 1, 3, 1 do
      local tMini = self:GetUnit("MiniBoss", i)
      if tMini then
        local nDistance = (v3OwnPos - Vector3.New(tMini:GetPosition())):Length()
        if nDistance < nRange then
          tClosest = tMini
          nRange = nDistance
        end
      end
    end

    return tClosest
  end
  local tCloseMini = _arg(fGetCloseMini)(_arg.self)

  CastStart{ strSpellName = "cast.devour", strUnitName = "unit.mini_boss", [tCloseMini] = _arg.tUnit,
    Cast("Devour", _arg.tCast),
    Alert("Devour", "alert.interrupt"),
    Sound("Devour"),
  }
end)