local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("PhageCouncil", {
  instance = "Genetic Archives",
  displayName = "Phageborn Convergence",
  tTrigger = {
    sType = "ANY",
    tNames = {"unit.hammer", "unit.spider", "unit.fly", "unit.sword", "unit.frog"},
    tZones = {
      [1] = {
        continentId = 67,
        parentZoneId = 147,
        mapId = 149,
      },
    },
  },
},{
  ["enUS"] = {
    ["unit.hammer"] = "Golgox the Lifecrusher",
    ["unit.spider"] = "Terax Blightweaver",
    ["unit.fly"] = "Ersoth Curseform",
    ["unit.sword"] = "Noxmind the Insidious",
    ["unit.frog"] = "Fleshmonger Vratorg",
    -- Datachron messages.
    ["datachron.midphase"] = "The Phageborn Convergence begins gathering its power",
    ["datachron.equalize"] = "Noxmind the Insidious prepares to equalize the Convergence!",
    -- Cast.
    ["cast.midphase_target"] = "Teleport",
    ["cast.midphase_notarget"] = "Channeling Energy",
    ["cast.midphase_ongoing"] = "Gathering Energy",
    ["cast.heal"] = "Stitching Strain",
    -- Timer bars.
    ["timer.midphase"] = "Next midphase",
    ["timer.equalize"] = "Next equalization",
    ["timer.mid_timeout_hammer"] = "Midphase: Timeout 20 IA",
    ["timer.mid_timeout_spider"] = "Midphase: Timeout mini adds",
    ["timer.mid_timeout_fly"] = "Midphase: Timeout subdue",
    ["timer.mid_timeout_sword"] = "Midphase: Timeout pillars",
    ["timer.mid_timeout_frog"] = "Midphase: Timeout shield",
    -- Message bars.
    ["message.interrupt_heal"] = "Interrupt!",
    ["message.midphase_hammer"] = "Midphase: Hammer! (20 IA)",
    ["message.midphase_spider"] = "Midphase: Spider! (Mini adds)",
    ["message.midphase_fly"] = "Midphase: Fly! (Subdue)",
    ["message.midphase_sword"] = "Midphase: Sword! (Pillars)",
    ["message.midphase_frog"] = "Midphase: Frog! (Shield)",
    --Labels
    ["label.midphase_timeout"] = "Midphase Timeouts",
    ["label.wave"] = "Swords wave",
    ["label.interrupt_heal"] = "Interrupt heal",
    ["label.fly_midphase"] = "Ersoth (Flying) midphase circles",
    ["label.midphase"] = "Midphase",
  },
  ["deDE"] = {
    -- Unit names.
    ["unit.hammer"] = "Golgox der Lebensmalmer",
    ["unit.spider"] = "Terax Faulflechter",
    ["unit.fly"] = "Ersoth Fluchform",
    ["unit.sword"] = "Noxgeist der Hinterlistige",
    ["unit.frog"] = "Fleischwolf Vratorg",
    -- Datachron messages.
    ["datachron.midphase"] = "Die Konvergenz der Phagengeborenen sammelt ihre Macht",
    ["datachron.equalize"] = "Noxgeist der Hinterlistige bereitet sich vor, die Konvergenz zu egalisieren!",
    -- Cast.
    ["cast.midphase_target"] = "Teleportieren",
    ["cast.midphase_notarget"] = "Energie kanalisieren",
    ["cast.midphase_ongoing"] = "Energie sammeln",
    ["cast.heal"] = "Mit Transmutation anstecken", --from SpellID 57412
    -- Timer bars.
    ["timer.midphase"] = "Nächste Mittelphase",
    ["timer.equalize"] = "Nächstes Ausgleichen",
    ["timer.mid_timeout_hammer"] = "Mittelphase: Timeout 20 IA",
    ["timer.mid_timeout_spider"] = "Mittelphase: Timeout kleine Adds",
    ["timer.mid_timeout_fly"] = "Mittelphase: Timeout Entwaffnungen",
    ["timer.mid_timeout_sword"] = "Mittelphase: Timeout Säulen",
    ["timer.mid_timeout_frog"] = "Mittelphase: Timeout Schild",
    -- Message bars.
    ["message.interrupt_heal"] = "Unterbreche!",
    ["message.midphase_hammer"] = "Mittelphase: Hammer! (20 IA)",
    ["message.midphase_spider"] = "Mittelphase: Spinne! (Kleine Adds)",
    ["message.midphase_fly"] = "Mittelphase: Flieger! (Entwaffnungen)",
    ["message.midphase_sword"] = "Mittelphase: Schwert! (Säulen)",
    ["message.midphase_frog"] = "Mittelphase: Frosch! (Schild)",
    --Labels
    ["label.midphase_timeout"] = "Mittelphasen Timeouts",
    ["label.wave"] = "Schwerts Welle",
    ["label.interrupt_heal"] = "Heilung unterbrechen",
    ["label.fly_midphase"] = "Ersoth (Flieger) Mittelphasen-Kreise",
    ["label.midphase"] = "Mittelphase",
  },
  ["frFR"] = {
    -- Unit names.
    ["unit.hammer"] = "Golgox le Fossoyeur",
    ["unit.spider"] = "Terax Tisserouille",
    ["unit.fly"] = "Ersoth le Maudisseur",
    ["unit.sword"] = "Toxultime l'Insidieux",
    ["unit.frog"] = "Vratorg le Cannibale",
    -- Datachron messages.
    ["datachron.midphase"] = "La Convergence néophage commence à rassembler son énergie !",
    ["datachron.equalize"] = "Toxultime l'Insidieux se prépare à égaliser la Convergence !",
    -- Cast.
    ["cast.midphase_target"] = "Se téléporter",
    ["cast.midphase_notarget"] = "Canalisation d'énergie",
    ["cast.midphase_ongoing"] = "Accumulation d'énergie",
    ["cast.heal"] = "Pression de suture",
    -- Timer bars.
    ["timer.midphase"] = "Prochaine P2",
    ["timer.equalize"] = "Prochaine égalisation",
    ["timer.mid_timeout_hammer"] = "P2: Timeout 20 IA",
    ["timer.mid_timeout_spider"] = "P2: Timeout mini adds",
    ["timer.mid_timeout_fly"] = "P2: Timeout désarmement",
    ["timer.mid_timeout_sword"] = "P2: Timeout pilliers",
    ["timer.mid_timeout_frog"] = "P2: Timeout bouclier",
    -- Message bars.
    ["message.interrupt_heal"] = "INTÉRROMPRE TERAX !",
    ["message.midphase_hammer"] = "Phase 2: GOLGOX! (20 IA)",
    ["message.midphase_spider"] = "Phase 2: TERAX! (Mini adds)",
    ["message.midphase_fly"] = "Phase 2: ERSOTH! (Désarmement)",
    ["message.midphase_sword"] = "Phase 2: TOXULTIME! (Pilliers)",
    ["message.midphase_frog"] = "Phase 2: VRATORG! (Bouclier)",
    --Labels
    ["label.midphase_timeout"] = "Midphase Timeouts",
    ["label.wave"] = "Swords wave",
    ["label.interrupt_heal"] = "Interrupt heal",
    ["label.fly_midphase"] = "Ersoth (Flying) midphase circles",
    ["label.midphase"] = "Midphase",
  },
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  Hammer{
    label = "unit.hammer",
    unit{},
  }
  Spider{
    label = "unit.spider",
    unit{},
  }
  Fly{
    label = "unit.fly",
    unit{},
    line{color = false, thickness = 3, label = "label.fly_midphase"},
  }
  Sword{
    label = "unit.sword",
    unit{},
  }
  Frog{
    label = "unit.frog",
    unit{},
  }

  Wave{
    label = "label.wave",
    line{thickness = 4, color = "ff00ff00"},
  }
  Equalize{
    label = "timer.equalize",
    timer{color = "ffc071fe"},
  }
  Heal{
    label = "label.interrupt_heal",
    sound{file = "alert"},
    alert{color = "ffff0000"}
  }
  Midphase{
    label = "label.midphase",
    timer{color = "ff703be7"},
    alert{color = "ff0000ff"},
    sound{file = "alert"},
  }


end, function(_arg, _env, _var) --luacheck: no unused args
  -- luacheck: no global

  --## Hammer ##
  UnitCreated{ strUnitName = "unit.hammer", bInCombat = true, [_arg.self:GetUnit("Hammer")] = _arg.Nil,
    Unit("Hammer", _arg.tUnit),
  }
  CastStart{ strSpellName = "cast.midphase_target", strUnitName = "unit.hammer",
    Alert("Midphase", "message.midphase_hammer"),
  }

  --## Spider ##
  UnitCreated{ strUnitName = "unit.spider", bInCombat = true, [_arg.self:GetUnit("Spider")] = _arg.Nil,
    Unit("Spider", _arg.tUnit),
  }
  CastStart{ strSpellName = "cast.midphase_target", strUnitName = "unit.spider",
    Alert("Midphase", "message.midphase_spider"),
  }
  CastStart{ strSpellName = "cast.heal", [_arg.self:InRange(_arg.tUnit, 35)] = true,
    Sound("Heal"),
    Alert("Heal", "message.interrupt_heal"),
  }

  --## Fly ##
  UnitCreated{ strUnitName = "unit.fly", bInCombat = true, [_arg.self:GetUnit("Fly")] = _arg.Nil,
    Unit("Fly", _arg.tUnit),
  }
  CastStart{ strSpellName = "cast.midphase_target", strUnitName = "unit.fly",
    Alert("Midphase", "message.midphase_fly"),
  }
  CastStart{ strSpellName = "cast.midphase_ongoing", strUnitName = "unit.fly",
    Polygon("Fly", _arg.tUnit, 10, 20) % ("Circle10") + {color = "red"},
    Polygon("Fly", _arg.tUnit, 20, 20) % ("Circle20") + {color = "xkcdOrangeyRed"},
    Polygon("Fly", _arg.tUnit, 30, 20) % ("Circle30") + {color = "xkcdOrange"},
  }
  CastEnd{ strSpellName = "cast.midphase_ongoing", strUnitName = "unit.fly",
    -Polygon("Fly") % ("Circle10"),
    -Polygon("Fly") % ("Circle20"),
    -Polygon("Fly") % ("Circle30"),
  }

  --## Sword ##
  UnitCreated{ strUnitName = "unit.sword", bInCombat = true, [_arg.self:GetUnit("Sword")] = _arg.Nil,
    Unit("Sword", _arg.tUnit),
    Timer("Equalize", 31.5),
  }
  CastStart{ strSpellName = "cast.midphase_target", strUnitName = "unit.sword",
    Alert("Midphase", "message.midphase_sword"),
  }
  UnitCreated{ strUnitName = "unit.sword", bInCombat = false,
    If{ [_arg.self:HasUnit("Sword")] = true,
    --only if we already found the Sword-Boss (prevent line appear on actual boss)
      Line("Wave", _arg.tUnit, 45) % (_arg.nUnitId) + {nOffset = 5}
    },
  }
  UnitDestroyed{ strUnitName = "unit.sword",
    -Line("Wave") % (_arg.nUnitId),
  }
  Datachron{ strMessage = "datachron.midphase",
    _var.bAnotherEqualize(true),
    -Timer("Equalize"),
  }
  _var.bAnotherEqualize = true
  CastEnd{ strSpellName = "cast.midphase_notarget", [_arg.self:HasUnit("Sword")] = true,
    Timer("Equalize", 5),
  }
  Datachron{ strMessage = "datachron.equalize", [_var.bAnotherEqualize] = true,
    _var.bAnotherEqualize(false),
    Timer("Equalize", 37)
  }

  --## Frog ##
  UnitCreated{ strUnitName = "unit.frog", bInCombat = true, [_arg.self:GetUnit("Frog")] = _arg.Nil,
    Unit("Frog", _arg.tUnit),
  }
  CastStart{ strSpellName = "cast.midphase_target", strUnitName = "unit.frog",
    Alert("Midphase", "message.midphase_frog"),
  }

  --## General Midphase ##
  Enable{
    Timer("Midphase", 87),
  }
  CastStart{strSpellName = "cast.midphase_target",
    Timer("Midphase", 29.5),
    Sound("Midphase"),
  }
  CastEnd{ strSpellName = "cast.midphase_ongoing",
    -Timer("Midphase"),
  }
  CastEnd{ strSpellName = "cast.midphase_notarget",
    Timer("Midphase", 60),
  }
end)