local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("Prototypes", {
  instance = "Genetic Archives",
  displayName = "Phagetech Prototypes",
  tTrigger = {
    sType = "ANY",
    tNames = {"unit.commander", "unit.augmentor", "unit.protector", "unit.fabricator"},
    tZones = {
      [1] = {
        continentId = 67,
        parentZoneId = 147,
        mapId = 149,
      },
    },
  },
},{
  ["enUS"] = {
    -- Unit names.
    ["unit.commander"] = "Phagetech Commander",
    ["unit.augmentor"] = "Phagetech Augmentor",
    ["unit.protector"] = "Phagetech Protector",
    ["unit.fabricator"] = "Phagetech Fabricator",
    -- Datachron messages.
    ["datachron.commander"] = "Phagetech Commander is now active!",
    ["datachron.augmentor"] = "Phagetech Augmentor is now active!",
    ["datachron.protector"] = "Phagetech Protector is now active!",
    ["datachron.fabricator"] = "Phagetech Fabricator is now active!",
    -- Cast.
    ["cast.repairbot"] = "Summon Repairbot",
    ["cast.destructbot"] = "Summon Destructobot",
    ["cast.forced_production"] = "Forced Production",
    -- Bar and messages.
    ["message.phase1"] = "[1] LINK + KICK",
    ["message.phase2"] = "[2] TP + CROSS + BOTS",
    ["message.phase3"] = "[3] SINGULARITY + WAVES",
    ["message.phase4"] = "[4] SOAK + BOTS",
    ["message.bots"] = "BOTS !!",
    ["message.enrage"] = "BERSERK",
    ["message.singularity"] = "Singularity",

    ["alert.interrupt"] = "Interrupt!",
    --Labels
    ["label.phase_switch"] = "Phase switches",
    ["label.bots"] = "Bots",
  },
  ["deDE"] = {
    -- Unit names.
    ["unit.commander"] = "Phagentech-Kommandant",
    ["unit.augmentor"] = "Phagentech-Augmentor",
    ["unit.protector"] = "Phagentech-Protektor",
    ["unit.fabricator"] = "Phagentech-Fabrikant",
    -- Datachron messages.
    ["datachron.commander"] = "Phagentech-Kommandant ist jetzt aktiv!",
    ["datachron.augmentor"] = "Phagentech-Augmentor ist jetzt aktiv!",
    ["datachron.protector"] = "Phagentech-Protektor ist jetzt aktiv!",
    ["datachron.fabricator"] = "Phagentech-Fabrikant ist jetzt aktiv!",
    -- Cast.
    ["cast.repairbot"] = "Reparaturbot herbeirufen",
    ["cast.destructbot"] = "Destruktobot herbeirufen",
    ["cast.forced_production"] = "Erzwungene Produktion",
    -- Bar and messages.
    ["message.phase1"] = "[1] VERBINDUNG + KICK",
    ["message.phase2"] = "[2] FARBEN + KREUZ + REPARATURBOTS",
    ["message.phase3"] = "[3] SINGULARITÄT + WELLEN",
    ["message.phase4"] = "[4] KREISE + DESTRUKTOBOTS",
    ["message.bots"]= "BOTS !!",
    ["message.enrage"] = "BERSERK",
    ["message.singularity"] = "SINGULARITÄT",

    ["alert.interrupt"] = "Unterbrechen!",
    --Labels
    ["label.phase_switch"] = "Phasenwechsel",
    ["label.bots"] = "Bots",
  },
  ["frFR"] = {
    -- Unit names.
    ["unit.commander"] = "Commandant technophage",
    ["unit.augmentor"] = "Augmenteur technophage",
    ["unit.protector"] = "Protecteur technophage",
    ["unit.fabricator"] = "Fabricant technophage",
    -- Datachron messages.
    ["datachron.commander"] = "Commandant technophage est désormais en activité !",
    ["datachron.augmentor"] = "Augmenteur technophage est désormais en activité !",
    ["datachron.protector"] = "Protecteur technophage est désormais en activité !",
    ["datachron.fabricator"] = "Fabricant technophage est désormais en activité !",
    -- Cast.
    ["cast.repairbot"] = "Déployer Bricobot",
    ["cast.destructbot"] = "Déployer Destructobot",
    ["cast.forced_production"] = "Forced Production", --need translation
    -- Bar and messages.
    ["message.phase1"] = "[1] LIEN + KICK",
    ["message.phase2"] = "[2] TP + CROIX + BOTS",
    ["message.phase3"] = "[3] SINGULARITÉ + VAGUE",
    ["message.phase4"] = "[4] SOAK + BOTS",
    ["message.bots"] = "BOTS !!",
    ["message.enrage"] = "BERSERK",
    ["message.singularity"] = "Singularité",

    ["alert.interrupt"] = "Interrupt!",
    --Labels
    ["label.phase_switch"] = "Phase switches",
    ["label.bots"] = "Bots",
  },
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  Commander{
    label = "unit.commander",
    unit{position = 1},
  }
  Augmentor{
    label = "unit.augmentor",
    unit{position = 2},
  }
  Protector{
    label = "unit.protector",
    unit{position = 3},
  }
  Fabricator{
    label = "unit.fabricator",
    unit{position = 4},
  }
  Bots{
    label = "label.bots",
    alert{},
    sound{file = "alert"},
    timer{},
  }
  Enrage{
    label = "message.enrage",
    timer{},
  }
  PhaseSwitch{
    label = "label.phase_switch",
    timer{},
  }
  Singularity{
    label = "message.singularity",
    timer{},
  }
  Production{
    label = "cast.forced_production",
    cast{},
    alert{},
    sound{file="info"},
  }

end, function(_arg, _env, _var) --luacheck: no unused args
  -- luacheck: no global

  UnitCreated{ strUnitName = "unit.commander", bInCombat = true, [_arg.self:HasUnit("Commander")] = false,
    Unit("Commander", _arg.tUnit),
  }
  UnitCreated{ strUnitName = "unit.augmentor", bInCombat = true, [_arg.self:HasUnit("Augmentor")] = false,
    Unit("Augmentor", _arg.tUnit),
  }
  UnitCreated{ strUnitName = "unit.protector", bInCombat = true, [_arg.self:HasUnit("Protector")] = false,
    Unit("Protector", _arg.tUnit),
  }
  UnitCreated{ strUnitName = "unit.fabricator", bInCombat = true, [_arg.self:HasUnit("Fabricator")] = false,
    Unit("Fabricator", _arg.tUnit),
  }
  CastStart{ strSpellName = {"cast.repairbot", "cast.destructbot"},
    Alert("Bots", "message.bots"),
    Sound("Bots"),
  }

  _var.bInitial = true
  Datachron{ strMessage = "datachron.commander",
    If{ [_var.bInitial] = true,
      _var.bInitial(false),
      Timer("Enrage", 585),
      Timer("PhaseSwitch", 20, "message.phase2")
    }/{
      Timer("PhaseSwitch", 60, "message.phase2")
    },
  }

  Datachron{ strMessage = "datachron.augmentor",
    Timer("PhaseSwitch", 60, "message.phase3"),
  }
  Datachron{ strMessage = "datachron.protector",
    Timer("PhaseSwitch", 60, "message.phase4"),
    Timer("Singularity", 5),
  }
  Datachron{ strMessage = "datachron.fabricator",
    Timer("PhaseSwitch", 60, "message.phase1"),
  }

  CastStart{ strSpellName = "cast.forced_production", [InRange(_arg.tUnit, 30)] = true,
    Cast("Production", _arg.tCast),
    Alert("Production", "alert.interrupt"),
    Sound("Production"),
  }
end)