local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("Engineers", {
  instance = "Redmoon Terror",
  displayName = "Engineers",
  tTrigger = {
    sType = "ANY",
    tNames = {"unit.boss_gun", "unit.boss_sword"},
    tZones = {
      [1] = {
        continentId = 104,
        parentZoneId = 548,
        mapId = 552,
      },
    },
  },
},{
  ["enUS"] = {
    -- Units
    ["unit.boss_gun"] = "Head Engineer Orvulgh",
    ["unit.boss_sword"] = "Chief Engineer Wilbargh",
    ["unit.fusion_core"] = "Fusion Core",
    ["unit.lubricant_nozzle"] = "Lubricant Nozzle",
    ["unit.spark_plug"] = "Spark Plug",
    ["unit.cooling_turbine"] = "Cooling Turbine",
    ["unit.circle_telegraph"] = "Hostile Invisible Unit for Fields (1.2 hit radius)",
    -- Debuffs
    ["debuff.atomic_attraction"] = "Atomic Attraction",
    ["debuff.electroshock_vulnerability"] = "Electroshock Vulnerability",
    -- Casts
    ["cast.electroshock"] = "Electroshock",
    ["cast.liquidate"] = "Liquidate",
    ["cast.rocket_jump"] = "Rocket Jump",
    -- Alerts
    ["alert.liquidate"] = "Liquidate!",
    ["alert.electroshock"] = "Electroshock!",
    ["alert.atomic_attraction"] = "Atomic Attraction on ",
    ["alert.atomic_attraction_player"] = "Kite the Orb!",
    ["alert.vulnerability"] = " swap to SWORD!",
    ["alert.vulnerability_player"] = "SWAP TO SWORD!",
    ["alert.sword_jump"] = "Sword is leaving ",
    ["alert.gun_jump"] = "Gun is leaving ",
    ["alert.gun_return"] = "RETURN TO GUN!",
    ["alert.pillar"] = " at 20%!",
    -- Datachron
    ["datachron.electroshock"] = "(.*) suffers from Electroshock",
    -- Labels
    ["label.pillar"] = "Pillar",
    ["label.pillar_warning"] = "20% Health Warning",
    ["label.pillar_health"] = "Pillar Health",
    ["label.circle_telegraph"] = "Circle Telegraphs",
    ["label.sword_jump"] = "Sword Rocket Jump",
    ["label.gun_jump"] = "Gun Rocket Jump",
    ["label.gun_return"] = "Return to Gun Reminder",
  },
  ["deDE"] = {
      -- Units
    ["unit.boss_gun"] = "Head Engineer Orvulgh", -- V
    ["unit.boss_sword"] = "Chief Engineer Wilbargh", -- V
    ["unit.fusion_core"] = "Fusion Core", -- V
    ["unit.lubricant_nozzle"] = "Lubricant Nozzle", -- V
    ["unit.spark_plug"] = "Spark Plug", -- V
    ["unit.cooling_turbine"] = "Cooling Turbine", -- V
    ["unit.circle_telegraph"] = "Feindselige unsichtbare Einheit für Felder (Trefferradius 1.2)",
    -- Debuffs
    ["debuff.atomic_attraction"] = "Atomic Attraction",
    ["debuff.electroshock_vulnerability"] = "Electroshock Vulnerability",
    -- Casts
    ["cast.electroshock"] = "Electroshock",
    ["cast.liquidate"] = "Liquidate",
    ["cast.rocket_jump"] = "Rocket Jump",
    -- Alerts
    ["alert.liquidate"] = "Liquidate!",
    ["alert.electroshock"] = "Elektroschock!",
    ["alert.atomic_attraction"] = "Feuerball auf ",
    ["alert.atomic_attraction_player"] = "Zieh den Feuerball!",
    ["alert.vulnerability"] = " zum SCHWERT!",
    ["alert.vulnerability_player"] = "WECHSEL ZUM SCHWERT!",
    ["alert.sword_jump"] = "Schwert verlässt ",
    ["alert.gun_jump"] = "Kanone verlässt ",
    ["alert.gun_return"] = "ZURÜCK ZUR KANONE!",
    ["alert.pillar"] = " auf 20%!",
    -- Datachron
    ["datachron.electroshock"] = '(.*) leidet unter .Elektroschock.',
    -- Labels
    ["label.pillar"] = "Säule",
    ["label.pillar_warning"] = "20% Lebens Warnung",
    ["label.pillar_health"] = "Säulen Leben",
    ["label.circle_telegraph"] = "Kreis Telegrafen",
    ["label.sword_jump"] = "Schwert: Raketensprung",
    ["label.gun_jump"] = "Kanone: Raketensprung",
    ["label.gun_return"] = "Erinnerung: Zurück zur Kanone",
},
  ["frFR"] = {
    -- Units
    ["unit.boss_gun"] = "Head Engineer Orvulgh", --V (Verified)
    ["unit.boss_sword"] = "Chief Engineer Wilbargh", --V
    ["unit.fusion_core"] = "Fusion Core", --V
    ["unit.lubricant_nozzle"] = "Lubricant Nozzle", --V
    ["unit.spark_plug"] = "Spark Plug", --V
    ["unit.cooling_turbine"] = "Cooling Turbine", --V
    ["unit.circle_telegraph"] = "Hostile Invisible Unit for Fields (1.2 hit radius)",
    -- Debuffs
    ["debuff.atomic_attraction"] = "Atomic Attraction", --V
    ["debuff.electroshock_vulnerability"] = "Electroshock Vulnerability",
    -- Casts
    ["cast.electroshock"] = "Electroshock", --V
    ["cast.liquidate"] = "Liquidate", --V
    ["cast.rocket_jump"] = "Rocket Jump", --V
    -- Alerts
    ["alert.liquidate"] = "Liquidation !",
    ["alert.electroshock"] = "Électrochoc !",
    ["alert.atomic_attraction"] = "Attraction Atomique sur ",
    ["alert.atomic_attraction_player"] = "Tu dois kitter l'orbe !",
    ["alert.vulnerability"] = " va sur l'ÉPÉE !",
    ["alert.vulnerability_player"] = "GO SUR L'ÉPÉE !",
    ["alert.sword_jump"] = "Épée quitte ",
    ["alert.gun_jump"] = "Fusil quitte ",
    ["alert.gun_return"] = "RETOURNE SUR LE FUSIL !",
    ["alert.pillar"] = " à 20% !",
    -- Datachron
    ["datachron.electroshock"] = "(.*) souffre de Electroshock", --V
    -- Labels
    ["label.pillar"] = "Pilier",
    ["label.pillar_warning"] = "Attention, vie à 20%",
    ["label.pillar_health"] = "Vie du Pilier",
    ["label.circle_telegraph"] = "Télégraphes Circulaire",
    ["label.sword_jump"] = "Saut Roquette de l'Epée",
    ["label.gun_jump"] = "Saut Roquette du Fusil",
    ["label.gun_return"] = "Rappel : Retour sur le Fusil",
  },
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global

  GunBoss{
    label = "unit.boss_gun",
    unit{color = "afafafaf"},
    line{thickness = 10, color = "ffff0000"},
  }
  SwordBoss{
    label = "unit.boss_sword",
    unit{color = "afafafaf"},
    line{thickness = 7, color = "ffff0000"},
  }

  GunJump{
    label = "label.gun_jump",
    cast{enable = false},
    alert{},
    sound{file = "info"},
  }
  SwordJump{
    label = "label.sword_jump",
    cast{enable = false},
    alert{},
    sound{file = "info"},
  }

  Electroshock{
    label = "cast.electroshock",
    timer{color = "ff00bfff"},
    alert{},
    sound{file = "info"},
    text{color = "ff00bfff"},
  }
  Vulnerability{
    label = "debuff.electroshock_vulnerability",
    alert{},
    text{color = "ff40e0d0"},
  }

  Liquidate{
    label = "cast.liquidate",
    timer{color = "ffffa500"},
    alert{},
    sound{},
    text{color = "ffffa500"},
  }

  Pillar{
    label = "label.pillar",
    unit{},
    text{color = false},
    sound{file = "alert"},
    alert{},
  }

  Circle{
    label = "label.circle_telegraph",
    line{thickness = 7, color = "ffff0000"}
  }

  Attraction{
    label = "debuff.atomic_attraction",
    timer{color = "ffff0000"},
    sound{file = "run-away"},
    aura{sprite = "LUIBM_meteor3", color = "ffff0000"},
    alert{},
    text{color = "ffff0000"},
  }
end, function(_arg, _env, _var) --luacheck: no unused args
  -- luacheck: no global

  local PLATFORM_BOUNDING_BOXES = {
    x = 374.71,
    z = -893.52,
    [0] = "unit.fusion_core", --less in x, less in z
    [1] = "unit.lubricant_nozzle", --greater in x, less in z
    [2] = "unit.cooling_turbine", --less in x, greater in z
    [3] = "unit.spark_plug", --greater in x, greater in z
  }

  local function fGetPlatform(tUnit)
    local loc = tUnit:GetPosition()
    if not loc then return nil end
    local idx = 0
    if loc.x > PLATFORM_BOUNDING_BOXES.x then
      idx = idx + 1
    end
    if loc.z > PLATFORM_BOUNDING_BOXES.z then
      idx = idx + 2
    end

    return PLATFORM_BOUNDING_BOXES[idx]
  end


  UnitCreated{ strUnitName = "unit.boss_gun", bInCombat = true, [_arg.self:HasUnit("GunBoss")] = false,
    Unit("GunBoss", _arg.tUnit),
    Line("GunBoss", _arg.tUnit, 30),

    Timer("Electroshock", 11),
    TimerText("Electroshock", _arg.tUnit, 11),
  }
  UnitCreated{ strUnitName = "unit.boss_sword", bInCombat = true, [_arg.self:HasUnit("SwordBoss")] = false,
    Unit("SwordBoss", _arg.tUnit),
    Line("SwordBoss", _arg.tUnit, 15) % ("CleaveA") + {nRotation = -50, tVectorOffsets = Vector3.New( 2, 0,-1.5)},
    Line("SwordBoss", _arg.tUnit, 15) % ("CleaveB") + {nRotation =  50, tVectorOffsets = Vector3.New(-2, 0,-1.5)},

    Timer("Liquidate", 12),
    TimerText("Liquidate", _arg.tUnit, 12),
  }

  UnitCreated{ strUnitName = {"unit.fusion_core", "unit.lubricant_nozzle", "unit.spark_plug", "unit.cooling_turbine"},
    Unit("Pillar", _arg.tUnit) % (_arg.nUnitId),
    HealthText("Pillar", _arg.tUnit) % (_arg.nUnitId) + {nOffset = 50, fUpdate = function(_, tDraw)
      local fHealth = tDraw.tOrigin:GetHealth() / tDraw.tOrigin:GetMaxHealth()
      if fHealth > 0.2 then
        tDraw.wnd:SetTextColor("ffadff2f")
      elseif fHealth > 0.15 then
        tDraw.wnd:SetTextColor("ffff8c00")
      else
        tDraw.wnd:SetTextColor("ffff0000")
      end
    end},
  }

  -- Pillar 20% Warning:
  _var.strWarnedPillar = nil
  _var.tPlayerUnit = _env.GameLib.GetPlayerUnit()
  HealthChanged{
    strUnitName = _arg(fGetPlatform)(_var.tPlayerUnit),
    nHealthPercent = {"<", 20},
    [_var.strWarnedPillar] = {"~=", _arg.strUnitName},

    _var.strWarnedPillar(_arg.strUnitName),
    Sound("Pillar"),
    Alert("Pillar", _arg.strUnitName .. _arg.self.L["alert.pillar"]),
  }

  UnitCreated{ strUnitName = "unit.circle_telegraph",
    Polygon("Circle", _arg.tUnit, 6.3, 20) % (_arg.nUnitId) + {nDuration = 3},
  }

  UnitDestroyed{ strUnitName = "unit.circle_telegraph",
    -Polygon("Circle") % (_arg.nUnitId),
  }

  local DEBUFF_ELECTROSHOCK_VULNERABILITY = 83798
  BuffAdded{ nSpellId = DEBUFF_ELECTROSHOCK_VULNERABILITY,
    TimerText("Vulnerability", _arg.tUnit, _arg.nDuration) % (_arg.nUnitId),
    If{ [_arg.tUnit:IsThePlayer()] = true,
      Alert("Vulnerability", "alert.vulnerability_player")
    }/{
      Alert("Vulnerability", _arg.strUnitName .. _arg.self.L["alert.vulnerability"])
    },
  }
  BuffRemoved{ nSpellId = DEBUFF_ELECTROSHOCK_VULNERABILITY,
    -TimerText("Vulnerability") % (_arg.nUnitId),
    If{ [_arg.tUnit:IsThePlayer()] = true,
      Alert("Vulnerability", "alert.gun_return")
    },
  }

  local DEBUFF_ATOMIC_ATTRACTION = 84053
  BuffAdded{ nSpellId = DEBUFF_ATOMIC_ATTRACTION,
    Timer("Attraction", 23),
    If{ [_arg.tUnit:IsThePlayer()] = true,
      Sound("Attraction"),
      Aura("Attraction", 15),
      Alert("Attraction", "alert.atomic_attraction_player")
    }/{
      Alert("Attraction", _arg.self.L["alert.atomic_attraction"].._arg.strUnitName),
      TimerText("Attraction", _arg.tUnit, 15)
    },
  }
  BuffRemoved{ nSpellId = DEBUFF_ATOMIC_ATTRACTION,
    -TimerText("Attraction"),
    -Aura("Attraction"),
  }
  local BUFF_INSULATION = 83987
  BuffRemoved{ nSpellId = BUFF_INSULATION, strUnitName = "unit.fusion_core",
    Timer("Attraction", 23),
  }

  CastStart{ strSpellName = "cast.rocket_jump", strUnitName = "unit.boss_sword",
    Cast("SwordJump", _arg.tCast),
    Sound("SwordJump"),
    Alert("SwordJump", _arg.self.L["alert.sword_jump"] .. _arg.self.L[_arg(fGetPlatform)(_arg.tUnit)]),
    Timer("Liquidate", 10),
    TimerText("Liquidate", _arg.tUnit, 10),
  }
  CastStart{ strSpellName = "cast.rocket_jump", strUnitName = "unit.boss_gun",
    Cast("GunJump", _arg.tCast),
    Sound("GunJump"),
    Alert("GunJump", _arg.self.L["alert.gun_jump"] .. _arg.self.L[_arg(fGetPlatform)(_arg.tUnit)]),
    Timer("Electroshock", 14),
    TimerText("Electroshock", _arg.tUnit, 14),
  }

  CastStart{
    strSpellName = "cast.electroshock",
    [_arg(fGetPlatform)(_var.tPlayerUnit)] = _arg(fGetPlatform)(_arg.tUnit),

    Alert("Electroshock", "alert.electroshock"),
    Sound("Electroshock"),
  }
  CastStart{
    strSpellName = "cast.liquidate",
    [_arg(fGetPlatform)(_var.tPlayerUnit)] = _arg(fGetPlatform)(_arg.tUnit),

    Alert("Liquidate", "alert.liquidate"),
    Sound("Liquidate"),
  }


  CastEnd{ strSpellName = "cast.electroshock",
    Timer("Electroshock", 18.5),
    TimerText("Electroshock", _arg.tUnit, 18.5),
  }
  CastEnd{ strSpellName = "cast.liquidate",
    Timer("Liquidate", 21.5),
    TimerText("Liquidate", _arg.tUnit, 21.5),
  }

end)
