local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("Laveka", {
  instance = "Redmoon Terror",
  displayName = "Laveka the Dark-Hearted",
  tTrigger = {
    sType = "ANY",
    tNames = {"unit.boss"},
    tZones = {
			[1] = {
				continentId = 104,
				parentZoneId = 548,
				mapId = 559,
			},
			[2] = {
				continentId = 104,
				parentZoneId = 0,
				mapId = 548,
			},
    },
  },
},{
	["enUS"] = {
		-- Units
		["unit.boss"] = "Laveka the Dark-Hearted",
		["unit.titan"] = "Risen Titan",
		["unit.boneclaw"] = "Risen Boneclaw",
		["unit.apparition"] = "Tortured Apparition",
		["unit.lost_soul"] = "Lost Soul",
		["unit.circle_telegraph"] = "Hostile Invisible Unit for Fields (0 hit radius)", -- Same name as Field Probes etc
		["unit.essence_void"] = "Essence Void",
    ["unit.orb"] = "Soul Eater",
		-- Casts
		["cast.devour_souls"] = "Devour Souls",
		["cast.essence_void"] = "Essence Void",
		["cast.expulsion_of_souls"] = "Expulsion of Souls",
		["cast.essence_surge"] = "Essence Surge",
		["cast.cacophony_of_souls"] = "Cacophony of Souls",
		-- Debuffs
		["debuff.necrotic_breath"] = "Necrotic Breath",
		["debuff.barrier_of_souls"] = "Barrier of Souls",
		["debuff.soul_eater"] = "Soul Eater",
		["debuff.boneclaw_gaze"] = "Boneclaw Gaze",
		["debuff.expulsion_of_souls"] = "Expulsion of Souls",
		["debuff.soulfire"] = "Soulfire",
		["debuff.realm_of_the_dead"] = "Realm of the Dead",
		["debuff.spirit_of_soulfire"] = "Spirit of Soulfire",
		-- Alert
		["alert.adds_debuff"] = "You are targeted by adds!",
		["alert.soulfire_debuff"] = "You have dot!",
		["alert.hex_debuff_self"] = "You are targeted by Hex!",
		["alert.hex_debuff"] = "Hex on %s",
		["alert.clone_spawn"] = "You can teleport",
		["alert.interrupt_essence"] = "Interrupt Essence %d!!",
		["alert.midphase"] = "Midphase!",
		["alert.last_phase"] = "Last Phase!",
		["alert.midphase_soon"] = "Midphase soon!",
		-- Timers
		["timer.adds_spawn"] = "Adds",
		["timer.orb_spawn"] = "Orbs",
		["timer.hex_spawn"] = "Hex",
		["timer.dispel_buff"] = "Dispel Buff %s",
		["timer.health_debuff"] = "Health Debuff: %d",
		-- Datachron
		["datachron.ablaze"] = "Laveka sets %s's soul ablaze!",
		["datachron.last_phase"] = "Laveka uses the Mask of Mog-Mog to rend the veil between this world and the next.",
		-- Chat messages
		["chat.dot"] = "Dot on %s!",
		-- Labels
		["label.circle_telegraph"] = "Circle telegraph",
		["label.lost_soul"] = "Lost soul",
		["label.titan_debuff"] = "Titan debuff mark (For healers)",
		["label.soulfire_debuff"] = "Soulfire debuff (For healers)",
		["label.add_spawn"] = "Adds spawn",
		["label.orb_spawn"] = "Orbs spawn",
		["label.hex_debuff_self"] = "Hex on you",
		["label.hex_debuff"] = "Hex on *player*",
		["label.cardinal_baitmarks"] = "Location marks for baiters",
		["label.entrance_line"] = "Entrance line (For tanks)",
		["label.clone_spawn"] = "Lost soul - Teleport spawn",
		["label.orbs_lines"] = "Orb paths",
		["label.orb_text"] = "Orb location marks",
		["label.essence_int_1"] = "Essence interrupt 1",
		["label.essence_int_2"] = "Essence interrupt 2",
		["label.essence_int_3"] = "Essence interrupt 3",
		["label.essence_int_4"] = "Essence interrupt 4",
		["label.essence_int_5"] = "Essence interrupt 5",
		["label.essence_int_6"] = "Essence interrupt 6",
		["label.orb_spawn_line_1"] = "Orb spawn line 1",
		["label.orb_spawn_line_2"] = "Orb spawn line 2",
		["label.orb_spawn_line_3"] = "Orb spawn line 3",
		["label.orb_spawn_line_4"] = "Orb spawn line 4",
		["label.orb_spawn_line_5"] = "Orb spawn line 5",
		["label.orb_spawn_line_6"] = "Orb spawn line 6",
		["label.midphase"] = "Midphase",
		["label.dispel_buff"] = "Dispel Buff on Laveka",
		["label.health_debuff"] = "Health Debuff",
		["label.center_mark"] = "Center Mark",

		["cardinal.SE"] = "SE",
		["cardinal.SW"] = "SW",
		["cardinal.NE"] = "NE",
		["cardinal.NW"] = "NW",
},
	["deDE"] = {
		-- Units
		["unit.boss"] = "Laveka the Dark-Hearted",
		["unit.titan"] = "Risen Titan",
		["unit.boneclaw"] = "Risen Boneclaw",
		["unit.apparition"] = "Tortured Apparition",
		["unit.lost_soul"] = "Lost Soul",
    ["unit.circle_telegraph"] = "Feindselige unsichtbare Einheit für Felder (Trefferradius 0)",
		["unit.essence_void"] = "Essenzleere",
    ["unit.orb"] = "Seelenfresser", --not sure. --copied from associated debuff..
		-- Casts
		["cast.devour_souls"] = "Devour Souls",
		["cast.essence_void"] = "Essenzleere",
		["cast.expulsion_of_souls"] = "Seelenausstoß", --Copied from the associated debuff..
		["cast.essence_surge"] = "Essenzwoge", --RC
		["cast.cacophony_of_souls"] = "Seelenkakophonie", --RC
		-- Debuffs
		["debuff.necrotic_breath"] = "Necrotic Breath", --All verified.
		["debuff.barrier_of_souls"] = "Seelenbarriere",
		["debuff.soul_eater"] = "Seelenfresser",
		["debuff.boneclaw_gaze"] = "Boneclaw Gaze",
		["debuff.expulsion_of_souls"] = "Seelenausstoß",
		["debuff.soulfire"] = "Soulfire",
		["debuff.realm_of_the_dead"] = "Realm of the Dead",
		["debuff.spirit_of_soulfire"] = "Spirit of Soulfire",
		-- Alert
		["alert.adds_debuff"] = "Du wirst von Adds verfolgt!",
		["alert.soulfire_debuff"] = "Dot auf dir!",
		["alert.hex_debuff_self"] = "Hex auf dir!",
		["alert.hex_debuff"] = "Hex auf %s",
		["alert.clone_spawn"] = "Du kannst Teleportieren",
		["alert.interrupt_essence"] = "Unterbreche Essenz %d!!",
		["alert.midphase"] = "Mittelphase!",
		["alert.last_phase"] = "Last Phase!",
		["alert.midphase_soon"] = "Mittelphase bald!",
		-- Timers
		["timer.adds_spawn"] = "Adds",
		["timer.orb_spawn"] = "Orbs",
		["timer.hex_spawn"] = "Hex",
		["timer.dispel_buff"] = "Dispel Buff %s",
		["timer.health_debuff"] = "Health Debuff: %d",
		-- Datachron
		["datachron.ablaze"] = "Laveka sets %s's soul ablaze!",
		["datachron.last_phase"] = "Laveka nutzt die Maske von Mog-Mog, um den Schleier zwischen dieser und der nächsten",
		-- Chat messages
		["chat.dot"] = "Dot auf %s!",
		-- Labels
		["label.circle_telegraph"] = "Kreis Telegraph",
		["label.lost_soul"] = "Lost soul",
		["label.titan_debuff"] = "Titan debuff Markierung (Für Heiler)",
		["label.soulfire_debuff"] = "Soulfire debuff (Für Heiler)",
		["label.add_spawn"] = "Adds spawn",
		["label.orb_spawn"] = "Orbs spawn",
		["label.hex_debuff_self"] = "Hex auf dir",
		["label.hex_debuff"] = "Hex auf *spieler*",
		["label.cardinal_baitmarks"] = "markierungen für Baiter",
		["label.entrance_line"] = "Eingangslinie (Für Tanks)",
		["label.clone_spawn"] = "Lost soul - Teleport spawn",
		["label.orbs_lines"] = "Orb Pfade",
		["label.orb_text"] = "Orb Markierungen",
		["label.essence_int_1"] = "Essenz Unterbrechen: 1",
		["label.essence_int_2"] = "Essenz Unterbrechen: 2",
		["label.essence_int_3"] = "Essenz Unterbrechen: 3",
		["label.essence_int_4"] = "Essenz Unterbrechen: 4",
		["label.essence_int_5"] = "Essenz Unterbrechen: 5",
		["label.essence_int_6"] = "Essenz Unterbrechen: 6",
		["label.orb_spawn_line_1"] = "Orb spawn Linie 1",
		["label.orb_spawn_line_2"] = "Orb spawn Linie 2",
		["label.orb_spawn_line_3"] = "Orb spawn Linie 3",
		["label.orb_spawn_line_4"] = "Orb spawn Linie 4",
		["label.orb_spawn_line_5"] = "Orb spawn Linie 5",
		["label.orb_spawn_line_6"] = "Orb spawn Linie 6",
		["label.midphase"] = "Mittelphase",
		["label.dispel_buff"] = "Dispel Buff auf Laveka",
		["label.health_debuff"] = "Health Debuff",
		["label.center_mark"] = "Mittel-Markierung",

		["cardinal.SE"] = "SO",
		["cardinal.SW"] = "SW",
		["cardinal.NE"] = "NO",
		["cardinal.NW"] = "NW",
	},
	["frFR"] = {
		["datachron.last_phase"] = "Laveka utilise le masque de Mog-Mog pour déchirer le voile qui sépare ce monde de",
	},
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  Boss{
    label = "unit.boss",
    unit{},
	}

	Midphase{
		label = "label.midphase",
		alert{},
		sound{file = "alert"},
		text{},
	}
	Soulfire{
		label = "debuff.soulfire",
		color = "ff0000ff",
		alert{},
		sound{file = "burn"},
		line{label = "label.soulfire_debuff", enable = false, thickness = 5},
		text{label = "label.soulfire_debuff", enable = false},
	}
	DispelBuff{
		label = "label.dispel_buff",
		timer{color="xkcdBarbiePink"},
	}
	HealthDebuff{
		label = "label.health_debuff",
		timer{enable=false},
	}

	Cardinal{
		text{label = "label.cardinal_baitmarks", color = "ffff4500"},
		line{enable = false, label = "label.entrance_line", color = "ffff1493", thickness = 5}
	}
	CentralMark{
		label = "label.center_mark",
		line{},
	}

	Adds{
		label = "label.add_spawn",
		timer{},
	}
	Orbs{
		label = "label.orb_spawn",
		timer{},
		text{label = "label.orb_text", color = "ffff4500"},
	}
	Hex{
		label = "timer.hex_spawn",
		timer{},
		alert{},
	}

	Titan{
		label = "unit.titan",
		unit{},
		line{color = "ff9400d3", thickness = 5},
	}
	TitanDebuff{
		label = "label.titan_debuff",
		color = "9600ffff",
		enable = false,
		line{thickness = 5},
		icon{sprite = "LUIBM_radioactive", size = 60}
	}
	Boneclaw{
		label = "alert.adds_debuff",
		color = "ffff0000",
		unit{enable = false, label = "unit.boneclaw"},
		alert{},
		sound{file = "run-away"},
		line{thickness = 5},
		icon{sprite = "LUIBM_crosshair", size = 60},
	}
	LostSoul{
		label = "unit.lost_soul",
		unit{enable = false},
		icon{enable = false, sprite = "LUIBM_skull4", size = 60, color = "ff00ff00"},
		line{color = "ff00ff00", thickness = 5},
	}
	Essence{
		label = "unit.essence_void",
		unit{enable = false},
		line{color = "ffffbb00"}, --circle
		text{},
	}
	Essence1{
		label = "label.essence_int_1",
		enable = false,
		color = "ffffd700",
		line{thickness = 6},
		cast{},
		alert{},
		sound{file = "inferno"},
	}
	Essence2{
		label = "label.essence_int_2",
		enable = false,
		color = "ffffd700",
		line{thickness = 6},
		cast{},
		alert{},
		sound{file = "inferno"},
	}
	Essence3{
		label = "label.essence_int_3",
		enable = false,
		color = "ffffd700",
		line{thickness = 6},
		cast{},
		alert{},
		sound{file = "inferno"},
	}
	Essence4{
		label = "label.essence_int_4",
		enable = false,
		color = "ffffd700",
		line{thickness = 6},
		cast{},
		alert{},
		sound{file = "inferno"},
	}
	Essence5{
		label = "label.essence_int_5",
		enable = false,
		color = "ffffd700",
		line{thickness = 6},
		cast{},
		alert{},
		sound{file = "inferno"},
	}
	Orb1{
		label = "label.orb_spawn_line_1",
		line{color = "ffff1493",thickness = 3}
	}
	Orb2{
		label = "label.orb_spawn_line_2",
		line{color = "ffff1493",thickness = 3}
	}
	Orb3{
		label = "label.orb_spawn_line_3",
		line{color = "ffff1493",thickness = 3}
	}
	Orb4{
		label = "label.orb_spawn_line_4",
		line{color = "ffff1493",thickness = 3}
	}
	Orb5{
		label = "label.orb_spawn_line_5",
		line{color = "ffff1493",thickness = 3}
	}
	Orb6{
		label = "label.orb_spawn_line_6",
		line{color = "ffff1493",thickness = 3}
	}
	Test{text{}, label = "ASdf", line{}}
end, function(_arg, _env, _var) --luacheck: no unused args
  -- luacheck: no global
	local v3RoomCenter = Vector3.New(-723.717773, 186.834915, -265.187195)

	_var.bDeadRealm = false
	_var.bMidphase = false

	Enable{
		Text("Cardinal", Vector3.New(-744.18, 187.15, -283.25), "cardinal.NW") % ("NW"),
		Text("Cardinal", Vector3.New(-703.35, 187.16, -283.39), "cardinal.NE") % ("NE"),
		Text("Cardinal", Vector3.New(-745.59, 187.16, -247.69), "cardinal.SW") % ("SW"),
		Text("Cardinal", Vector3.New(-702.25, 187.17, -247.74), "cardinal.SE") % ("SE"),
		--entrance line... not sure what this is for, but it was in the original LUI_BM
		LineBetween("Cardinal", Vector3.New(-723.84, 187.02, -252.58), Vector3.New(-723.84, 187.17, -206.61)),
		--something like this has been added to a custon Laveka file. (they just used a text ('.'))
		Polygon("CentralMark", v3RoomCenter, 1, 8),

		Timer("Adds", 37, "timer.adds_spawn"),
		Timer("Orbs", 76, "timer.orb_spawn"),
		Delay("Orbs", 71, FireCallbacks("PredrawOrbOrbits")),
	}

  UnitCreated{ strUnitName = "unit.boss", bInCombat = true,
		Unit("Boss", _arg.tUnit) + {position = -1},
		If{ [Count("BossTargeted")] = 1,
			_env.GameLib.SetTarget(_arg.tUnit),
			--im too lazy to search for an alternative method of tracking midphase than debuffs,
			--but for that you had to have had the mob targeted at least once.
		}
	}

	UnitCreated{ strUnitName = "unit.boneclaw", [_arg.self:HasUnit("Boneclaw", _arg.nUnitId)] = false,
		Unit("Boneclaw", _arg.tUnit) % (_arg.nUnitId) + {position = Count("Boneclaw")},
	}
	local GAZE_BUFF_PLAYER = 85609 -- Boneclaw target
	BuffAdded{ nSpellId = GAZE_BUFF_PLAYER, [_arg.tUnit:IsThePlayer()] = true,
		Alert("Boneclaw", "alert.adds_debuff"),
		Sound("Boneclaw"),
		LineBetween("Boneclaw", _arg.tUnit, _arg.tBuff.tSpell.unitCaster) % (_arg.tBuff.tSpell.unitCaster:GetId()),
		Icon("Boneclaw", _arg.tUnit) % (_arg.tBuff.tSpell.unitCaster:GetId()),
	}
	HealthReached{ strUnitName = "unit.boneclaw", nHealthReached = 1,
		--its basically dead at 1% - not sure if we get 0% warning. (e.g. Swabbie mobs are always at 1HP)
		-LineBetween("Boneclaw") % (_arg.nUnitId),
		-Icon("Boneclaw") % (_arg.nUnitId),
	}
	UnitDestroyed{ strUnitName = "unit.boneclaw",
		-LineBetween("Boneclaw") % (_arg.nUnitId),
		-Icon("Boneclaw") % (_arg.nUnitId),
	}

	UnitCreated{ strUnitName = "unit.lost_soul",
		Unit("LostSoul", _arg.tUnit) % (_arg.nUnitId),
		LineBetween("LostSoul", _arg.tUnit, nil) % (_arg.nUnitId),
		Icon("LostSoul", _arg.tUnit) % (_arg.nUnitId) + {bTop = true},
	}

	--[[Counters:
		"Essence" -> Counts the amount of essences (1-5)
		"Essence", nUnitId -> has this unit benn processed?
	]]
	UnitCreated{ strUnitName = "unit.essence_void", [GetCount("Essence", _arg.nUnitId)] = 0,
	Count("Essence"),
		If{ [GetCount("Essence")] = {">", 5}, SetCount(1, "Essence")},--basically count = (count % 5)+1
		SetCount(GetCount("Essence"), "Essence", _arg.nUnitId), --we basically assign 1-5 to ("Essence", nUnitId)

		Unit("Essence", _arg.tUnit) % (_arg.nUnitId),
		Polygon("Essence", _arg.tUnit, 4.2, 10) % (_arg.nUnitId),
		Text("Essence", _arg.tUnit, GetCount("Essence")) % (_arg.nUnitId),

		LineBetween("Essence"..GetCount("Essence"), _arg.tUnit, nil) % (_arg.nUnitId),
	}
	CastStart{ strSpellName = "cast.essence_surge", [GetCount("Essence", _arg.nUnitId)] = {"~=", 0},
		Polygon("Essence", _arg.tUnit, 4.2, 10) % (_arg.nUnitId) + {color = "ffff0000"},
		Sound("Essence"..GetCount("Essence", _arg.nUnitId)),
		Cast("Essence"..GetCount("Essence", _arg.nUnitId), _arg.tCast) + {
			strText = {"alert.	interrupt_essence", GetCount("Essence", _arg.nUnitId)}},
		Alert("Essence"..GetCount("Essence", _arg.nUnitId), {"alert.interrupt_essence", GetCount("Essence", _arg.nUnitId)}),
	}


	CastStart{ strSpellName = "cast.cacophony_of_souls",
		SetCount(0, "Essence"),
		Alert("Midphase", "alert.midphase"),
		Sound("Midphase"),
	}
	Datachron{ strMessage = "datachron.last_phase",
		Alert("Midphase", "alert.last_phase"),
		Sound("Midphase"),
		-Timer("Adds"),
		-Timer("Orbs"),
		-Delay("Orbs"),
	}


	UnitCreated{ strUnitName = "unit.titan",
		Unit("Titan", _arg.tUnit) % (_arg.nUnitId) + {position = 0},
		If{ [_var.bDeadRealm] = false,
			LineBetween("Titan", _arg.tUnit, nil) % (_arg.nUnitId),
			If{ _var.bMidphase,
				Timer("Adds", 75, "timer.adds_spawn")
			}/{
				Timer("Adds", 90, "timer.adds_spawn")
			},
    },
	}
	HealthReached{ strUnitName = "unit.titan", nHealthReached = 1, --1% is close enough
		-LineBetween("Titan") % (_arg.nUnitId),
	}

	HealthReached{ strUnitName = "unit.boss", nHealthReached = {80, 55, 30},
		Alert("Midphase", "alert.midphase_soon"),
		Sound("Midphase"),
		HealthText("Midphase", _arg.tUnit, _arg.nHealthReached-5),
	}

	local DISPEL_BUFF_LAVEKA = 75576 --SPIRIT_OF_SOULFIRE
	_var.nLastDispelStack = 0
	BuffAdded{ nSpellId = DISPEL_BUFF_LAVEKA,
		_var.nLastDispelStack(_arg.nStack),
		Timer("DispelBuff", _arg.nDuration, {"timer.dispel_buff", _arg.nStack})
	}
	BuffUpdated{ nSpellId = DISPEL_BUFF_LAVEKA, nStack = {">", _var.nLastDispelStack},
		_var.nLastDispelStack(_arg.nStack),
		Timer("DispelBuff", _arg.nDuration, {"timer.dispel_buff", _arg.nStack})
	}
	BuffRemoved{ nSpellId = DISPEL_BUFF_LAVEKA,
		_var.nLastDispelStack(0),
		-Timer("DispelBuff"),
	}

	local MIDPHASE_BUFF_LAVEKA = 87774 --BARRIER_OF_SOULS
	BuffAdded{ nSpellId = MIDPHASE_BUFF_LAVEKA,
		_var.bMidphase(true),
		-Timer("Adds"),
		-Timer("Orbs"),
		-Delay("Orbs"),
		fHideOrbLines,
	}
	BuffRemoved{ nSpellId = MIDPHASE_BUFF_LAVEKA,
		_var.bMidphase(false),
		-Timer("Adds"),

		Timer("Orbs", 61, "timer.orb_spawn"),
		Delay("Orbs", 56, FireCallbacks("PredrawOrbOrbits")),
	}


	local DISPEL_DEBUFF_PLAYER = 75574 -- Debuff to be cleansed (SOULFIRE)
	BuffAdded{ nSpellId = DISPEL_DEBUFF_PLAYER,
		TimerText("Soulfire", _arg.tUnit, _arg.nDuration) % (_arg.nUnitId),
    If{ [_arg.tUnit:IsThePlayer()] = true,
			Alert("Soulfire", "alert.soulfire_debuff"),
			Sound("Soulfire")
    }/{
			LineBetween("Soulfire", _arg.tUnit, nil) % (_arg.nUnitId)
    },
	}
	BuffRemoved{ nSpellId = DISPEL_DEBUFF_PLAYER,
		-TimerText("Soulfire") % (_arg.nUnitId),
		-LineBetween("Soulfire") % (_arg.nUnitId),
	}

	local DEBUFF_HEX = 87901 --EXPULSION_OF_SOULS -- Runic circle debuff
	BuffAdded{ nSpellId = DEBUFF_HEX,
    If{ [_arg.tUnit:IsThePlayer()] = true,
			Alert("Hex", "alert.hex_debuff_self")
    }/{
			Alert("Hex", {"alert.hex_debuff", _arg.strUnitName})
    },
	}


	local DEBUFF_HEALTH_DECREASE = 75525 --ECHOES_OF_THE_AFTERLIFE -- stacking debuff
	_var.nLastHealthDebuff = 0
	BuffAdded{ nSpellId = DEBUFF_HEALTH_DECREASE, [_arg.tUnit:IsThePlayer()] = true,
		_var.nLastHealthDebuff(_arg.nStack),
		If{ [_var.bDeadRealm] = true,
			Timer("HealthDebuff", 10, {"timer.health_debuff", _arg.nStack+1})
    }/{
			Timer("HealthDebuff", 10, {"timer.health_debuff", _arg.nStack-1})
    },
	}
	BuffUpdated{ nSpellId = DEBUFF_HEALTH_DECREASE, [_arg.tUnit:IsThePlayer()] = true,
		_var.nLastHealthDebuff(_arg.nStack),
		If{ [_var.bDeadRealm] = true,
			Timer("HealthDebuff", 10, {"timer.health_debuff", _arg.nStack+1})
    }/{
			Timer("HealthDebuff", 10, {"timer.health_debuff", _arg.nStack-1})
    },
	}
	BuffRemoved{ nSpellId = DEBUFF_HEALTH_DECREASE, [_arg.tUnit:IsThePlayer()] = true,
		_var.nLastHealthDebuff(0),
		-Timer("HealthDebuff")
	}

	local DEBUFF_DEAD_REALM = 75528 --REALM_OF_THE_DEAD -- When in dead world
	BuffAdded{ nSpellId = DEBUFF_DEAD_REALM, [_arg.tUnit:IsThePlayer()] = true,
		_var.bDeadRealm(true),
		Timer("HealthDebuff", 10, {"timer.health_debuff", _arg(_var.nLastHealthDebuff)+1})
	}
	BuffRemoved{ nSpellId = DEBUFF_DEAD_REALM, [_arg.tUnit:IsThePlayer()] = true,
		_var.bDeadRealm(false),
		Timer("HealthDebuff", 10, {"timer.health_debuff", _arg(_var.nLastHealthDebuff)-1})
	}


	local DEBUFF_TITAN_ABSORB = 75608-- NECROTIC_BREATH -- Debuff to be healed
	BuffAdded{ nSpellId = DEBUFF_TITAN_ABSORB,
		LineBetween("TitanDebuff", _arg.tUnit, nil) % (_arg.nUnitId),
		Icon("TitanDebuff", _arg.tUnit) % (_arg.nUnitId),
	}
	BuffRemoved{ nSpellId = DEBUFF_TITAN_ABSORB,
		-LineBetween("TitanDebuff") % (_arg.nUnitId),
		-Icon("TitanDebuff") % (_arg.nUnitId),
	}


	--- ##### ORB THINGS ! ##### ---
	--[[ Order of Operations:
		1) Predraw ~5 sec before Orbs spawn (triggered from somewhere else)
		2) Orbs spawn -> Draw all lines
		3) Orb caught -> Draw this line 'inactive'
			3a) Share if you see somebody having caught one
			3b) Use the shared info to deactivate orbs caught in the other realm.
		4) Orbs despawn -> Remove all lines
	]]

	_var.bOrbitsDrawn = false --whether or not fDrawOrbit is actually allowed to draw
	_var.bOrbsCreated = false --whether or not we can have an orb be drawn inactive
	local strInactiveColor = "ffababab"
	local tOrbitState = {}; Enable{function() tOrbitState = {} end}
	local function fDrawOrbit(self, nOrbIndex, bShow, bActive)
		if bShow and not self.tVars.bOrbitsDrawn then return end
		if bShow and not bActive and not self.tVars.bOrbsCreated then return end

		local bState = bShow and (bActive and true or false) or nil
		-- nil/true/false = not_shown/active/inactive
		if tOrbitState[nOrbIndex] == bState then return end
		tOrbitState[nOrbIndex] = bState

		if bShow then
			local nRadius = nOrbIndex*6
			local strColor = not bActive and strInactiveColor or nil
			local strOrbKey = "Orb"..nOrbIndex

			--text is always drawn in the same color.
			self:Text("Orbs", v3RoomCenter+Vector3.New(0,0, nRadius), nOrbIndex, "A"..nOrbIndex)
			self:Text("Orbs", v3RoomCenter+Vector3.New(0,0,-nRadius), nOrbIndex, "B"..nOrbIndex)
			self:Polygon(strOrbKey, v3RoomCenter, nRadius, 40, "Orbit", {color = strColor})
		else
			local strOrbKey = "Orb"..nOrbIndex
			self:RemoveText("Orbs", "A"..nOrbIndex)
			self:RemoveText("Orbs", "B"..nOrbIndex)
			self:RemovePolygon(strOrbKey, "Orbit")
		end
	end

	local function fDrawAllOrbits(self)
		if self.tVars.bOrbitsDrawn then return end --the Orbits are drawn already
		self.tVars.bOrbitsDrawn = true

		for nOrbIndex = 1, 6, 1 do
			fDrawOrbit(self, nOrbIndex, true, true)
		end
	end

	local function fHideAllOrbits(self)
		if not self.tVars.bOrbitsDrawn then return end --the Orbits are hidden already
		self.tVars.bOrbitsDrawn = false

		for nOrbIndex = 1, 6, 1 do
			fDrawOrbit(self, nOrbIndex, false)
		end
	end


	-- 1) Predraw ~5 sec before Orbs spawn (triggered from somewhere else)
	Callback("PredrawOrbOrbits", {
		fDrawAllOrbits
	})

	-- 2) Orbs spawn -> Draw all lines
	_var.nNextSoulEaterIndex = 6
	UnitCreated{ strUnitName = "unit.orb", [GetCount("OrbIndex", _arg.nUnitId)] = {"~=", 0},
		_var.bOrbsCreated(true),
		fDrawAllOrbits,

		--this is for 3a)
		SetCount(_var.nNextSoulEaterIndex, "OrbIndex", _arg.nUnitId),
		_var.nNextSoulEaterIndex-1,
		If{[_var.nNextSoulEaterIndex] = 0, _var.nNextSoulEaterIndex(6)},
	}

	-- 3) Orb caught -> Draw this line 'inactive'
	BuffAdded{ nSpellId = 87069, --Soul Eater Debuff...
		{function(self, tBuff)
			if not tBuff or not tBuff.tSpell or not tBuff.tSpell.unitCaster or not tBuff.tSpell.unitCaster:IsValid() then
				return
			end

			local nUnitId = tBuff.tSpell.unitCaster:GetId()
			local nOrbIndex = self:GetCount("OrbIndex", nUnitId)

			if not nOrbIndex then return end

			fDrawOrbit(self, nOrbIndex, true, false)

			-- 3a) Share if you see somebody having caught one
			self:SendCommMessage(1, nOrbIndex) --This is Compatible with RaidCore. (1 = strReason)
		end, _arg.self, _arg.tBuff}
	}

	-- 3b) Use the shared info to deactivate orbs caught in the other realm.
	CommMessage{ strReason = 1,
		{fDrawOrbit, _arg.self, _arg.tData, true, false},
	}

	-- 4) Orbs despawn -> Remove all lines
	UnitDestroyed{ strUnitName = "unit.orb",
		_var.bOrbsCreated(false),
		fHideAllOrbits,
		Timer("Orbs", 85, "timer.orb_spawn"),
		Delay("Orbs", 80, FireCallbacks("PredrawOrbOrbits")),
	}
	CastEnd{ strSpellName = "cast.devour_souls",
		fHideAllOrbits,
		Timer("Orbs", 85, "timer.orb_spawn"),
		Delay("Orbs", 80, FireCallbacks("PredrawOrbOrbits")),
	}
end)