local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("Mordechai", {
  instance = "Redmoon Terror",
  displayName = "Mordechai",
  tTrigger = {
    sType = "ANY",
    tNames = {"unit.boss"},
    tZones = {
      [1] = {
        continentId = 104,
        parentZoneId = 0,
        mapId = 548,
      },
    },
  },
},{
  ["enUS"] = {
    -- Units
    ["unit.boss"] = "Mordechai Redmoon",
    ["unit.orb"] = "Kinetic Orb",
    ["unit.airlock_anchor"] = "Airlock Anchor",
    -- Debuffs
    ["debuff.orb_damage"] = "Kinetic Link",
    ["debuff.orb_following"] = "Kinetic Fixation",
    ["debuff.shocking_attraction"] = "Shocking Attraction",
    -- Datachron
    ["datachron.airlock_opened"] = "The airlock has been opened!",
    ["datachron.airlock_closed"] = "The airlock has been closed!",
    -- Casts
    ["cast.shuriken"] = "Shatter Shock",
    ["cast.vicious_barrage"] = "Vicious Barrage",
    -- Alerts
    ["alert.orb_spawned"] = "Orb spawned!",
    ["alert.orb_damage"] = "HIT THE ORB!",
    ["alert.orb_following"] = "ORB ON YOU!",
    ["alert.shocking_attraction"] = "SHURIKENS ON YOU!",
    ["alert.shuriken_targets_left"] = "MOVE TO THE LEFT!",
    ["alert.shuriken_targets_right"] = "MOVE TO THE RIGHT!",
    ["alert.midphase"] = "Midphase soon!",
    ["alert.shuriken_on"] = "Shuriken on: ",
    -- Messages
    ["message.barrage_next"] = "Next Barrage",
    ["message.shuriken_next"] = "Next Shuriken",
    ["message.orb_next"] = "Next Orb",
    ["message.orb_active"] = "Orb start moving",
    -- Labels
    ["label.midphase"] = "Midphase",
    ["label.orb_next"] = "Kinetic Orb (Next)",
    ["label.orb_active"] = "Kinetic Orb (Active)",
    ["label.shuriken_targets_left"] = "Shocking Attraction (Left)",
    ["label.shuriken_targets_right"] = "Shocking Attraction (Right)",
    ["label.shuriken"] = "Shuriken",
    ["label.airlock"] = "Airlock",
    ["label.stack_point"] = "Barrage Stack Point",
  },
  ["deDE"] = {
    -- Units
    ["unit.boss"] = "Mordechai Redmoon",
    ["unit.orb"] = "Kinetic Orb",
    ["unit.airlock_anchor"] = "Airlock Anchor",
    -- Debuffs
    ["debuff.orb_damage"] = "Kinetic Link",
    ["debuff.orb_following"] = "Kinetic Fixation",
    ["debuff.shocking_attraction"] = "Shocking Attraction",
    -- Datachron
    ["datachron.airlock_opened"] = "The airlock has been opened!",
    ["datachron.airlock_closed"] = "The airlock has been closed!",
    -- Casts
    ["cast.shuriken"] = "Shatter Shock",
    ["cast.vicious_barrage"] = "Vicious Barrage",
    -- Alerts
    ["alert.orb_spawned"] = "Orb gespawnt!",
    ["alert.orb_damage"] = "HAU DEN ORB!",
    ["alert.orb_following"] = "ORB AUF DIR!",
    ["alert.shocking_attraction"] = "SHURIKEN AUF DIR!",
    ["alert.shuriken_targets_left"] = "LAUF NACH LINKS!",
    ["alert.shuriken_targets_right"] = "LAUF NACH RECHTS!",
    ["alert.midphase"] = "Mittelphase bald!",
    ["alert.shuriken_on"] = "Shuriken auf: ",
    -- Messages
    ["message.barrage_next"] = "Nächste Barrage",
    ["message.shuriken_next"] = "Nächste Shuriken",
    ["message.orb_next"] = "Nächstes Orb",
    ["message.orb_active"] = "Orb beginnt Bewegung",
    -- Labels
    ["label.midphase"] = "Mittelphase",
    ["label.orb_next"] = "Orb (Nächstes)",
    ["label.orb_active"] = "Orb (Aktivierung)",
    ["label.shuriken_targets_left"] = "Shuriken Ziele (Links)",
    ["label.shuriken_targets_right"] = "Shuriken Ziele (Rechts)",
    ["label.shuriken"] = "Shuriken",
    ["label.airlock"] = "Luftsschleuse",
    ["label.stack_point"] = "Barrage Stack Punkt",
  },
  ["frFR"] = {
    -- Units
    ["unit.boss"] = "Mordechai Redmoon",--V (Verified)
    ["unit.orb"] = "Kinetic Orb",--V
    ["unit.airlock_anchor"] = "Airlock Anchor",--V
    -- Debuffs
    ["debuff.orb_damage"] = "Kinetic Link",--V
    ["debuff.orb_following"] = "Kinetic Fixation",--V
    ["debuff.shocking_attraction"] = "Shocking Attraction",--V
    -- Datachron
    ["datachron.airlock_opened"] = "The airlock has been opened!",--V
    ["datachron.airlock_closed"] = "The airlock has been closed!",--V
    -- Casts
    ["cast.shuriken"] = "Shatter Shock",--V
    ["cast.vicious_barrage"] = "Vicious Barrage",--V
    -- Alerts
    ["alert.orb_spawned"] = "Une orbe est apparue !",
    ["alert.orb_damage"] = "TAPE L'ORBE !",
    ["alert.orb_following"] = "ORBE SUR TOI !",
    ["alert.shocking_attraction"] = "SHURIKEN SUR TOI !",
    ["alert.shuriken_targets_left"] = "BOUGE VERS LA GAUCHE !",
    ["alert.shuriken_targets_right"] = "BOUGE VERS LA DROITE !",
    ["alert.midphase"] = "Midphase bientôt !",
    ["alert.shuriken_on"] = "Shuriken on: ",
    -- Messages
    ["message.barrage_next"] = "Barrage Suivant",
    ["message.shuriken_next"] = "Shuriken Suivant",
    ["message.orb_next"] = "Orbe Suivante",
    ["message.orb_active"] = "L'orbe commence à bouger",
    -- Labels
    ["label.midphase"] = "Midphase",
    ["label.orb_next"] = "Orbe Cinétique (Suivante)",
    ["label.orb_active"] = "Orbe Cinétique (Active)",
    ["label.shuriken_targets_left"] = "Attraction Choquante (Gauche)",
    ["label.shuriken_targets_right"] = "Attraction Choquante (Droite)",
    ["label.shuriken"] = "Shuriken",
    ["label.airlock"] = "Aspiration",
    ["label.stack_point"] = "Point de ralliement du barrage",
  },
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  Boss{
    label = "unit.boss",
    unit{},
    line{thickness = 6, color = "ffffffff"},
  }

  Midphase{
    label = "label.midphase",
    sound{file = "beware"},
    alert{},
    text{},
    timer{},
  }

  Anchor{
    label = "unit.airlock_anchor",
    icon{sprite = "BasicSprites:WhiteCircle", size = 40, color = "9600ff00"},
  }

  Shuriken{
    label = "label.shuriken",
    color = "ffb0ff2f",
    sound{file = "beware"},
    aura{sprite = "LUIBM_shuriken"},
    icon{sprite = "LUIBM_crosshair", size = 80},
    timer{},
    text{},
    alert{},
    line{thickness = 4},
  }
  ShurikenAlertLeft{ alert{label = "label.shuriken_targets_left", enable = false} }
  ShurikenAlertRight{ alert{label = "label.shuriken_targets_right"} }
  StackPoint{
    label = "label.stack_point",
    icon{sprite = "BasicSprites:WhiteCircle", size = 40, color = "96ff00ff"},
  }

  Orb{
    label = "unit.orb",
    color = "ffffa500",
    unit{},
    timer{},
    alert{},
    sound{file = "alert"},
  }
  OrbActive{
    label = "label.orb_active",
    color = "ffff0000",
    timer{},
    text{},
  }
  OrbTarget{
    label = "alert.orb_following",
    sound{file = "run-away"},
    line{thickness = 6, color = "ffb0ff2f"},
    alert{},
  }
  OrbDamage{
    label = "alert.orb_damage",
    sound{file = "burn"},
    line{thickness = 6, color = "ffff0000"},
    alert{},
    icon{sprite = "LUIBM_crosshair", size = 80, color = "ffff0000"},
  }

  Barrage{
    label = "cast.vicious_barrage",
    timer{color = "c8ff0000"},
  }
end, function(_arg, _env, _var) --luacheck: no unused args
  -- luacheck: no global

  local function fAddMarkers(self)
    local tUnit = self:GetUnit("Boss")

    if tUnit then
      self:Line("Boss", tUnit, 60, "FrontLeft",  {nRotation = -23.5, tVectorOffsets = Vector3.New( 3.25, 0, 0)})
      self:Line("Boss", tUnit,-60, "BackLeft",   {nRotation = -23.5, tVectorOffsets = Vector3.New(-3.25, 0, 0)})
      self:Line("Boss", tUnit, 60, "FrontRight", {nRotation =  23.5, tVectorOffsets = Vector3.New(-3.25, 0, 0)})
      self:Line("Boss", tUnit,-60, "BackRight",  {nRotation =  23.5, tVectorOffsets = Vector3.New( 3.25, 0, 0)})
    end

    self:Icon("Anchor", Vector3.New(123.85, 353.874, 179.71), "Left")
    self:Icon("Anchor", Vector3.New( 93.85, 353.874, 179.71), "Right")
    self:Icon("StackPoint", Vector3.New(108.63, 353.87, 175.49))
  end

  local function fRemMarkers(self)
    self:RemoveLine("Boss", "FrontLeft")
    self:RemoveLine("Boss", "BackLeft")
    self:RemoveLine("Boss", "FrontRight")
    self:RemoveLine("Boss", "BackRight")

    self:RemoveIcon("Anchor", "Left")
    self:RemoveIcon("Anchor", "Right")
    self:RemoveIcon("StackPoint")
  end


  UnitCreated{ strUnitName = "unit.boss", bInCombat = true, [_arg.self:HasUnit("Boss")] = false,
    Unit("Boss", _arg.tUnit),
    fAddMarkers,
  }

  --## MIDPHASE STUFFS ##
  HealthReached{ strUnitName = "unit.boss", nHealthReached = {88, 63, 38, 13},
    Alert("Midphase", "alert.midphase"),
    Sound("Midphase"),
  }
  HealthReached{ strUnitName = "unit.boss", nHealthReached = {90, 65, 40, 15},
    HealthText("Midphase", _arg.tUnit, _arg.nHealthReached-5) + {nOffset = -50}, --85, 60, 35, 10
  }

  _var.bNextIsBarragePhase = false
  Datachron{ strMessage = "datachron.airlock_closed",
    Timer("Shuriken", 10),
    TimerText("Shuriken", _arg.self:GetUnit("Boss"), 10),
    Timer("Orb", 15),
    If{ [_var.bNextIsBarragePhase] = true,
      Timer("Barrage", 19)
    },
    _var.bNextIsBarragePhase(true), --this means, the 2nd time he gets out of a midphase, barrage is coming
    fAddMarkers,
  }

  Datachron{ strMessage = "datachron.airlock_opened",
    -Timer("Shuriken"),
    -TimerText("Shuriken"),
    -Timer("Orb"),
    -Timer("Barrage"),

    Timer("Midphase", 25),
    fRemMarkers,
  }

  --## SHURIKEN STUFFS ##
  CastStart{ strSpellName = "cast.shuriken",
    Timer("Shuriken", 22),
    TimerText("Shuriken", _arg.tUnit, 22),
  }

  _var.tShurikenTargets = _arg(function() return {} end)()

  local DEBUFF_SHURIKEN_TARGETS = 86861 --DEBUFF_SHOCKING_ATTRACTION
  BuffAdded{ nSpellId = DEBUFF_SHURIKEN_TARGETS,
    Icon("Shuriken", _arg.tUnit) % (_arg.nUnitId) + {nDuration = _arg.nDuration},
    -- LineBetween("Shuriken", _arg.self:GetUnit("Boss"), _arg.tUnit) % (_arg.nUnitId) + {
    --   nDuration = _arg.nDuration, nOffset = 2},

    If{ [_arg.tUnit:IsThePlayer()] = true,
      Sound("Shuriken"),
      Aura("Shuriken", _arg.nDuration),
      Alert("ShurikenAlertLeft", "alert.shuriken_targets_left"),
      Alert("ShurikenAlertRight", "alert.shuriken_targets_right")
    },

    Alert("Shuriken", _arg.self.L["alert.shuriken_on"] .. _arg.strUnitName) % (_arg.nUnitId),
    -- {function(self, strUnitName)
    --   table.insert(self.tVars.tShurikenTargets, strUnitName)
    -- end, _arg.self, _arg.strUnitname},
    -- Delay("ShurikenAlert", 0 , function(self)
    --   if #self.tVars.tShurikenTargets > 0 then
    --     local strPlayers = table.concat(self.tVars.tShurikenTargets, ", ")
    --     self.tVars.tShurikenTargets = {}
    --   end
    -- end),
  }

  BuffRemoved{ nSpellId = DEBUFF_SHURIKEN_TARGETS,
    -Icon("Shuriken") % (_arg.nUnitId),
    -Aura("Shuriken"),
  }


  --## ORB STUFFS ##
  Enable{
    Timer("Orb", 22),
  }

  UnitCreated{ strUnitName = "unit.orb", bInCombat = true,
    Unit("Orb", _arg.tUnit),
    Timer("Orb", 26),
    Alert("Orb", "alert.orb_spawned"),
    Sound("Orb"),

    Timer("OrbActive", 5),
    TimerText("OrbActive", _arg.tUnit, 5),
  }

  UnitDestroyed{ strUnitName = "unit.orb",
    -LineBetween("OrbDamage"),
    -LineBetween("OrbTarget"),
  }

  local DEBUFF_ORB_FOLLOWING = 85566 --DEBUFF_KINETIC_FIXATION
  BuffAdded{ nSpellId = DEBUFF_ORB_FOLLOWING,
    If{ [_arg.self:HasUnit("Orb")] = true,
      LineBetween("OrbTarget", _arg.self:GetUnit("Orb"), _arg.tUnit)
    },
    If{ [_arg.tUnit:IsThePlayer()] = true,
      Sound("OrbTarget"),
      Alert("OrbTarget", "alert.orb_following")
    },
  }
  BuffRemoved{ nSpellId = DEBUFF_ORB_FOLLOWING,
    -LineBetween("OrbTarget"),
  }

  local DEBUFF_ORB_DAMAGE = 86797 --DEBUFF_KINETIC_LINK
  BuffAdded{ nSpellId = DEBUFF_ORB_DAMAGE,
    Icon("OrbDamage", _arg.tUnit) % (_arg.nUnitId) + {nDuration = _arg.nDuration},
    If{ [_arg.tUnit:IsThePlayer()] = true,
      Sound("OrbDamage"),
      Alert("OrbDamage", "alert.orb_damage"),
      If{ [_arg.self:HasUnit("Orb")] = true,
        LineBetween("OrbDamage", _arg.self:GetUnit("Orb"), _arg.tUnit)
      },
    },
  }
  BuffRemoved{ nSpellId = DEBUFF_ORB_DAMAGE,
    -Icon("OrbDamage") % (_arg.nUnitId),
    -LineBetween("OrbDamage"),
  }

  --## BARRAGE ##
  CastStart{ strSpellName = "cast.vicious_barrage",
    Timer("Barrage", 33),
  }
end)