local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("Robomination", {
  instance = "Redmoon Terror",
  displayName = "Robomination",
  tTrigger = {
    sType = "ANY",
    tNames = {"unit.boss"},
    tZones = {
      [1] = {
        continentId = 104,
        parentZoneId = 548,
        mapId = 551,
      },
      [2] = {
        continentId = 104,
        parentZoneId = 0,
        mapId = 548,
      },
    },
  },
},{
  ["enUS"] = {
    -- Units
    ["unit.boss"] = "Robomination",
    ["unit.cannon_arm"] = "Cannon Arm",
    ["unit.flailing_arm"] = "Flailing Arm",
    ["unit.scanning_eye"] = "Scanning Eye",
    -- Casts
    ["cast.noxious_belch"] = "Noxious Belch",
    ["cast.incineration_laser"] = "Incineration Laser",
    ["cast.cannon_fire"] = "Cannon Fire",
    -- Alerts
    ["alert.interrupt"] = "Interrupt!",
    ["alert.lasers"] = "Lasers incoming!",
    ["alert.midphase"] = "Midphase soon!",
    ["alert.crush"] = "CRUSH ON %s!",
    ["alert.crush_player"] = "CRUSH ON YOU!",
    ["alert.incineration"] = "INCINERATION ON %s!",
    ["alert.incineration_player"] = "INCINERATION ON YOU!",
    -- Messages
    ["message.next_arms"] = "Next arms",
    ["message.next_crush"] = "Next crush",
    ["message.next_belch"] = "Next belch",
    ["message.next_incineration"] = "Next incineration",
    -- Datachron messages
    ["datachron.midphase_start"] = "The Robomination sinks",
    ["datachron.midphase_end"] = "The Robomination erupts back into the fight!",
    ["datachron.incineration"] = "The Robomination tries to incinerate (.*)",
    -- Labels
    ["label.arms"] = "Arms",
    ["label.crush"] = "Crush",
    ["label.crush_player"] = "Crush on player",
  },
  ["deDE"] = {
    -- Units
    ["unit.boss"] = "Robomination",
    ["unit.cannon_arm"] = "Cannon Arm",
    ["unit.flailing_arm"] = "Fuchtelnder Arm",
    ["unit.scanning_eye"] = "Scanning Eye",
    -- Casts
    ["cast.noxious_belch"] = "Noxious Belch",
    ["cast.incineration_laser"] = "Incineration Laser",
    ["cast.cannon_fire"] = "Cannon Fire",
    -- Alerts
    ["alert.interrupt"] = "Unterbrechen!",
    ["alert.lasers"] = "Achtung Kotzen!",
    ["alert.midphase"] = "Mittelphase bald!",
    ["alert.crush"] = "STAMPFER AUF %s!",
    ["alert.crush_player"] = "STAMPFER AUF DIR!",
    ["alert.incineration"] = "FLAMMEN AUF %s!",
    ["alert.incineration_player"] = "FLAMMEN AUF DIR!",
    -- Messages
    ["message.next_arms"] = "Nächste Arme",
    ["message.next_crush"] = "Nächste Stampfer",
    ["message.next_belch"] = "Nächstes Kotzen",
    ["message.next_incineration"] = "Nächste Flammen",
    -- Datachron messages
    ["datachron.midphase_start"] = "Die Robomination sinkt in den Müll hinab.",
    ["datachron.midphase_end"] = "Die Robomination stürzt sich erneut ins Gefecht!",
    ["datachron.incineration"] = "Die Robomination versucht, (.*) zu verbrennen.",
    -- Labels
    ["label.arms"] = "Arme",
    ["label.crush"] = "Stampfer",
    ["label.crush_player"] = "Stampfer auf Spieler",
  },
  ["frFR"] = {
    -- Units
    ["unit.boss"] = "Robomination", --V (Verified)
    ["unit.cannon_arm"] = "Cannon Arm", --V
    ["unit.flailing_arm"] = "Bras agité", --V
    ["unit.scanning_eye"] = "Scanning Eye", --V
    -- Casts
    ["cast.noxious_belch"] = "Noxious Belch", --V
    ["cast.incineration_laser"] = "Incineration Laser", --V
    ["cast.cannon_fire"] = "Cannon Fire", --V
    -- Alerts
    ["alert.interrupt"] = "Interromps !",
    ["alert.lasers"] = "Lasers en approche !",
    ["alert.midphase"] = "Midphase bientôt !",
    ["alert.crush"] = "ÉCRASER SUR %s !",
    ["alert.crush_player"] = "ÉCRASER SUR TOI !",
    ["alert.incineration"] = "INCINÉRATION SUR %s !",
    ["alert.incineration_player"] = "INCINÉRATION SUR TOI !",
    -- Messages
    ["message.next_arms"] = "Bras suivants",
    ["message.next_crush"] = "Écraser suivant",
    ["message.next_belch"] = "Lasers suivants",
    ["message.next_incineration"] = "Incineration suivante",
    -- Datachron messages
    ["datachron.midphase_start"] = "Robomination s'enfonce dans les ordures.", --V
    ["datachron.midphase_end"] = "Robomination refait irruption dans le combat !", --V
    ["datachron.incineration"] = "Robomination essaie d'incinérer (.*)", --V
    -- Labels
    ["label.arms"] = "Bras",
    ["label.crush"] = "Écraser",
    ["label.crush_player"] = "Écraser sur le joueur",
  },
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  Boss{
    label = "unit.boss",
    unit{},
    text{label = "alert.midphase"},
    alert{label = "alert.midphase"},
  }

  NoxiousBelch{
    label = "cast.noxious_belch",
    timer{color = "ff7cfc00"},
    cast{},
    alert{},
  }
  Crush{
    label = "label.crush",
    timer{color = "ffffd700"},
    aura{sprite = "LUIBM_run", color = "ffff0000"},
    alert{},
    sound{file = "alert"},
    icon{sprite = "LUIBM_meteor", size = 80, color = "ffff0000"},
    text{color = "ffff0000"},
  }
  Incineration{
    label = "cast.incineration_laser",
    timer{color = "c8ff0000"},
    sound{file = "run-away"},
    aura{sprite = "LUIBM_ifrit", color = "ffff0000"},
    alert{},
    icon{sprite = "LUIBM_fire", size = 80, color = "ffff0000"},
    line{thickness = 12, color = "ffff0000"},
  }

  Arms{
    label = "label.arms",
    timer{},
  }
  CannonArm{
    label = "unit.cannon_arm",
    color = "ffff0000",
    unit{},
    line{},
    text{font = "CRB_FloaterGigantic"},
    cast{},
    sound{file = "info"},
  }
  FlailingArm{
    label = "unit.flailing_arm",
    color = "ff0084ff",
    unit{},
    line{},
  }
  ScanningEye{
    label = "unit.scanning_eye",
    line{},
    text{},
  }


end, function(_arg, _env, _var) --luacheck: no unused args
  -- luacheck: no global
  _var.bIsMainPhase = true
  _var.bIsArmPhase = false

  Enable{
    Timer("Arms", 45),
    Timer("Crush", 8),
    Timer("NoxiousBelch", 16),
  }

  UnitCreated{ strUnitName = "unit.boss", bInCombat = true, [_arg.self:HasUnit("Boss")] = false,
    Unit("Boss", _arg.tUnit),
    TimerText("Crush", _arg.tUnit, 8),
  }

  HealthReached{ strUnitName = "unit.boss", nHealthReached = {80, 55},
    HealthText("Boss", _arg.tUnit, _arg.nHealthReached-5) + {nOffset = -50},
  }
  HealthReached{ strUnitName = "unit.boss", nHealthReached = {77, 52},
    Alert("Boss", "alert.midphase")
  }

  local tArmUnits = {}
  Enable{function() tArmUnits = {} end}
  local function fShowArms(self, bShow)
    local strEvent = bShow and "UnitCreated" or "UnitDestroyed"

    for nUnitId, tUnit in pairs(tArmUnits) do
      if tUnit:IsValid() then
        local strUnitName = tUnit:GetName()
        local bInCombat = tUnit:IsInCombat()

        self:FireCallbacks(strEvent, {
          nUnitId, tUnit, strUnitName, bInCombat,
          nUnitId = nUnitId,
          tUnit = tUnit,
          strUnitName = strUnitName,
          bInCombat = bInCombat,
        }, nUnitId, tUnit, strUnitName, bInCombat)
      else
        tArmUnits[nUnitId] = nil
      end
    end
  end

  local tCannonFireCounters = {}
  Enable{function()
    local key = next(tCannonFireCounters)
    while key do tCannonFireCounters[key] = nil; key = next(tCannonFireCounters) end
  end}


  -- ## Cannon Arm ##
  UnitCreated{ strUnitName = "unit.cannon_arm", [_arg(tArmUnits)[_arg.nUnitId]] = _arg.Nil,
    Unit("CannonArm", _arg.tUnit) % (_arg.nUnitId),
    LineBetween("CannonArm", _arg.tUnit, nil) % (_arg.nUnitId)+ {nOffset = 2},

    {function(nUnitId) tCannonFireCounters[nUnitId] = tCannonFireCounters[nUnitId] or 1 end, _arg.nUnitId},
    Text("CannonArm", _arg.tUnit, 1) % (_arg.nUnitId),

    {function(nUnitId, tUnit) tArmUnits[nUnitId] = tUnit end, _arg.nUnitId, _arg.tUnit}
  }
  UnitCreated{ strUnitName = "unit.cannon_arm", [_var.bIsMainPhase] = true,
    Timer("Arms", 45),
  }
  UnitDestroyed{ strUnitName = "unit.cannon_arm",
    -Unit("CannonArm") % (_arg.nUnitId),
    -LineBetween("CannonArm") % (_arg.nUnitId),
    -Text("CannonArm") % (_arg.nUnitId),
    {function(nUnitId) tCannonFireCounters[nUnitId] = nil end, _arg.nUnitId},
  }
  CastStart{ strSpellName = "cast.cannon_fire", [_arg.self:InRange(_arg.tUnit, 30)] = true,
    Cast("CannonArm", _arg.tCast),
    Sound("CannonArm"),
  }
  CastEnd{ strSpellName = "cast.cannon_fire",
    {function(nUnitId) tCannonFireCounters[nUnitId] = (tCannonFireCounters[nUnitId] or 1)+1 end, _arg.nUnitId},
    Text("CannonArm", _arg.tUnit, _arg(tCannonFireCounters)[_arg.nUnitId]) % (_arg.nUnitId),
  }

  -- ## Flailing Arm ##
  UnitCreated{ strUnitName = "unit.flailing_arm", [_arg(tArmUnits)[_arg.nUnitId]] = _arg.Nil,
    Unit("FlailingArm", _arg.tUnit) % (_arg.nUnitId),
    LineBetween("FlailingArm", _arg.tUnit, nil) % (_arg.nUnitId),

    {function(nUnitId, tUnit) tArmUnits[nUnitId] = tUnit end, _arg.nUnitId, _arg.tUnit}
  }
  UnitDestroyed{ strUnitName = "unit.flailing_arm",
    -Unit("FlailingArm") % (_arg.nUnitId),
    -LineBetween("FlailingArm") % (_arg.nUnitId),
  }

  -- ## Noxious Belch ##
  CastStart{ strSpellName = "cast.noxious_belch",
    Cast("NoxiousBelch", _arg.tCast),
    Timer("NoxiousBelch", 31),
    Alert("NoxiousBelch", "alert.lasers"),
  }

  -- ## Crush ##
  local CRUSH_TARGET = 75126 -- Crush target
  BuffAdded{ nSpellId = CRUSH_TARGET, [_arg.tUnit:IsThePlayer()] = true,
    Timer("Crush", 17),
    TimerText("Crush", _arg.self:GetUnit("Boss"), 17),
    Icon("Crush", _arg.tUnit),

    Aura("Crush", _arg.nDuration),
    Alert("Crush", "alert.crush_player"),
    Sound("Crush"),
  }
  BuffAdded{ nSpellId = CRUSH_TARGET, [_arg.tUnit:IsThePlayer()] = false,
    Timer("Crush", 17),
    TimerText("Crush", _arg.self:GetUnit("Boss"), 17),
    Icon("Crush", _arg.tUnit),

    Alert("Crush", _arg.self.L["alert.crush"]:format(_arg.strUnitName)),
    Sound("Crush"),
  }
  BuffRemoved{ nSpellId = CRUSH_TARGET,
    -Aura("Crush"),
    -Icon("Crush"),
  }

  -- ## Incineration Laser ##
  Datachron{
    {function(self, strMessage)
      local strPlayerLaserFocused = strMessage:match(self.L["datachron.incineration"])

      if strPlayerLaserFocused then
        local tFocusedUnit = GameLib.GetPlayerUnitByName(strPlayerLaserFocused)

        if tFocusedUnit then
          if tFocusedUnit:IsThePlayer() then
            self:Sound("Incineration")
            self:Aura("Incineration", 12)
            self:Alert("Incineration", "alert.incineration_player")
          else
            self:Alert("Incineration", self.L["alert.incineration"]:format(strPlayerLaserFocused))
          end

          self:Icon("Incineration", tFocusedUnit, nil, {bTop = true, nDuration = 12})
          self:Timer("Incineration", 40)
          self:LineBetween("Incineration", tFocusedUnit, self:GetUnit("Boss"), nil, {nDuration = 12})
        end
      end
    end, _arg.self, _arg.strMessage}
  }

  -- ## Midphase Handling ##
  Datachron{ strMessage = "datachron.midphase_start", -- ## Main Phase End ## --
    _var.bIsMainPhase(false),
    _var.bIsArmPhase(false),
    -Timer("NoxiousBelch"),
    -Timer("Arms"),
    -Timer("Crush"),
    -Timer("Incineration"),
    -Icon("Crush"),
    -Aura("Crush"),
    -TimerText("Crush"),

    {fShowArms, _arg.self, false},
  }

  UnitCreated{ strUnitName = "unit.scanning_eye",
    LineBetween("ScanningEye", _arg.tUnit, nil) % (_arg.nUnitId),
    {fShowArms, _arg.self, false},

    TrackUnit(_arg.tUnit), --for health updates
  }
  HealthReached{ strUnitName = "unit.scanning_eye", nHealthReached = {100, 75, 50, 25},
    HealthText("ScanningEye", _arg.tUnit, _arg.nHealthReached-25),
  }

  UnitDestroyed{ strUnitName = "unit.scanning_eye", -- ## Arm Phase Start ## --
    _var.bIsMainPhase(false),
    _var.bIsArmPhase(true),
    -LineBetween("ScanningEye") % (_arg.nUnitId),
  }

  Datachron{ strMessage = "datachron.midphase_end", -- ## Arm Phase End / Main Phase Start ## --
    _var.bIsMainPhase(true),
    _var.bIsArmPhase(false),
    Timer("Arms", 45),
    Timer("Crush", 8),
    TimerText("Crush", _arg.self:GetUnit("Boss"), 8),
    Timer("NoxiousBelch", 14),
    Timer("Incineration", 20),

    {fShowArms, _arg.self, true},
  }
end)
