local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("Shredder", {
  instance = "Redmoon Terror",
  displayName = "Shredder",
  tTrigger = {
    sType = "ANY",
    tNames = {"unit.boss"},
    tZones = {
      [1] = {
        continentId = 104,
        parentZoneId = 548,
        mapId = 549,
      },
    },
  },
},{
  ["enUS"] = {
    -- Units
    ["unit.boss"] = "Swabbie Ski'Li",
    ["unit.noxious_nabber"] = "Noxious Nabber",
    ["unit.bilious_brute"] = "Bilious Brute",
    ["unit.regor_the_rancid"] = "Regor the Rancid",
    ["unit.braugh_the_bloodied"] = "Braugh the Bloodied",
    ["unit.sawblade"] = "Sawblade",
    ["unit.circle_telegraph"] = "Hostile Invisible Unit for Fields (1.2 hit radius)",
    -- Casts
    ["cast.necrotic_lash"] = "Necrotic Lash",
    ["cast.deathwail"] = "Deathwail",
    ["cast.gravedigger"] = "Gravedigger",
    -- Alerts
    ["alert.oozing_bile"] = "STOP DAMAGE!",
    ["alert.interrupt"] = "INTERRUPT!",
    -- Debuffs
    ["debuff.oozing_bile"] = "Oozing Bile",
    -- Datachron
    ["datachron.shredder_jammed"] = "Ye've jammed me shredder, ye have! Blast ye filthy bilge slanks!",
    -- Labels
    ["label.lines_room"] = "Room Dividers",
    ["label.circle_telegraph"] = "Circle Telegraphs",
    ["label.waves"] = "Add Waves",
    ["label.wave_1"] = "Add Wave #1",
    ["label.wave_2"] = "Add Wave #2",
    ["label.wave_3"] = "Add Wave #3",
    ["label.N"] = "N",
    ["label.S"] = "S",
    -- Texts
    ["text.stackmoron"] = "/p I hit %d stacks because I'm a complete moron.",
  },
  ["deDE"] = {
    ["unit.boss"] = "Swabbie Ski'Li",
    ["unit.noxious_nabber"] = "Noxious Nabber",
    ["unit.bilious_brute"] = "Bilious Brute", -- Missing!
    ["unit.regor_the_rancid"] = "Regor the Rancid",
    ["unit.braugh_the_bloodied"] = "Braugh der Blähbauch",
    ["unit.sawblade"] = "Sägeblatt",
    ["unit.circle_telegraph"] = "Feindselige unsichtbare Einheit für Felder (Trefferradius 1.2)",
    -- Casts
    ["cast.necrotic_lash"] = "Nekrotisches Peitschen",
    ["cast.deathwail"] = "Totenklage",
    ["cast.gravedigger"] = "Gravedigger",
    -- Alerts
    ["alert.oozing_bile"] = "STOP DAMAGE!",
    ["alert.interrupt"] = "UNTERBRECHEN!",
    -- Debuffs
    ["debuff.oozing_bile"] = "Triefende Galle",
    -- Datachron
    ["datachron.shredder_jammed"] = "Ye've jammed me shredder, ye have! Blast ye filthy bilge slanks!", -- Missing!
    -- Labels
    ["label.lines_room"] = "Raum Einteilungen",
    ["label.circle_telegraph"] = "Kreis Telegraphen",
    ["label.waves"] = "Add Waves",
    ["label.wave_1"] = "Add Wave #1",
    ["label.wave_2"] = "Add Wave #2",
    ["label.wave_3"] = "Add Wave #3",
    ["label.N"] = "N",
    ["label.S"] = "S",
    -- Texts
    ["text.stackmoron"] = "/gr Ich Vollidiot habe %d Stacks erreicht!",
  },
  ["frFR"] = {
    -- Units
    ["unit.boss"] = "Swabbie Ski'Li", --V (Verified)
    ["unit.noxious_nabber"] = "Noxious Nabber", --V
    ["unit.bilious_brute"] = "Bilious Brute", --V
    ["unit.regor_the_rancid"] = "Regor the Rancid", --V
    ["unit.braugh_the_bloodied"] = "Braugh the Bloodied",
    ["unit.sawblade"] = "Lamescie", --V
    ["unit.circle_telegraph"] = "Hostile Invisible Unit for Fields (1.2 hit radius)",
    -- Casts
    ["cast.necrotic_lash"] = "Necrotic Lash",
    ["cast.deathwail"] = "Deathwail",
    ["cast.gravedigger"] = "Gravedigger",
    -- Alerts
    ["alert.oozing_bile"] = "STOP DPS !",
    ["alert.interrupt"] = "INTERROMPS !",
    -- Debuffs
    ["debuff.oozing_bile"] = "Oozing Bile", --maybe Coup de bile
    -- Datachron
    ["datachron.shredder_jammed"] = "Z'avez bloqué mon broyeur ! Je vous déteste, sales Slanks de cale !", -- V
    -- Labels
    ["label.lines_room"] = "Ligne d'ancres",
    ["label.circle_telegraph"] = "Télégraphes Circulaire",
    ["label.waves"] = "Vague d'adds",
    ["label.wave_1"] = "Vague d'adds #1",
    ["label.wave_2"] = "Vague d'adds #2",
    ["label.wave_3"] = "Vague d'adds #3",
    ["label.N"] = "N",
    ["label.S"] = "S",
    -- Texts
    ["text.stackmoron"] = "/éq J'ai atteint %d stacks parce que je suis un crétin fini.",
  },
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  Boss{
    label = "unit.boss",
    unit{},
  }
  RoomLines{
    label = "label.lines_room",
    line{thickness = 5, color = "649932cc"}
  }
  NecroticLash{
    label = "cast.necrotic_lash",
    cast{},
    alert{},
    sound{file = "alert"},
  }
  NoxiousNabber{
    label = "unit.noxious_nabber",
    unit{},
    icon{sprite = "LUIBM_skull", size = 80, color = "ffff00ff"},
    text{color = "ffff00ff"},
  }
  BiliousBrute{
    label = "unit.bilious_brute",
    unit{},
    icon{sprite = "LUIBM_skull2", size = 80, color = "ff00ffff",},
  }
  RegorTheRancid{
    label = "unit.regor_the_rancid",
    unit{},
    cast{},
    alert{},
    sound{file = "alert"},
  }
  BraughTheBloodied{
    label = "unit.braugh_the_bloodied",
    unit{},
    cast{},
    alert{},
    sound{file = "alert"},
  }
  Sawblade{
    label = "unit.sawblade",
    line{thickness = 15, color = "ff9932cc"}
  }
  CircleTelegraph{
    label = "label.circle_telegraph",
    line{thickness = 7, color = "ffff0000"}
  }
  Ooze{
    label = "debuff.oozing_bile",
    aura{color = "ffff0000", sprite = "LUIBM_stop"},
    alert{},
    sound{file = "alert"},
  }
  Waves{
    label = "label.waves",
    timer{color = false},
    text{},
  }
end, function(_arg, _env) --luacheck: no unused args
  -- luacheck: no global


  local tTextPositions = {
    [1] = Vector3.New(-21, 598, -830), --Entrance
    [2] = Vector3.New(-21, 598, -882), --Center
    [3] = Vector3.New(-21, 598, -980), --Exit
  }
  --1,2 or 3 -- while 1 is the first set of Adds, 2 the 2nd, 3 the 3rd
  local function fDrawSpawnDistances(self, tUnit, nUpcomingAdds)
    if not tUnit or not nUpcomingAdds then return print(tUnit, nUpcomingAdds) end

    local zPos;

    if nUpcomingAdds == 1 then
      zPos = -830
    elseif nUpcomingAdds == 2 then
      zPos = -882
    elseif nUpcomingAdds == 3 then
      zPos = -920
    end

    local bDraw = zPos and true or false
    --or 0, because we still want this to throw no error, even if its unused (bDraw = false).
    local v3TargetPos = Vector3.New(-21, 598, zPos or 0)

    local function fUpdate(this, _, tBoss)
      --get the Units Position, or rather his offset to it.
      local v3Pos = Vector3.New(tBoss:GetPosition())
      if v3Pos.z < v3TargetPos.z then
        this:FireCallbacks("ReachedSpawnLocation", {tUnit = tBoss, nReachedSpawn = nUpcomingAdds})
        return
      end

      local fDistance = (v3TargetPos-v3Pos):Length()
      return ("%0.1f"):format(fDistance)
    end

    for i in ipairs{1,2,3} do
      self:RemoveText("Waves", i)
      if bDraw then
        self:Text("Waves", tTextPositions[i], "77,7", i, {fUpdate = fUpdate, tData = tUnit})
      end
    end

  end


  -- ## General Whole Fight Things ##
  UnitCreated{ strUnitName = "unit.boss", bInCombat = true, [_arg.self:GetUnit("Boss")] = _arg.Nil,
    Unit("Boss", _arg.tUnit),
    FireCallbacks("BossCreated", {tUnit = _arg.tUnit}) --this is for wave management below.
  }
  Enable{
    LineBetween("RoomLines", Vector3.New(-1, 598, -830), Vector3.New(-41, 598, -830)) % ("Entrance"),
    LineBetween("RoomLines", Vector3.New(-1, 598, -882), Vector3.New(-41, 598, -882)) % ("Center"),
    LineBetween("RoomLines", Vector3.New(-1, 598, -980), Vector3.New(-41, 598, -980)) % ("Exit"),
  }

  UnitCreated{ strUnitName = "unit.sawblade",
    Line("Sawblade", _arg.tUnit, 60),
  }
  UnitCreated{ strUnitName = "unit.circle_telegraph",
    Polygon("CircleTelegraph", _arg.tUnit, 6.7, 20),
  }

  -- ## Add Wave Management ##

  Enable{
    Timer("Waves", 15, "label.wave_1") % ("Wave:1") + {color = "c87cfc00"},
    Timer("Waves", 53, "label.wave_2") % ("Wave:2") + {color = "c8ffd700"},
    Timer("Waves", 78, "label.wave_3") % ("Wave:3") + {color = "c8ff4500"},
  }
  Callback("BossCreated", {
    Delay(5,
    {fDrawSpawnDistances, _arg.self, _arg.tUnit, 1}
  )
  })
  Callback("ReachedSpawnLocation", {
    {_env.print, "Reached:", _arg.nReachedSpawn},
    {fDrawSpawnDistances, _arg.self, _arg.tUnit, _arg.nReachedSpawn+1},
  })
  Datachron{ strMessage = "datachron.shredder_jammed",
    Timer("Waves", 15, "label.wave_1") % ("Wave:1") + {color = "c87cfc00"},
    Timer("Waves", 53, "label.wave_2") % ("Wave:2") + {color = "c8ffd700"},
    Timer("Waves", 78, "label.wave_3") % ("Wave:3") + {color = "c8ff4500"},
    {fDrawSpawnDistances, _arg.self, _arg.self:GetUnit("Boss"), 1},
  }



  -- ## Noxious Nabbers (Special Adds) ##
  local function fCardinal(tUnit)
    local tPos = tUnit:GetPosition()
    return tPos.z < -882 and "label.N" or "label.S"
  end
  UnitCreated{ strUnitName = "unit.noxious_nabber",
    Unit("NoxiousNabber", _arg.tUnit) % (_arg.nUnitId) + {strMark = _arg(fCardinal)(_arg.tUnit)},
    Icon("NoxiousNabber", _arg.tUnit) % (_arg.nUnitId) + {bTop = true},
    TimerText("NoxiousNabber", _arg.tUnit, 12) % (_arg.nUnitId),
  }
  CastStart{ strCastName = "cast.necrotic_lash", [_arg.self:InRange(_arg.tUnit, 30)] = true,
    Alert("NecroticLash", "alert.interrupt") % (_arg.nUnitId),
    Sound("NecroticLash"),
    Cast("NecroticLash", _arg.tCast),
  }
  HealthReached{ nHealthReached = 0, strUnitName = "unit.noxious_nabber",
    -Unit("NoxiousNabber") % (_arg.nUnitId),
  }

  -- ## Midphase Mini-Bosses (1) ##
  UnitCreated{ strUnitName = "unit.regor_the_rancid",
    Unit("RegorTheRancid", _arg.tUnit),
  }
  HealthReached{ nHealthReached = 0, strUnitName = "unit.regor_the_rancid",
    -Unit("RegorTheRancid"),
  }
  CastStart{ strCastName = {"cast.deathwail", "cast.gravedigger"}, strUnitName = "unit.regor_the_rancid",
    Alert("RegorTheRancid", "alert.interrupt"),
    Sound("RegorTheRancid"),
    Cast("RegorTheRancid", _arg.tCast),
  }

  -- ## Midphase Mini-Bosses (2) ##
  UnitCreated{ strUnitName = "unit.braugh_the_bloodied",
    Unit("BraughTheBloodied", _arg.tUnit),
  }
  HealthReached{ nHealthReached = 0, strUnitName = "unit.braugh_the_bloodied",
    -Unit("BraughTheBloodied"),
  }
  CastStart{ strCastName = {"cast.deathwail", "cast.gravedigger"}, strUnitName = "unit.braugh_the_bloodied",
    Alert("BraughTheBloodied", "alert.interrupt"),
    Sound("BraughTheBloodied"),
    Cast("BraughTheBloodied", _arg.tCast),
  }

  -- ## 2nd Phase Miniboss ##
  UnitCreated{ strUnitName = "unit.bilious_brute",
    Unit("BiliousBrute", _arg.tUnit),
    Icon("BiliousBrute", _arg.tUnit) + {bTop = true},
  }
  HealthReached{ nHealthReached = 0, strUnitName = "unit.bilious_brute",
    -Unit("BiliousBrute"),
  }
  local OOZING = 84321
  function fGreaterEqual(nVal, nThreshold) return nVal >= nThreshold end --i need a better way to do this......
  BuffUpdated{ nSpellId = OOZING, [_arg.tUnit:IsThePlayer()] = true, [_arg(fGreaterEqual)(_arg.nStack, 8)] = true,
    Aura("Ooze", _arg.nDuration),
    Sound("Ooze"),
    Alert("Ooze", "alert.oozing_bile"),
  }
  BuffUpdated{ nSpellId = OOZING, [_arg.tUnit:IsThePlayer()] = true, [_arg(fGreaterEqual)(_arg.nStack, 10)] = true,
    {_env.ChatSystemLib.Command, _arg.self.L["text.stackmoron"]:format(_arg.nStack)}
  }
  BuffRemoved{ nSpellId = OOZING, [_arg.tUnit:IsThePlayer()] = true,
    -Aura("Ooze"),
  }
end)