local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")
local Encounter = tAddon.Encounter


Encounter.new("TEST_HOUSE", {
  instance = "TEST_HOUSE",
  groupName = "GROUP",
  displayName = "BOSS",
  tTrigger = {
    tZones = {
      [1] = {
        continentId = 36,
        parentZoneId = 0,
        mapId = 60,
      },
    },
  },
},{
  ["enUS"] = {
    ["unit.boss"] = "???",
  },
  ["deDE"] = {
    ["unit.boss"] = "???",
  },
  ["frFR"] = {},
}, function(tConfig) --luacheck: no unused args
  -- luacheck: no global
  Boss{
    label = "unit.boss",
    unit{},
  }

  Test{
    text{font="Pixel"},
    line{},
    icon{sprite = "LUIBM_stop"},
  }

end, function(_arg, _env, _var) --luacheck: no unused args
  -- luacheck: no global

  UnitCreated{ strUnitName = "unit.boss", bInCombat = true, [_arg.self:HasUnit("Boss")] = false,
    Unit("Boss", _arg.tUnit),
  }
  local nZ = math.sqrt(0.75)
  local tPlayersPillarPos = {x = -0.5,   y = 0, z = -nZ}--   ["NW"] = {x = 131.5,  y = -111.5, z = -555.4},


--   local v3Center = Vector3.New(1268.13, -800.51, 877.117)
--   local Aug = {
--     [1] = Vector3.New(1268.16, -800.51, 830.32),
--     [2] = Vector3.New(1227.63, -800.51, 900.47),
--     [3] = Vector3.New(1308.60, -800.51, 900.56)
--   }


--   local NewCorrds = {
--     ["Offset.L"] = Vector3.New(11.21, 0, 6.68),
--     ["Offset.R"] = Vector3.New(-10.63, 0, 6.87),
--     ["Offset.F"] = Vector3.New(0, 0, -6.48),
--     ["Offset.B"] = Vector3.New(0, 0, 13.01),

--     ["Rotation.L"] = -90,
--     ["Rotation.R"] =  90,
--     ["Rotation.BL"] = -30,
--     ["Rotation.BR"] = 30,
--   }

--   -- Thanks to KuronaSilversky <3
--   local Coords = {
--     [1] = {
--       [1] = Vector3.New(1302.87, -800.60, 837.23),
--       [2] = Vector3.New(1303.22, -800.60, 823.23),
--       [3] = Vector3.New(1291.21, -800.60, 803.33),
--       [4] = Vector3.New(1280.26, -800.60, 796.33),
--       [5] = Vector3.New(1256.22, -800.60, 796.51),
--       [6] = Vector3.New(1244.71, -800.60, 802.90),
--       [7] = Vector3.New(1232.53, -800.60, 823.87),
--       [8] = Vector3.New(1232.62, -800.60, 836.80),
--       [9] = Vector3.New(1278.79, -800.60, 823.45),
--       [10]= Vector3.New(1268.00, -800.60, 817.31),
--       [11]= Vector3.New(1256.95, -800.60, 823.64),

--       -- -- B = "Back" (aka Back-Left)
--       -- --_1 is always the one closer to the front.
--       -- ["Inner.L"] = Vector3.New(1256.95, -800.60, 823.64), --11
--       -- ["Inner.R"] = Vector3.New(1278.79, -800.60, 823.45), --9
--       -- ["Inner.F"] = Vector3.New(1267.74, -800.60, 836.80),
--       -- ["Inner.B"] = Vector3.New(1268.00, -800.60, 817.31), --10



--       -- tVectorOffsets = {},
--       -- nRotation = 20,

--       -- ["Outer.L_1"] = Vector3.New(1232.62, -800.60, 836.80),--8
--       -- ["Outer.L_2"] = Vector3.New(1232.53, -800.60, 823.87),--7
--       -- ["Outer.R_1"] = Vector3.New(1302.87, -800.60, 837.23), --1
--       -- ["Outer.R_2"] = Vector3.New(1303.22, -800.60, 823.23), --2
--       -- ["Outer.BL_1"] = Vector3.New(1244.71, -800.60, 802.90),--6
--       -- ["Outer.BL_2"] = Vector3.New(1256.22, -800.60, 796.51), --5
--       -- ["Outer.BR_1"] = Vector3.New(1291.21, -800.60, 803.33), --3
--       -- ["Outer.BR_2"] = Vector3.New(1280.26, -800.60, 796.33), --4
--     },
--     [2] = {
--       [1] = Vector3.New(1215.35, -800.60,  866.08),
--       [2] = Vector3.New(1204.24, -800.60,  872.99),
--       [3] = Vector3.New(1191.91, -800.60,  893.94),
--       [4] = Vector3.New(1191.86, -800.60,  906.97),
--       [5] = Vector3.New(1204.29, -800.60,  927.76),
--       [6] = Vector3.New(1215.66, -800.60,  934.04),
--       [7] = Vector3.New(1239.53, -800.60, 933.933),
--       [8] = Vector3.New(1250.87, -800.60,  927.76),
--       [9] = Vector3.New(1216.43, -800.60,  894.04),
--       [10]= Vector3.New(1216.33, -800.60,  906.61),
--       [11]= Vector3.New(1227.33, -800.60,  912.87),
--     },
--     [3] = {
--       [1] = Vector3.New(1285.45, -800.60, 927.58),
--       [2] = Vector3.New(1296.25, -800.60, 934.77),
--       [3] = Vector3.New(1320.93, -800.60, 935.26),
--       [4] = Vector3.New(1332.09, -800.60, 928.45),
--       [5] = Vector3.New(1344.32, -800.60, 907.19),
--       [6] = Vector3.New(1344.04, -800.60, 891.89),
--       [7] = Vector3.New(1331.96, -800.60, 873.30),
--       [8] = Vector3.New(1321.60, -800.60, 866.36),
--       [9] = Vector3.New(1308.58, -800.60, 913.53),
--       [10]= Vector3.New(1319.61, -800.60, 907.28),
--       [11]= Vector3.New(1319.62, -800.60, 894.53),
--     }
--   }
--   local Xs = {
--     [2] = Vector3.New(1238.03, -800.51, 894.45),
-- [1] = Vector3.New(1268.17, -800.51, 842.32),
-- [3] = Vector3.New(1298.20, -800.51, 894.57),
--   }
--   Enable{function(self)
--     local v3PlayerPos = Vector3.New(GameLib.GetPlayerUnit():GetPosition())
--     local v3Off = v3Center-v3PlayerPos

--     for idxAugmentor = 1, 3, 1 do
--       local v3Augmentor = Aug[idxAugmentor]
--       self:Text("Test", v3Augmentor-v3Off, "Aug"..idxAugmentor, idxAugmentor)
--       local tCoords = Coords[idxAugmentor]

--       self:Text("Test", Xs[idxAugmentor]-v3Off,  "X"..idxAugmentor, "X"..idxAugmentor)

--       for idx, v3Pos in ipairs(tCoords) do
--         self:Text("Test", v3Pos-v3Off, idx, idx.." "..idxAugmentor)
--       end
--     end




--     for idxAugmentor = 1, 3, 1 do
--       local v3Augmentor = Aug[idxAugmentor]
--       local v3Facing = (v3Augmentor-v3Center):Normal()
--       local v3Pos = v3Augmentor-v3Off

--       self:Line("Test", v3Pos, 35, idxAugmentor..":F|L", {
--         tVectorFacing = v3Facing,
--         tVectorOffsets = NewCorrds["Offset.F"],
--         nRotation = NewCorrds["Rotation.L"]
--       })
--       self:Line("Test", v3Pos, 35, idxAugmentor..":F|R", {
--         tVectorFacing = v3Facing,
--         tVectorOffsets = NewCorrds["Offset.F"],
--         nRotation = NewCorrds["Rotation.R"]
--       })

--       self:Line("Test", v3Pos, 25, idxAugmentor..":L|L", {
--         tVectorFacing = v3Facing,
--         tVectorOffsets = NewCorrds["Offset.L"],
--         nRotation = NewCorrds["Rotation.L"]
--       })
--       self:Line("Test", v3Pos, 25, idxAugmentor..":R|R", {
--         tVectorFacing = v3Facing,
--         tVectorOffsets = NewCorrds["Offset.R"],
--         nRotation = NewCorrds["Rotation.R"]
--       })

--       self:Line("Test", v3Pos, 25, idxAugmentor..":L|BL", {
--         tVectorFacing = v3Facing,
--         tVectorOffsets = NewCorrds["Offset.L"],
--         nRotation = NewCorrds["Rotation.BL"]
--       })
--       self:Line("Test", v3Pos, 25, idxAugmentor..":R|BR", {
--         tVectorFacing = v3Facing,
--         tVectorOffsets = NewCorrds["Offset.R"],
--         nRotation = NewCorrds["Rotation.BR"]
--       })

--       self:Line("Test", v3Pos, 25, idxAugmentor..":B|BL", {
--         tVectorFacing = v3Facing,
--         tVectorOffsets = NewCorrds["Offset.B"],
--         nRotation = NewCorrds["Rotation.BL"]
--       })
--       self:Line("Test", v3Pos, 25, idxAugmentor..":B|BR", {
--         tVectorFacing = v3Facing,
--         tVectorOffsets = NewCorrds["Offset.B"],
--         nRotation = NewCorrds["Rotation.BR"]
--       })
--       self:Icon("Test", v3Pos - (v3Facing*12), idxAugmentor)


--     -- ["Offset.L"] = Vector3.New(-11.21, 0, -6.68),
--     -- ["Offset.R"] = Vector3.New(10.63, 0, -6.87),
--     -- ["Offset.F"] = Vector3.New(-0.42, 0, 6.48),
--     -- ["Offset.B"] = Vector3.New(-0.16, 0, 13.01),

--     -- ["Rotation.L"] = -90,
--     -- ["Rotation.R"] =  90,
--     -- ["Rotation.BL"] = -30,
--     -- ["Rotation.BR"] = 30,

--     end

--   end}

  local tConstants = {
    ["Offset.L"] = Vector3.New(11.21, 0, 6.68),
    ["Offset.R"] = Vector3.New(-10.63, 0, 6.87),
    ["Offset.F"] = Vector3.New(0, 0, -6.48),
    ["Offset.B"] = Vector3.New(0, 0, 13.01),

    ["Rotation.L"] = -90,
    ["Rotation.R"] =  90,
    ["Rotation.BL"] = -30,
    ["Rotation.BR"] = 30,

    ["Distance.Safespot"] = 12,
  }
  local v3Center = Vector3.New(1268.13, -800.51, 877.117)
  local function fDrawBossMarkers(self, tUnit)
    local v3Pos = Vector3.New(tUnit:GetPosition())
    local v3Facing = (v3Pos-v3Center):Normal()

    self:Line("Test", v3Pos, 35, "Front towards Left", {
      tVectorFacing = v3Facing,
      tVectorOffsets = tConstants["Offset.F"],
      nRotation = tConstants["Rotation.L"],
    })
    self:Line("Test", v3Pos, 35, "Front towards Right", {
      tVectorFacing = v3Facing,
      tVectorOffsets = tConstants["Offset.F"],
      nRotation = tConstants["Rotation.R"]
    })

    self:Line("Test", v3Pos, 25, "Left towards Left", {
      tVectorFacing = v3Facing,
      tVectorOffsets = tConstants["Offset.L"],
      nRotation = tConstants["Rotation.L"]
    })
    self:Line("Test", v3Pos, 25, "Right towards Right", {
      tVectorFacing = v3Facing,
      tVectorOffsets = tConstants["Offset.R"],
      nRotation = tConstants["Rotation.R"]
    })

    self:Line("Test", v3Pos, 25, "Left towards Back-Left", {
      tVectorFacing = v3Facing,
      tVectorOffsets = tConstants["Offset.L"],
      nRotation = tConstants["Rotation.BL"]
    })
    self:Line("Test", v3Pos, 25, "Right towards Back-Right", {
      tVectorFacing = v3Facing,
      tVectorOffsets = tConstants["Offset.R"],
      nRotation = tConstants["Rotation.BR"]
    })

    self:Line("Test", v3Pos, 25, "Back towards Back-Left", {
      tVectorFacing = v3Facing,
      tVectorOffsets = tConstants["Offset.B"],
      nRotation = tConstants["Rotation.BL"]
    })
    self:Line("Test", v3Pos, 25, "Back towards Back-Right", {
      tVectorFacing = v3Facing,
      tVectorOffsets = tConstants["Offset.B"],
      nRotation = tConstants["Rotation.BR"]
    })
    self:Icon("Test", v3Pos - (v3Facing*tConstants["Distance.Safespot"]), "Safespot")
  end

  Enable{ [_env.GameLib.GetTargetUnit()] = {"~=", _arg(nil)},
    function()
      v3Center = Vector3.New(GameLib.GetPlayerUnit():GetPosition())
    end,
    {fDrawBossMarkers, _arg.self, _env.GameLib.GetTargetUnit()}
  }



  -- Enable{
  --   LineBetween("Test", _env.Vector3.New(_env.GameLib.GetPlayerUnit():GetPosition()), nil)+ {nOffset = 3},
  -- }

  -- Enable{
  --   If{

  --     -- Line("Test", _env.GameLib.GetPlayerUnit(), 20)
  --     Line("Test", _env.GameLib.GetPlayerUnit(), 10) + {nOffset = 2, tVectorFacing = tPlayersPillarPos}
  --   }
  -- }


  UnitCreated{Text("Test", _arg.tUnit, _arg.strUnitName) % (_arg.nUnitId) + {font="CRB_Pixel"}}
  CastStart{_env.print}
end)