local Apollo = require "Apollo"
local tAddon = Apollo.GetAddon("MischhBossModules")

local Localizer = {}
tAddon.Localizer = Localizer
tAddon:Link(Localizer)


local tKeyMeta = {__index = function(_,k) return k end}

function Localizer:Localize(tLocales) --luacheck: no unused args (self)
  local tUS = tLocales["enUS"] or {}
  local tDE = tLocales["deDE"] or {}
  local tFR = tLocales["frFR"] or {}

  local tRefUS = {__index = tUS}

  setmetatable(tUS, tKeyMeta) --return the key itself, if not defined.
  setmetatable(tDE, tRefUS) --lookup in tUS, if not defined.
  setmetatable(tFR, tRefUS) --lookup in tUS, if not defined.


  local strCancel = Apollo.GetString(1)
  if strCancel == "Abbrechen" then --deDE
    return tDE
  elseif strCancel == "Annuler" then --frFR
    return tFR
  else --enUS
    return tUS
  end
end
setmetatable(Localizer, {__call = Localizer.Localize})


--[[ this is designed to be used like: ]]

--[[
  local L = tAddon.Localizer{
    ["enUS"] = {
      ["to_be_localized"] = "English Localization",
    },
    ["deDE"] = {
      ["to_be_localized"] = "Deutsche Lokalisierung",
    },
    ["frFR"] = {
      ["to_be_localized"] = nil, --unknown. --upon request he will use enUS defenition
    },
  }
]]

