local Apollo = require "Apollo"

-----------------------------------------------------------------------------------------------
-- Module Definition
-----------------------------------------------------------------------------------------------
local tAddon = Apollo.GetAddon("MischhBossModules")

local Utils = {}
tAddon.Utils = Utils

-----------------------------------------------------------------------------------------------
-- Static Variables
-----------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------
-- Module
-----------------------------------------------------------------------------------------------

--currently only supports max 5 args (because i did not yet find a good other solution)
function Utils.CreateCallback(nArg, func, handler, ...)
  if nArg == -1 then -- -1 = infinite '...' should be empty
    if type(func) == "function" then
      return func
    elseif type(handler) == "table" then
      return function (...) return handler[func](handler, ...) end
    else
      error("Could not create callback, need either a function, or a key-table pair.")
    end
  elseif not nArg or nArg == 0 then
    local t = {...}
    if type(func) == "function" then
      return function() return func(unpack(t)) end
    elseif type(handler) == "table" then
      return function() return handler[func](handler, unpack(t)) end
    else
      error("Could not create callback, need either a function, or a key-table pair.")
    end
  elseif nArg == 1 then
    local t = {...}
    if type(func) == "function" then
      return function(arg1) return func(arg1, unpack(t)) end
    elseif type(handler) == "table" then
      return function(arg1) return handler[func](handler, arg1, unpack(t)) end
    else
      error("Could not create callback, need either a function, or a key-table pair.")
    end
  elseif nArg == 2 then
    local t = {...}
    if type(func) == "function" then
      return function(arg1, arg2) return func(arg1, arg2, unpack(t)) end
    elseif type(handler) == "table" then
      return function(arg1, arg2) return handler[func](handler, arg1, arg2, unpack(t)) end
    else
      error("Could not create callback, need either a function, or a key-table pair.")
    end
  elseif nArg == 3 then
    local t = {...}
    if type(func) == "function" then
      return function(arg1, arg2, arg3) return func(arg1, arg2, arg3, unpack(t)) end
    elseif type(handler) == "table" then
      return function(arg1, arg2, arg3) return handler[func](handler, arg1, arg2, arg3, unpack(t)) end
    else
      error("Could not create callback, need either a function, or a key-table pair.")
    end
  elseif nArg == 4 then
      local t = {...}
      if type(func) == "function" then
        return function(arg1, arg2, arg3, arg4) return func(arg1, arg2, arg3, arg4, unpack(t)) end
      elseif type(handler) == "table" then
        return function(arg1, arg2, arg3, arg4) return handler[func](handler, arg1, arg2, arg3, arg4, unpack(t)) end
      else
        error("Could not create callback, need either a function, or a key-table pair.")
      end
  elseif nArg == 5 then
      local t = {...}
      if type(func) == "function" then
        return function(arg1, arg2, arg3, arg4, arg5) return func(arg1, arg2, arg3, arg4, arg5, unpack(t)) end
      elseif type(handler) == "table" then
        return function(arg1, arg2, arg3, arg4, arg5) return handler[func](handler, arg1, arg2, arg3, arg4, arg5,
          unpack(t)) end
      else
        error("Could not create callback, need either a function, or a key-table pair.")
      end
  else
    error("Not Supported")
  end
end

function Utils.DeepCopy(src, tar, lookup)
  if type(src) ~= "table" then return src end
  if not tar then tar = {} end
  if not lookup then lookup = {} end

  if lookup[src] then return lookup[src] end

  lookup[src] = tar

  for idx, val in pairs(src) do
    tar[Utils.DeepCopy(idx, nil, lookup)] = Utils.DeepCopy(val, nil, lookup)
  end

  return tar
end

local selfMeta = { __index = function(_,k)
		return k
	end
}
function Utils.Localize(eng, ger, fre)
	local strCancel = Apollo.GetString(1)

	if type(eng) == "table" then
		setmetatable(eng, selfMeta)

		local m = {__index = function(_,k)
			return eng[k]
		end}
		setmetatable(ger, m)
		setmetatable(fre, m)
	end

	-- German
	if strCancel == "Abbrechen" then
		return ger or eng
	end

	-- French
	if strCancel == "Annuler" then
		return fre or eng
	end

	return eng
end

function print(...) --luacheck: ignore
  local tbl = {...}
  local num = select("#", ...)
  local str = ""
  for i = 1, num, 1 do
  str = str..tostring(tbl[i])..", "
  end
  Print(str:sub(1,-3)) --luacheck: ignore
end
